#!/usr/bin/env python3
# encoding: utf-8

#  PostmasterGS Stamp Album Page Generator for Scribus v1.5.5 (20220704)
#  GermanStamps.net -- http://www.germanstamps.net
#
#  Copyright ©2015-2022. GermanStamps.net. All Rights Reserved. License to use, copy, modify,
#  and distribute this software and its documentation for educational, personal, and not-
#  for-profit purposes, without fee and without a signed licensing agreement, is hereby 
#  granted, provided that the above copyright notice and this paragraph appear in all copies, 
#  modifications, and distributions.  Use for commercial or resale purposes is strictly prohibited.

from __future__ import division
import scribus
from decimal import *

from random import randint

global origUnit
origUnit = scribus.getUnit()
	
import sys
strFileDir = sys.path[0]

from sys import platform as _platform
if _platform == "linux" or _platform == "linux2" or _platform == "darwin":
	strFileDirM = "/"
else:
	strFileDirM = "\\"

strFileDir = strFileDir + strFileDirM

global strFileS
strFileS = strFileDir + "PMGSSAPG_scribus_v1_5_5_settings.txt"
global strFileB
strFileB = strFileDir + "PMGSSAPG_scribus_v1_5_5_batch.txt"

'''Set global value to convert from millimeters to points'''
global decConversionValue
decConversionValue = float(2.83464657)

global intStartPage
intStartPage = scribus.currentPage()

def funcImportSettings():
   
	'''Load the text file'''
	fileHandleS = open(strFileS, 'r')
	fileContentsS = fileHandleS.readlines()
	fileHandleS.close()
	fileContentsS = [item.rstrip('\r\n') for item in fileContentsS]

	'''Strip out the field identifiers to leave just the value, then assign to variables'''
	global strStyle
	strStyle = fileContentsS[0]
	strStyleI = strStyle.find("|")+1
	strStyleL = len(strStyle)
	strStyle = strStyle[strStyleI:strStyleL]
	global strSingleSet
	strSingleSet = fileContentsS[1]
	strSingleSetI = strSingleSet.find("|")+1
	strSingleSetL = len(strSingleSet)
	strSingleSet = strSingleSet[strSingleSetI:strSingleSetL]
	global strSetMultiSpacing
	strSetMultiSpacing = fileContentsS[2]
	strSetMultiSpacingI = strSetMultiSpacing.find("|")+1
	strSetMultiSpacingL = len(strSetMultiSpacing)
	strSetMultiSpacing = strSetMultiSpacing[strSetMultiSpacingI:strSetMultiSpacingL]
	global strSetOrientation
	strSetOrientation = fileContentsS[3]
	strSetOrientationI = strSetOrientation.find("|")+1
	strSetOrientationL = len(strSetOrientation)
	strSetOrientation = strSetOrientation[strSetOrientationI:strSetOrientationL]
	global strSetSpacing
	strSetSpacing = fileContentsS[4]
	strSetSpacingI = strSetSpacing.find("|")+1
	strSetSpacingL = len(strSetSpacing)
	strSetSpacing = (round(float(strSetSpacing[strSetSpacingI:strSetSpacingL]),4))
	strSetSpacing = strSetSpacing * decConversionValue
	global strSetFrame
	strSetFrame = fileContentsS[5]
	strSetFrameI = strSetFrame.find("|")+1
	strSetFrameL = len(strSetFrame)
	strSetFrame = strSetFrame[strSetFrameI:strSetFrameL]
	global strSetFrameTextAlign
	strSetFrameTextAlign = fileContentsS[6]
	strSetFrameTextAlignI = strSetFrameTextAlign.find("|")+1
	strSetFrameTextAlignL = len(strSetFrameTextAlign)
	strSetFrameTextAlign = strSetFrameTextAlign[strSetFrameTextAlignI:strSetFrameTextAlignL]
	global strSetHFrameAlign
	strSetHFrameAlign = fileContentsS[7]
	strSetHFrameAlignI = strSetHFrameAlign.find("|")+1
	strSetHFrameAlignL = len(strSetHFrameAlign)
	strSetHFrameAlign = strSetHFrameAlign[strSetHFrameAlignI:strSetHFrameAlignL]
	global strSetVFrameAlign
	strSetVFrameAlign = fileContentsS[8]
	strSetVFrameAlignI = strSetVFrameAlign.find("|")+1
	strSetVFrameAlignL = len(strSetVFrameAlign)
	strSetVFrameAlign = strSetVFrameAlign[strSetVFrameAlignI:strSetVFrameAlignL]
	global strFrameStyle
	strFrameStyle = fileContentsS[9]
	strFrameStyleI = strFrameStyle.find("|")+1
	strFrameStyleL = len(strFrameStyle)
	strFrameStyle = strFrameStyle[strFrameStyleI:strFrameStyleL]
	global strFrameDouble
	strFrameDouble = fileContentsS[10]
	strFrameDoubleI = strFrameDouble.find("|")+1
	strFrameDoubleL = len(strFrameDouble)
	strFrameDouble = strFrameDouble[strFrameDoubleI:strFrameDoubleL]
	global strFrameSpacing
	strFrameSpacing = fileContentsS[11]
	strFrameSpacingI = strFrameSpacing.find("|")+1
	strFrameSpacingL = len(strFrameSpacing)
	strFrameSpacing = (round(float(strFrameSpacing[strFrameSpacingI:strFrameSpacingL]),4))
	strFrameSpacing = strFrameSpacing * decConversionValue
	global strFrameThicknessOuter
	strFrameThicknessOuter = fileContentsS[12]
	strFrameThicknessOuterI = strFrameThicknessOuter.find("|")+1
	strFrameThicknessOuterL = len(strFrameThicknessOuter)
	strFrameThicknessOuter = (round(float(strFrameThicknessOuter[strFrameThicknessOuterI:strFrameThicknessOuterL]),4))
	strFrameThicknessOuter = strFrameThicknessOuter * decConversionValue
	global strFrameThicknessInner
	strFrameThicknessInner = fileContentsS[13]
	strFrameThicknessInnerI = strFrameThicknessInner.find("|")+1
	strFrameThicknessInnerL = len(strFrameThicknessInner)
	strFrameThicknessInner = (round(float(strFrameThicknessInner[strFrameThicknessInnerI:strFrameThicknessInnerL]),4))
	strFrameThicknessInner = strFrameThicknessInner * decConversionValue
	global strPaddingTop
	strPaddingTop = fileContentsS[14]
	strPaddingTopI = strPaddingTop.find("|")+1
	strPaddingTopL = len(strPaddingTop)
	strPaddingTop = (round(float(strPaddingTop[strPaddingTopI:strPaddingTopL]),4))
	strPaddingTop = strPaddingTop * decConversionValue
	global strPaddingBottom
	strPaddingBottom = fileContentsS[15]
	strPaddingBottomI = strPaddingBottom.find("|")+1
	strPaddingBottomL = len(strPaddingBottom)
	strPaddingBottom = (round(float(strPaddingBottom[strPaddingBottomI:strPaddingBottomL]),4))
	strPaddingBottom = strPaddingBottom * decConversionValue
	global strPaddingLeft
	strPaddingLeft = fileContentsS[16]
	strPaddingLeftI = strPaddingLeft.find("|")+1
	strPaddingLeftL = len(strPaddingLeft)
	strPaddingLeft = (round(float(strPaddingLeft[strPaddingLeftI:strPaddingLeftL]),4))
	strPaddingLeft = strPaddingLeft * decConversionValue
	global strPaddingRight
	strPaddingRight = fileContentsS[17]
	strPaddingRightI = strPaddingRight.find("|")+1
	strPaddingRightL = len(strPaddingRight)
	strPaddingRight = (round(float(strPaddingRight[strPaddingRightI:strPaddingRightL]),4))
	strPaddingRight = strPaddingRight * decConversionValue
	global strMarginTop
	strMarginTop = fileContentsS[18]
	strMarginTopI = strMarginTop.find("|")+1
	strMarginTopL = len(strMarginTop)
	strMarginTop = (round(float(strMarginTop[strMarginTopI:strMarginTopL]),4))
	strMarginTop = strMarginTop * decConversionValue
	global strMarginBottom
	strMarginBottom = fileContentsS[19]
	strMarginBottomI = strMarginBottom.find("|")+1
	strMarginBottomL = len(strMarginBottom)
	strMarginBottom = (round(float(strMarginBottom[strMarginBottomI:strMarginBottomL]),4))
	strMarginBottom = strMarginBottom * decConversionValue
	global strMarginLeft
	strMarginLeft = fileContentsS[20]
	strMarginLeftI = strMarginLeft.find("|")+1
	strMarginLeftL = len(strMarginLeft)
	strMarginLeft = (round(float(strMarginLeft[strMarginLeftI:strMarginLeftL]),4))
	strMarginLeft = strMarginLeft * decConversionValue
	global strMarginRight
	strMarginRight = fileContentsS[21]
	strMarginRightI = strMarginRight.find("|")+1
	strMarginRightL = len(strMarginRight)
	strMarginRight = (round(float(strMarginRight[strMarginRightI:strMarginRightL]),4))
	strMarginRight = strMarginRight * decConversionValue
	global strVerticalSpacing
	strVerticalSpacing = fileContentsS[22]
	strVerticalSpacingI = strVerticalSpacing.find("|")+1
	strVerticalSpacingL = len(strVerticalSpacing)
	strVerticalSpacing = (round(float(strVerticalSpacing[strVerticalSpacingI:strVerticalSpacingL]),4))
	strVerticalSpacing = strVerticalSpacing * decConversionValue
	global strOISpacing
	strOISpacing = fileContentsS[23]
	strOISpacingI = strOISpacing.find("|")+1
	strOISpacingL = len(strOISpacing)
	strOISpacing = (round(float(strOISpacing[strOISpacingI:strOISpacingL]),4))
	strOISpacing = strOISpacing * decConversionValue
	global strTitleInclude
	strTitleInclude = fileContentsS[24]
	strTitleIncludeI = strTitleInclude.find("|")+1
	strTitleIncludeL = len(strTitleInclude)
	strTitleInclude = strTitleInclude[strTitleIncludeI:strTitleIncludeL]
	global strTitleIncludeP
	strTitleIncludeP = strTitleInclude
	global strTitleFont
	strTitleFont = fileContentsS[25]
	strTitleFontI = strTitleFont.find("|")+1
	strTitleFontL = len(strTitleFont)
	strTitleFont = strTitleFont[strTitleFontI:strTitleFontL]
	global strTitleFontSize
	strTitleFontSize = fileContentsS[26]
	strTitleFontSizeI = strTitleFontSize.find("|")+1
	strTitleFontSizeL = len(strTitleFontSize)
	strTitleFontSize = strTitleFontSize[strTitleFontSizeI:strTitleFontSizeL]
	global strTitleFontSpacing
	strTitleFontSpacing = fileContentsS[27]
	strTitleFontSpacingI = strTitleFontSpacing.find("|")+1
	strTitleFontSpacingL = len(strTitleFontSpacing)
	strTitleFontSpacing = strTitleFontSpacing[strTitleFontSpacingI:strTitleFontSpacingL]
	global strTitleRatio
	strTitleRatio = fileContentsS[28]
	strTitleRatioI = strTitleRatio.find("|")+1
	strTitleRatioL = len(strTitleRatio)
	strTitleRatio = (round(float(strTitleRatio[strTitleRatioI:strTitleRatioL]),4))
	global strTitleTextAlign
	strTitleTextAlign = fileContentsS[29]
	strTitleTextAlignI = strTitleTextAlign.find("|")+1
	strTitleTextAlignL = len(strTitleTextAlign)
	strTitleTextAlign = strTitleTextAlign[strTitleTextAlignI:strTitleTextAlignL]
	global strTitleStyle
	strTitleStyle = fileContentsS[30]
	strTitleStyleI = strTitleStyle.find("|")+1
	strTitleStyleL = len(strTitleStyle)
	strTitleStyle = strTitleStyle[strTitleStyleI:strTitleStyleL] 
	global strSetTitle
	strSetTitle = fileContentsS[31]
	strSetTitleI = strSetTitle.find("|")+1
	strSetTitleL = len(strSetTitle)
	strSetTitle = strSetTitle[strSetTitleI:strSetTitleL] 
	global strTitleHyphen
	strTitleHyphen = fileContentsS[32]
	strTitleHyphenI = strTitleHyphen.find("|")+1
	strTitleHyphenL = len(strTitleHyphen)
	strTitleHyphen = strTitleHyphen[strTitleHyphenI:strTitleHyphenL] 
	global strDateInclude
	strDateInclude = fileContentsS[33]
	strDateIncludeI = strDateInclude.find("|")+1
	strDateIncludeL = len(strDateInclude)
	strDateInclude = strDateInclude[strDateIncludeI:strDateIncludeL]
	global strDateIncludeP
	strDateIncludeP = strDateInclude
	global strDateFont
	strDateFont = fileContentsS[34]
	strDateFontI = strDateFont.find("|")+1
	strDateFontL = len(strDateFont)
	strDateFont = strDateFont[strDateFontI:strDateFontL]
	global strDateFontSize
	strDateFontSize = fileContentsS[35]
	strDateFontSizeI = strDateFontSize.find("|")+1
	strDateFontSizeL = len(strDateFontSize)
	strDateFontSize = strDateFontSize[strDateFontSizeI:strDateFontSizeL]
	global strDateFontSpacing
	strDateFontSpacing = fileContentsS[36]
	strDateFontSpacingI = strDateFontSpacing.find("|")+1
	strDateFontSpacingL = len(strDateFontSpacing)
	strDateFontSpacing = strDateFontSpacing[strDateFontSpacingI:strDateFontSpacingL]
	global strDateRatio
	strDateRatio = fileContentsS[37]
	strDateRatioI = strDateRatio.find("|")+1
	strDateRatioL = len(strDateRatio)
	strDateRatio = (round(float(strDateRatio[strDateRatioI:strDateRatioL]),4))
	global strDateTextAlign
	strDateTextAlign = fileContentsS[38]
	strDateTextAlignI = strDateTextAlign.find("|")+1
	strDateTextAlignL = len(strDateTextAlign)
	strDateTextAlign = strDateTextAlign[strDateTextAlignI:strDateTextAlignL]
	global strDateStyle
	strDateStyle = fileContentsS[39]
	strDateStyleI = strDateStyle.find("|")+1
	strDateStyleL = len(strDateStyle)
	strDateStyle = strDateStyle[strDateStyleI:strDateStyleL]
	global strSetDate
	strSetDate = fileContentsS[40]
	strSetDateI = strSetDate.find("|")+1
	strSetDateL = len(strSetDate)
	strSetDate = strSetDate[strSetDateI:strSetDateL] 
	global strDateHyphen
	strDateHyphen = fileContentsS[41]
	strDateHyphenI = strDateHyphen.find("|")+1
	strDateHyphenL = len(strDateHyphen)
	strDateHyphen = strDateHyphen[strDateHyphenI:strDateHyphenL] 
	global strKatalogInclude
	strKatalogInclude = fileContentsS[42]
	strKatalogIncludeI = strKatalogInclude.find("|")+1
	strKatalogIncludeL = len(strKatalogInclude)
	strKatalogInclude = strKatalogInclude[strKatalogIncludeI:strKatalogIncludeL]
	global strKatalogIncludeP
	strKatalogIncludeP = strKatalogInclude
	global strKatalogFont
	strKatalogFont = fileContentsS[43]
	strKatalogFontI = strKatalogFont.find("|")+1
	strKatalogFontL = len(strKatalogFont)
	strKatalogFont = strKatalogFont[strKatalogFontI:strKatalogFontL]
	global strKatalogFontSize
	strKatalogFontSize = fileContentsS[44]
	strKatalogFontSizeI = strKatalogFontSize.find("|")+1
	strKatalogFontSizeL = len(strKatalogFontSize)
	strKatalogFontSize = strKatalogFontSize[strKatalogFontSizeI:strKatalogFontSizeL]
	global strKatalogFontSpacing
	strKatalogFontSpacing = fileContentsS[45]
	strKatalogFontSpacingI = strKatalogFontSpacing.find("|")+1
	strKatalogFontSpacingL = len(strKatalogFontSpacing)
	strKatalogFontSpacing = strKatalogFontSpacing[strKatalogFontSpacingI:strKatalogFontSpacingL]
	global strKatalogRatio
	strKatalogRatio = fileContentsS[46]
	strKatalogRatioI = strKatalogRatio.find("|")+1
	strKatalogRatioL = len(strKatalogRatio)
	strKatalogRatio = (round(float(strKatalogRatio[strKatalogRatioI:strKatalogRatioL]),4))
	global strKatalogTextAlign
	strKatalogTextAlign = fileContentsS[47]
	strKatalogTextAlignI = strKatalogTextAlign.find("|")+1
	strKatalogTextAlignL = len(strKatalogTextAlign)
	strKatalogTextAlign = strKatalogTextAlign[strKatalogTextAlignI:strKatalogTextAlignL]
	global strKatalogStyle
	strKatalogStyle = fileContentsS[48]
	strKatalogStyleI = strKatalogStyle.find("|")+1
	strKatalogStyleL = len(strKatalogStyle)
	strKatalogStyle = strKatalogStyle[strKatalogStyleI:strKatalogStyleL]
	global strSetKatalog
	strSetKatalog = fileContentsS[49]
	strSetKatalogI = strSetKatalog.find("|")+1
	strSetKatalogL = len(strSetKatalog)
	strSetKatalog = strSetKatalog[strSetKatalogI:strSetKatalogL] 
	global strKatalogHyphen
	strKatalogHyphen = fileContentsS[50]
	strKatalogHyphenI = strKatalogHyphen.find("|")+1
	strKatalogHyphenL = len(strKatalogHyphen)
	strKatalogHyphen = strKatalogHyphen[strKatalogHyphenI:strKatalogHyphenL] 
	global strFaceInclude
	strFaceInclude = fileContentsS[51]
	strFaceIncludeI = strFaceInclude.find("|")+1
	strFaceIncludeL = len(strFaceInclude)
	strFaceInclude = strFaceInclude[strFaceIncludeI:strFaceIncludeL]
	global strFaceIncludeP
	strFaceIncludeP = strFaceInclude
	global strFaceFont
	strFaceFont = fileContentsS[52]
	strFaceFontI = strFaceFont.find("|")+1
	strFaceFontL = len(strFaceFont)
	strFaceFont = strFaceFont[strFaceFontI:strFaceFontL]
	global strFaceFontSize
	strFaceFontSize = fileContentsS[53]
	strFaceFontSizeI = strFaceFontSize.find("|")+1
	strFaceFontSizeL = len(strFaceFontSize)
	strFaceFontSize = strFaceFontSize[strFaceFontSizeI:strFaceFontSizeL]
	global strFaceFontSpacing
	strFaceFontSpacing = fileContentsS[54]
	strFaceFontSpacingI = strFaceFontSpacing.find("|")+1
	strFaceFontSpacingL = len(strFaceFontSpacing)
	strFaceFontSpacing = strFaceFontSpacing[strFaceFontSpacingI:strFaceFontSpacingL]
	global strFaceRatio
	strFaceRatio = fileContentsS[55]
	strFaceRatioI = strFaceRatio.find("|")+1
	strFaceRatioL = len(strFaceRatio)
	strFaceRatio = (round(float(strFaceRatio[strFaceRatioI:strFaceRatioL]),4))
	global strFaceTextAlign
	strFaceTextAlign = fileContentsS[56]
	strFaceTextAlignI = strFaceTextAlign.find("|")+1
	strFaceTextAlignL = len(strFaceTextAlign)
	strFaceTextAlign = strFaceTextAlign[strFaceTextAlignI:strFaceTextAlignL]
	global strFaceStyle
	strFaceStyle = fileContentsS[57]
	strFaceStyleI = strFaceStyle.find("|")+1
	strFaceStyleL = len(strFaceStyle)
	strFaceStyle = strFaceStyle[strFaceStyleI:strFaceStyleL]
	global strSetFace
	strSetFace = fileContentsS[58]
	strSetFaceI = strSetFace.find("|")+1
	strSetFaceL = len(strSetFace)
	strSetFace = strSetFace[strSetFaceI:strSetFaceL] 
	global strFaceHyphen
	strFaceHyphen = fileContentsS[59]
	strFaceHyphenI = strFaceHyphen.find("|")+1
	strFaceHyphenL = len(strFaceHyphen)
	strFaceHyphen = strFaceHyphen[strFaceHyphenI:strFaceHyphenL] 
	global strCaptionInclude
	strCaptionInclude = fileContentsS[60]
	strCaptionIncludeI = strCaptionInclude.find("|")+1
	strCaptionIncludeL = len(strCaptionInclude)
	strCaptionInclude = strCaptionInclude[strCaptionIncludeI:strCaptionIncludeL]
	global strCaptionIncludeP
	strCaptionIncludeP = strCaptionInclude
	global strCaptionIncludeXP
	strCaptionIncludeXP = strCaptionInclude
	global strCaptionFont
	strCaptionFont = fileContentsS[61]
	strCaptionFontI = strCaptionFont.find("|")+1
	strCaptionFontL = len(strCaptionFont)
	strCaptionFont = strCaptionFont[strCaptionFontI:strCaptionFontL]
	global strCaptionFontSize
	strCaptionFontSize = fileContentsS[62]
	strCaptionFontSizeI = strCaptionFontSize.find("|")+1
	strCaptionFontSizeL = len(strCaptionFontSize)
	strCaptionFontSize = strCaptionFontSize[strCaptionFontSizeI:strCaptionFontSizeL]
	global strCaptionFontSpacing
	strCaptionFontSpacing = fileContentsS[63]
	strCaptionFontSpacingI = strCaptionFontSpacing.find("|")+1
	strCaptionFontSpacingL = len(strCaptionFontSpacing)
	strCaptionFontSpacing = strCaptionFontSpacing[strCaptionFontSpacingI:strCaptionFontSpacingL]
	global strCaptionRatio
	strCaptionRatio = fileContentsS[64]
	strCaptionRatioI = strCaptionRatio.find("|")+1
	strCaptionRatioL = len(strCaptionRatio)
	strCaptionRatio = (round(float(strCaptionRatio[strCaptionRatioI:strCaptionRatioL]),4))
	global strCaptionTextAlign
	strCaptionTextAlign = fileContentsS[65]
	strCaptionTextAlignI = strCaptionTextAlign.find("|")+1
	strCaptionTextAlignL = len(strCaptionTextAlign)
	strCaptionTextAlign = strCaptionTextAlign[strCaptionTextAlignI:strCaptionTextAlignL]
	global strCaptionStyle
	strCaptionStyle = fileContentsS[66]
	strCaptionStyleI = strCaptionStyle.find("|")+1
	strCaptionStyleL = len(strCaptionStyle)
	strCaptionStyle = strCaptionStyle[strCaptionStyleI:strCaptionStyleL]
	global strSetCaption
	strSetCaption = fileContentsS[67]
	strSetCaptionI = strSetCaption.find("|")+1
	strSetCaptionL = len(strSetCaption)
	strSetCaption = strSetCaption[strSetCaptionI:strSetCaptionL] 
	global strCaptionHyphen
	strCaptionHyphen = fileContentsS[68]
	strCaptionHyphenI = strCaptionHyphen.find("|")+1
	strCaptionHyphenL = len(strCaptionHyphen)
	strCaptionHyphen = strCaptionHyphen[strCaptionHyphenI:strCaptionHyphenL] 
	global strPhotoInclude
	strPhotoInclude = fileContentsS[69]
	strPhotoIncludeI = strPhotoInclude.find("|")+1
	strPhotoIncludeL = len(strPhotoInclude)
	strPhotoInclude = strPhotoInclude[strPhotoIncludeI:strPhotoIncludeL]
	global strPhotoIncludeP
	strPhotoIncludeP = strPhotoInclude
	global strPhotoGreyscale
	strPhotoGreyscale = fileContentsS[70]
	strPhotoGreyscaleI = strPhotoGreyscale.find("|")+1
	strPhotoGreyscaleL = len(strPhotoGreyscale)
	strPhotoGreyscale = strPhotoGreyscale[strPhotoGreyscaleI:strPhotoGreyscaleL]
	global strPhotoRatio
	strPhotoRatio = fileContentsS[71]
	strPhotoRatioI = strPhotoRatio.find("|")+1
	strPhotoRatioL = len(strPhotoRatio)
	strPhotoRatio = strPhotoRatio[strPhotoRatioI:strPhotoRatioL]
	strPhotoRatio = (round(float(strPhotoRatio) / 100,4))
	global strLayoutTitle
	strLayoutTitle = fileContentsS[72]
	strLayoutTitleI = strLayoutTitle.find("|")+1
	strLayoutTitleL = len(strLayoutTitle)
	strLayoutTitle = strLayoutTitle[strLayoutTitleI:strLayoutTitleL]
	global strLayoutDate
	strLayoutDate = fileContentsS[73]
	strLayoutDateI = strLayoutDate.find("|")+1
	strLayoutDateL = len(strLayoutDate)
	strLayoutDate = strLayoutDate[strLayoutDateI:strLayoutDateL]
	global strLayoutKatalog
	strLayoutKatalog = fileContentsS[74]
	strLayoutKatalogI = strLayoutKatalog.find("|")+1
	strLayoutKatalogL = len(strLayoutKatalog)
	strLayoutKatalog = strLayoutKatalog[strLayoutKatalogI:strLayoutKatalogL]
	global strLayoutKatalogO
	strLayoutKatalogO = strLayoutKatalog
	global strLayoutFace
	strLayoutFace = fileContentsS[75]
	strLayoutFaceI = strLayoutFace.find("|")+1
	strLayoutFaceL = len(strLayoutFace)
	strLayoutFace = strLayoutFace[strLayoutFaceI:strLayoutFaceL]
	global strLayoutFaceO
	strLayoutFaceO = strLayoutFace
	global strLayoutCaption
	strLayoutCaption = fileContentsS[76]
	strLayoutCaptionI = strLayoutCaption.find("|")+1
	strLayoutCaptionL = len(strLayoutCaption)
	strLayoutCaption = strLayoutCaption[strLayoutCaptionI:strLayoutCaptionL] 
	global strStack1
	strStack1 = fileContentsS[77]
	strStack1I = strStack1.find("|")+1
	strStack1L = len(strStack1)
	strStack1 = strStack1[strStack1I:strStack1L] 
	global strStack2
	strStack2 = fileContentsS[78]
	strStack2I = strStack2.find("|")+1
	strStack2L = len(strStack2)
	strStack2 = strStack2[strStack2I:strStack2L] 
	global strStack3
	strStack3 = fileContentsS[79]
	strStack3I = strStack3.find("|")+1
	strStack3L = len(strStack3)
	strStack3 = strStack3[strStack3I:strStack3L] 
	global strStack4
	strStack4 = fileContentsS[80]
	strStack4I = strStack4.find("|")+1
	strStack4L = len(strStack4)
	strStack4 = strStack4[strStack4I:strStack4L] 
	global strStack5
	strStack5 = fileContentsS[81]
	strStack5I = strStack5.find("|")+1
	strStack5L = len(strStack5)
	strStack5 = strStack5[strStack5I:strStack5L] 
	global strFrameShadingInner
	strFrameShadingInner = fileContentsS[82]
	strFrameShadingInnerI = strFrameShadingInner.find("|")+1
	strFrameShadingInnerL = len(strFrameShadingInner)
	strFrameShadingInner = strFrameShadingInner[strFrameShadingInnerI:strFrameShadingInnerL]
	
	'''Substitute Text Box variables into Stack variables'''
	global strSetStack1
	if strStack1 == 'Title':
		strSetStack1 = strSetTitle
	elif strStack1 == 'Date':
		strSetStack1 = strSetDate
	elif strStack1 == 'Catalog':
		strSetStack1 = strSetKatalog
	elif strStack1 == 'Face Value':
		strSetStack1 = strSetFace
	elif strStack1 == 'Caption':
		strSetStack1 = strSetCaption
	global strSetStack2
	if strStack2 == 'Title':
		strSetStack2 = strSetTitle
	elif strStack2 == 'Date':
		strSetStack2 = strSetDate
	elif strStack2 == 'Catalog':
		strSetStack2 = strSetKatalog
	elif strStack2 == 'Face Value':
		strSetStack2 = strSetFace
	elif strStack2 == 'Caption':
		strSetStack2 = strSetCaption
	global strSetStack3
	if strStack3 == 'Title':
		strSetStack3 = strSetTitle
	elif strStack3 == 'Date':
		strSetStack3 = strSetDate
	elif strStack3 == 'Catalog':
		strSetStack3 = strSetKatalog
	elif strStack3 == 'Face Value':
		strSetStack3 = strSetFace
	elif strStack3 == 'Caption':
		strSetStack3 = strSetCaption
	global strSetStack4
	if strStack4 == 'Title':
		strSetStack4 = strSetTitle
	elif strStack4 == 'Date':
		strSetStack4 = strSetDate
	elif strStack4 == 'Catalog':
		strSetStack4 = strSetKatalog
	elif strStack4 == 'Face Value':
		strSetStack4 = strSetFace
	elif strStack4 == 'Caption':
		strSetStack4 = strSetCaption
	global strSetStack5
	if strStack5 == 'Title':
		strSetStack5 = strSetTitle
	elif strStack5 == 'Date':
		strSetStack5 = strSetDate
	elif strStack5 == 'Catalog':
		strSetStack5 = strSetKatalog
	elif strStack5 == 'Face Value':
		strSetStack5 = strSetFace
	elif strStack5 == 'Caption':
		strSetStack5 = strSetCaption
	
	'''Convert text alignments to numeric codes'''
	global strTitleTextAlignN
	if strTitleTextAlign == 'Left':
		strTitleTextAlignN = 0
	elif strTitleTextAlign == 'Center':
		strTitleTextAlignN = 1
	elif strTitleTextAlign == 'Right':
		strTitleTextAlignN = 2
	elif strTitleTextAlign == 'Justified':
		strTitleTextAlignN = 3

	global strDateTextAlignN
	if strDateTextAlign == 'Left':
		strDateTextAlignN = 0
	elif strDateTextAlign == 'Center':
		strDateTextAlignN = 1
	elif strDateTextAlign == 'Right':
		strDateTextAlignN = 2
	elif strDateTextAlign == 'Justified':
		strDateTextAlignN = 3
		
	global strKatalogTextAlignN
	if strKatalogTextAlign == 'Left':
		strKatalogTextAlignN = 0
	elif strKatalogTextAlign == 'Center':
		strKatalogTextAlignN = 1
	elif strKatalogTextAlign == 'Right':
		strKatalogTextAlignN = 2
	elif strKatalogTextAlign == 'Justified':
		strKatalogTextAlignN = 3

	global strFaceTextAlignN
	if strFaceTextAlign == 'Left':
		strFaceTextAlignN = 0
	elif strFaceTextAlign == 'Center':
		strFaceTextAlignN = 1
	elif strFaceTextAlign == 'Right':
		strFaceTextAlignN = 2
	elif strFaceTextAlign == 'Justified':
		strFaceTextAlignN = 3
		
	global strCaptionTextAlignN
	if strCaptionTextAlign == 'Left':
		strCaptionTextAlignN = 0
	elif strCaptionTextAlign == 'Center':
		strCaptionTextAlignN = 1
	elif strCaptionTextAlign == 'Right':
		strCaptionTextAlignN = 2
	elif strCaptionTextAlign == 'Justified':
		strCaptionTextAlignN = 3

	'''Set global text box styles'''
	if strTitleStyle == 'Global':
		scribus.createCharStyle("styTitleC",strTitleFont,float(strTitleFontSize))
		scribus.createParagraphStyle("Title",0,float(strTitleFontSize)*float(strTitleFontSpacing),strTitleTextAlignN,0,0,0,0,0,0,0,0,"styTitleC")
	if strDateStyle == 'Global':
		scribus.createCharStyle("styDateC",strDateFont,float(strDateFontSize))
		scribus.createParagraphStyle("Date",0,float(strDateFontSize)*float(strDateFontSpacing),strDateTextAlignN,0,0,0,0,0,0,0,0,"styDateC")
	if strKatalogStyle == 'Global':
		scribus.createCharStyle("styKatalogC",strKatalogFont,float(strKatalogFontSize))
		scribus.createParagraphStyle("Katalog",0,float(strKatalogFontSize)*float(strKatalogFontSpacing),strKatalogTextAlignN,0,0,0,0,0,0,0,0,"styKatalogC")
	if strFaceStyle == 'Global':
		scribus.createCharStyle("styFaceC",strFaceFont,float(strFaceFontSize))
		scribus.createParagraphStyle("Face",0,float(strFaceFontSize)*float(strFaceFontSpacing),strFaceTextAlignN,0,0,0,0,0,0,0,0,"styFaceC")
	if strCaptionStyle == 'Global':
		scribus.createCharStyle("styCaptionC",strCaptionFont,float(strCaptionFontSize))
		scribus.createParagraphStyle("Caption",0,float(strCaptionFontSize)*float(strCaptionFontSpacing),strCaptionTextAlignN,0,0,0,0,0,0,0,0,"styCaptionC")		
	if strFaceStyle == 'Global - Small Caps':
		strSmallCaps = 'smallcaps'
		scribus.createCharStyle("styFaceSC",strFaceFont,float(strFaceFontSize),strSmallCaps)
		scribus.createParagraphStyle("FaceSC",0,float(strFaceFontSize)*float(strFaceFontSpacing),strFaceTextAlignN,0,0,0,0,0,0,0,0,"styFaceSC")

	'''Zero out inner frame data if using single frame'''
	if strFrameDouble == 'FALSE':
		strFrameThicknessInner = 0
		strFrameSpacing = 0
	
	if strFrameStyle == 'Internal':
		strFrameThicknessInner = 0
		strFrameSpacing = 0

	'''Set frame offset'''
	global strFrameOffset
	if strFrameStyle == 'External':
		strFrameOffset = strFrameThicknessOuter + strFrameSpacing + strFrameThicknessInner
	else:
		strFrameOffset = 0
	
	'''Prevent use of Internal frame style with group frame style sets'''
	if strSingleSet == 'Set' and strSetFrame == 'Group':
		strFrameStyle = 'External'
	
	'''Disable photos if using Internal frame style'''
	if strFrameStyle == 'Internal':
		strPhotoInclude = 'FALSE'
		
	'''Zero out the padding if using Internal styles'''
	if strFrameStyle == 'Internal':
		strPaddingLeft = 0
		strPaddingRight = 0
		strPaddingTop = 0
		strPaddingBottom = 0

	'''Adjust includes based on style'''
	if strStyle == 'Inside - Catalog':
		strKatalogInclude = 'TRUE'
		strKatalogIncludeP = strKatalogInclude
		strTitleInclude = 'FALSE'
		strTitleIncludeP = strTitleInclude
		strDateInclude = 'FALSE'
		strDateIncludeP = strDateInclude
		strFaceInclude = 'FALSE'
		strFaceIncludeP = strFaceInclude
		strCaptionInclude = 'FALSE'
		strCaptionIncludeP = strCaptionInclude
		strPhotoInclude = 'FALSE'
		strLayoutKatalog = 'Bottom'
	if strStyle == 'Inside - Face Value':
		strFaceInclude = 'TRUE'
		strFaceIncludeP = strFaceInclude
		strTitleInclude = 'FALSE'
		strTitleIncludeP = strTitleInclude
		strDateInclude = 'FALSE'
		strDateIncludeP = strDateInclude
		strKatalogInclude = 'FALSE'
		strKatalogIncludeP = strKatalogInclude
		strCaptionInclude = 'FALSE'
		strCaptionIncludeP = strCaptionInclude
		strPhotoInclude = 'FALSE'
		strLayoutFace = 'Bottom'
	if strStyle == 'Outside/Inside':
		strLayoutKatalog = 'Bottom'

	'''Prep for Sets'''
	global strSetMaxH
	strSetMaxH = 0
	global strSetMaxW
	strSetMaxW = 0
	global strSetTotH
	strSetTotH = 0
	global strSetTotW
	strSetTotW = 0
	global strSetCount
	strSetCount = 0
	global strSetMaxI
	strSetMaxI = 0

	global lstGroupName
	lstGroupName = []
	
	funcImportBatch()

def funcImportBatch():	 
	'''Load data from the text file'''
	fileHandleB = open(strFileB, 'r', encoding="utf-8")
	fileContentsB = fileHandleB.readlines()
	fileNumLines = len([l for l in fileContentsB if l.strip(' \n') != ''])
	fileHandleB.close
		
	'''Create empty lists for set shapes'''
	global lstFoS
	lstFoS = []
	global lstFiS
	lstFiS = []
	global lstPS
	lstPS = []
	global lstTS
	lstTS = []
	global lstDS
	lstDS = []
	global lstKS
	lstKS = []
	global lstFS
	lstFS = [] 
	global lstCS
	lstCS = []

	'''Lists to capture data on first run though of sets'''
	global lstPageOffset
	lstPageOffset = []
	global lstPageOffsetT
	lstPageOffsetT = []
	
	global lstSetRow
	lstSetRow = []
	
	global lstStampH
	global lstStampW
	lstStampH = []
	lstStampW = []

	global lstPhoto
	global lstPhotoH
	global lstPhotoW
	lstPhoto = []
	lstPhotoH = []
	lstPhotoW = []

	global lstTitle
	global lstDate
	global lstKatalog
	global lstFace
	global lstCaption
	lstTitle = []
	lstDate = []
	lstKatalog = []
	lstFace = []
	lstCaption = []

	global shpS1t
	global shpS1b
	global shpS1r
	global shpS1l
	global shpS2t
	global shpS2b
	global shpS2r
	global shpS2l
	global shpS3t
	global shpS3b
	global shpS3r
	global shpS3l
	global shpS4t
	global shpS4b
	global shpS4r
	global shpS4l
	global shpS5t
	global shpS5b
	global shpS5r
	global shpS5l
	
	shpS1t = 'abc'
	shpS1b = 'abc'
	shpS1r = 'abc'
	shpS1l = 'abc'
	shpS2t = 'abc'
	shpS2b = 'abc'
	shpS2r = 'abc'
	shpS2l = 'abc'
	shpS3t = 'abc'
	shpS3b = 'abc'
	shpS3r = 'abc'
	shpS3l = 'abc'
	shpS4t = 'abc'
	shpS4b = 'abc'
	shpS4r = 'abc'
	shpS4l = 'abc'
	shpS5t = 'abc'
	shpS5b = 'abc'
	shpS5r = 'abc'
	shpS5l = 'abc'
	
	global lstSetMaxH
	global lstSetMaxW
	global lstSetTotH
	global lstSetTotW
	global lstSetCount
	global lstSetMaxI
	lstSetMaxH = []
	lstSetMaxW = []
	lstSetTotH = []
	lstSetTotW = []
	lstSetCount = []
	lstSetMaxI = []
	
	global strSetMaxH
	global strSetMaxW
	global strSetTotH
	global strSetTotW
	global strSetCount
	global strSetMaxI
	strSetMaxH = 0
	strSetMaxW = 0
	strSetTotH = 0
	strSetTotW = 0
	strSetCount = 0
	strSetMaxI = 0
	
	'''Loop through the stamp entries to extract the respective field values from each entry'''
	global icnt0
	icnt0 = 0
	global icnt
	icnt = 0
	global icntsubset
	icntsubset = 0
	
	global lstRndGrp
	lstRndGrp = []
	
	global rndfirst
	
	while icnt0 < (fileNumLines):		
		scribus.setUnit(0)
		fileHandleB = open(strFileB, 'r', encoding="utf-8")
		fileLine = fileHandleB.readlines()
		strLineTemp = fileLine[icnt0]
		strLineTemp = strLineTemp.replace("~", '\n')
		
		strLineTempI = strLineTemp.find("|")
		strPageOffset = strLineTemp[0:strLineTempI]
		lstPageOffsetT.append(strPageOffset)
		
		'''loop to the next stamp entry'''
		icnt0 += 1
		fileHandleB.close()	
			
	lstPageOffsetT = sorted(set(lstPageOffsetT))
	mv = int(max(lstPageOffsetT))
	
	global rnd
	global lstFo
	global lstFi
	global lstP
	global lstTopShp
	global lstBottomShp
	global lstRightShp
	global lstRightShpG
	global lstLeftShp
	global lstLeftShpG
	global strTitle
	global strTitleInclude
	global strDate
	global strDateInclude
	global strKatalog
	global strKatalogInclude
	global strFace
	global strFaceInclude
	global strCaption
	global strCaptionInclude
	global strPhoto
	global strPhotoHeight
	global strPhotoWidth
	global i3
	global acnt
	
	if strSingleSet != 'Singles' and len(lstPageOffsetT)>1:
		j = 0
		while j < len(lstPageOffsetT):
			k = int(lstPageOffsetT[j])
			lstPageOffset[:]=[]
			icnt = 0
			icntsubset = 0
			while icnt < (fileNumLines):		
				'''Use random numer to give unique shape names'''
				 
				rnd = str(randint(10000,999999999))
		
				'''Make a list of the random numbers for later use in IDing shapes'''
				lstRndGrp.append(rnd)
		
				'''Save the first random number so we can later ID the text boxes to use in a set'''
				if icnt == 0:
					rndfirst = rnd

				'''Lists for frame and photo shapes'''
				global lstFo
				global lstFi
				global lstP
				lstFo = []
				lstFi = []
				lstP = []

				'''Lists of Text boxes shapes on each side of frame'''
				global lstTopShp
				global lstBottomShp
				global lstRightShp
				global lstRightShpG
				global lstLeftShp
				global lstLeftShpG
				lstTopShp = []
				lstBottomShp= []
				lstRightShp = []
				lstRightShpG = []
				lstLeftShp = []
				lstLeftShpG = []

				scribus.setUnit(0)
				fileHandleB = open(strFileB, 'r')
				fileLine = fileHandleB.readlines()
				strLineTemp = fileLine[icnt]
				strLineTemp = strLineTemp.replace("~", '\n')
		
				strLineTempI = strLineTemp.find("|")
				strPageOffset = strLineTemp[0:strLineTempI]
				if int(strPageOffset) != k:
					icnt += 1
				else:
					lstPageOffset.append(strPageOffset)
	
					strLineTempM = strLineTempI + 1
					strLineTempI = strLineTemp.find("|",strLineTempM)
					strSetRow = strLineTemp[strLineTempM:strLineTempI]
					lstSetRow.append(strSetRow)
		
					strLineTempM = strLineTempI + 1
					strLineTempI = strLineTemp.find("|",strLineTempM)
					strStampHeight = strLineTemp[strLineTempM:strLineTempI]
					'''if StampHeight was left empty, assign a minimal value'''		  
					if strStampHeight == 'NullField':
						strStampHeight = "5"
					strStampHeight = (round(float(strStampHeight),4))
					strStampHeight = strStampHeight * decConversionValue
					lstStampH.append(strStampHeight)

					strLineTempM = strLineTempI + 1
					strLineTempI = strLineTemp.find("|",strLineTempM)
					strStampWidth = strLineTemp[strLineTempM:strLineTempI]
					'''if StampWidth was left empty, assign a minimal value''' 
					if strStampWidth == 'NullField':
						strStampWidth = "5"
					strStampWidth = (round(float(strStampWidth),4))
					strStampWidth = strStampWidth * decConversionValue
					lstStampW.append(strStampWidth)

					strLineTempM = strLineTempI + 1
					strLineTempI = strLineTemp.find("|",strLineTempM)
					global strTitle
					strTitle = strLineTemp[strLineTempM:strLineTempI]
					lstTitle.append(strTitle)
					global strTitleInclude
					strTitleInclude = strTitleIncludeP

					strLineTempM = strLineTempI + 1
					strLineTempI = strLineTemp.find("|",strLineTempM)
					global strDate
					strDate = strLineTemp[strLineTempM:strLineTempI]
					lstDate.append(strDate)
					global strDateInclude
					strDateInclude = strDateIncludeP

					strLineTempM = strLineTempI + 1
					strLineTempI = strLineTemp.find("|",strLineTempM)
					global strKatalog
					strKatalog = strLineTemp[strLineTempM:strLineTempI]
					lstKatalog.append(strKatalog)
					global strKatalogInclude
					strKatalogInclude = strKatalogIncludeP

					strLineTempM = strLineTempI + 1
					strLineTempI = strLineTemp.find("|",strLineTempM)
					global strFace
					strFace = strLineTemp[strLineTempM:strLineTempI]
					lstFace.append(strFace)
					global strFaceInclude
					strFaceInclude = strFaceIncludeP

					strLineTempM = strLineTempI + 1
					strLineTempI = strLineTemp.find("|",strLineTempM)
					global strCaption
					strCaption = strLineTemp[strLineTempM:strLineTempI]
					lstCaption.append(strCaption)
					global strCaptionInclude
					strCaptionInclude = strCaptionIncludeP

					strLineTempM = strLineTempI + 1
					strLineTempI = strLineTemp.find("|",strLineTempM)
					global strPhoto
					strPhoto = strLineTemp[strLineTempM:strLineTempI]
					lstPhoto.append(strPhoto)

					global strPhotoHeight
					strPhotoHeight = strStampHeight * strPhotoRatio
					lstPhotoH.append(strPhotoHeight)
					global strPhotoWidth
					strPhotoWidth = strStampWidth * strPhotoRatio
					lstPhotoW.append(strPhotoWidth)
					
					'''If Single, call the Generate code, otherwise calculate the size of the set box'''
					if strSingleSet == 'Singles':
						if strTitle == 'NullField':
							strTitleInclude = 'FALSE'
						if strDate == 'NullField':
							strDateInclude = 'FALSE'
						if strKatalog == 'NullField':
							strKatalogInclude = 'FALSE'
						if strFace == 'NullField':
							strFaceInclude = 'FALSE'
						if strCaption == 'NullField':
							strCaptionInclude = 'FALSE'
						funcGenerateSingles()
					else:
						i = icnt
						icnt = icntsubset	
						funcSetCalc()
						icnt = i
					icntsubset += 1

					'''loop to the next stamp entry'''
					icnt += 1
				fileHandleB.close()

			'''shpTest2a = scribus.createText(100, 100, 50, 15, 'shpTest2a')
			scribus.setText(str(icnt), shpTest2a)
			shpTest2b = scribus.createText(100, 100, 50, 15, 'shpTest2b')
			scribus.setText(str(len(lstStampH)), shpTest2b)'''

			'''If Set, build the set'''
			if strSingleSet == 'Set':
				'''If generating across multiple pages using the page offset'''
				pagecountOrig = scribus.pageCount()
				pageoffset = int(intStartPage) + k
				if pagecountOrig < pageoffset:
					pagediff = pageoffset - pagecountOrig
					for i in range (0,pagediff):
						scribus.newPage(-1)
						pagecount2 = scribus.pageCount()
						scribus.gotoPage(pagecount2)
				else:
					scribus.gotoPage(pageoffset)
				'''If set uses a grouped frame, generate the frame then run the second import to generate text boxes'''
				if strSetFrame == 'Group':
					funcGenerateSetFrameGrouped()
					if strPhotoInclude == 'TRUE':
						funcGenerateSetFrameGroupedPhotos()
					funcGenerateSetFrameGroupedText()
					funcGroupAndAlign()
				else:
					funcGenerateSetFrameIndiv()
					funcGenerateSetFrameIndivText()
					funcGroupAndAlign()
					strSetMaxH = 0
					strSetMaxW = 0
					strSetTotH = 0
					strSetTotW = 0
					strSetCount = 0
					strSetMaxI = 0
				scribus.setUnit(origUnit)
			elif strSingleSet == 'Set - Multi-Row/Column':
				'''If generating across multiple pages using the page offset'''
				pagecountOrig = scribus.pageCount()
				pageoffset = int(intStartPage) + k
				if pagecountOrig < pageoffset:
					pagediff = pageoffset - pagecountOrig
					for i in range (0,pagediff):
						scribus.newPage(-1)
						pagecount2 = scribus.pageCount()
						scribus.gotoPage(pagecount2)
				else:
					scribus.gotoPage(pageoffset)
				i1 = len(lstSetRow)
				i2 = lstSetRow.count('0')
				if i1 == i2:
					if strSetFrame == 'Group':
						funcGenerateSetFrameGrouped()
						if strPhotoInclude == 'TRUE':
							funcGenerateSetFrameGroupedPhotos()
						funcGenerateSetFrameGroupedText()
						funcGroupAndAlign()
					else:
						funcGenerateSetFrameIndiv()
						funcGenerateSetFrameIndivText()
						funcGroupAndAlign()
					scribus.setUnit(origUnit)
				else:
					'''global i3'''
					i3 = int(max(lstSetRow))
					'''global acnt'''
					acnt = 0
					while acnt <= i3:
						'''global strSetMaxH'''
						'''global strSetMaxW'''
						'''global strSetTotH'''
						'''global strSetTotW'''
						'''global strSetCount'''
						'''global strSetMaxI'''
						strSetMaxH = 0
						strSetMaxW = 0
						strSetTotH = 0
						strSetTotW = 0
						strSetCount = 0
						strSetMaxI = 0
						funcImportBatchSetRow(acnt)
						funcGenerateSetFrameIndiv()
						funcGenerateSetFrameIndivText()
						funcGroupAndAlign()
						lstPageOffset = lstPageOffsetOrig[:]
						lstStampH = lstStampHOrig[:]
						lstStampW = lstStampWOrig[:]
						lstPhoto = lstPhotoOrig[:]
						lstPhotoH = lstPhotoHOrig[:]
						lstPhotoW = lstPhotoWOrig[:]
						lstTitle = lstTitleOrig[:]
						lstDate = lstDateOrig[:]
						lstKatalog = lstKatalogOrig[:]
						lstFace = lstFaceOrig[:]
						lstCaption = lstCaptionOrig[:]
						acnt += 1
					funcSetMultiYPosition()
					scribus.setUnit(origUnit)
			
			lstSetRow[:] = []
			lstStampH[:] = []
			lstStampW[:] = []
			lstPhoto[:] = []
			lstPhotoH[:] = []
			lstPhotoW[:] = []
			lstTitle[:] = []
			lstDate[:] = []
			lstKatalog[:] = []
			lstFace[:] = []
			lstCaption[:] = []
			lstGroupName[:] = []
			j += 1
	else:
		lstPageOffset[:]=[]
		while icnt < (fileNumLines):		
			'''Use random numer to give unique shape names'''
			rnd = str(randint(10000,999999999))
		
			'''Make a list of the random numbers for later use in IDing shapes'''
			lstRndGrp.append(rnd)
		
			'''Save the first random number so we can later ID the text boxes to use in a set'''
			if icnt == 0:
				rndfirst = rnd

			'''Lists for frame and photo shapes'''
			'''global lstFo
			global lstFi
			global lstP'''
			lstFo = []
			lstFi = []
			lstP = []

			'''Lists of Text boxes shapes on each side of frame'''
			'''global lstTopShp
			global lstBottomShp
			global lstRightShp
			global lstRightShpG
			global lstLeftShp
			global lstLeftShpG'''
			lstTopShp = []
			lstBottomShp= []
			lstRightShp = []
			lstRightShpG = []
			lstLeftShp = []
			lstLeftShpG = []

			scribus.setUnit(0)
			fileHandleB = open(strFileB, 'r', encoding="utf-8")
			fileLine = fileHandleB.readlines()
			strLineTemp = fileLine[icnt]
			strLineTemp = strLineTemp.replace("~", '\n')
		
			strLineTempI = strLineTemp.find("|")
			strPageOffset = strLineTemp[0:strLineTempI]
			lstPageOffset.append(strPageOffset)
	
			strLineTempM = strLineTempI + 1
			strLineTempI = strLineTemp.find("|",strLineTempM)
			strSetRow = strLineTemp[strLineTempM:strLineTempI]
			lstSetRow.append(strSetRow)
		
			strLineTempM = strLineTempI + 1
			strLineTempI = strLineTemp.find("|",strLineTempM)
			strStampHeight = strLineTemp[strLineTempM:strLineTempI]
			'''if StampHeight was left empty, assign a minimal value'''		  
			if strStampHeight == 'NullField':
				strStampHeight = "5"
			strStampHeight = (round(float(strStampHeight),4))
			strStampHeight = strStampHeight * decConversionValue
			lstStampH.append(strStampHeight)

			strLineTempM = strLineTempI + 1
			strLineTempI = strLineTemp.find("|",strLineTempM)
			strStampWidth = strLineTemp[strLineTempM:strLineTempI]
			'''if StampWidth was left empty, assign a minimal value''' 
			if strStampWidth == 'NullField':
				strStampWidth = "5"
			strStampWidth = (round(float(strStampWidth),4))
			strStampWidth = strStampWidth * decConversionValue
			lstStampW.append(strStampWidth)

			strLineTempM = strLineTempI + 1
			strLineTempI = strLineTemp.find("|",strLineTempM)
			'''global strTitle'''
			strTitle = strLineTemp[strLineTempM:strLineTempI]
			lstTitle.append(strTitle)
			'''global strTitleInclude'''
			strTitleInclude = strTitleIncludeP

			strLineTempM = strLineTempI + 1
			strLineTempI = strLineTemp.find("|",strLineTempM)
			'''global strDate'''
			strDate = strLineTemp[strLineTempM:strLineTempI]
			lstDate.append(strDate)
			'''global strDateInclude'''
			strDateInclude = strDateIncludeP

			strLineTempM = strLineTempI + 1
			strLineTempI = strLineTemp.find("|",strLineTempM)
			'''global strKatalog'''
			strKatalog = strLineTemp[strLineTempM:strLineTempI]
			lstKatalog.append(strKatalog)
			'''global strKatalogInclude'''
			strKatalogInclude = strKatalogIncludeP

			strLineTempM = strLineTempI + 1
			strLineTempI = strLineTemp.find("|",strLineTempM)
			'''global strFace'''
			strFace = strLineTemp[strLineTempM:strLineTempI]
			lstFace.append(strFace)
			'''global strFaceInclude'''
			strFaceInclude = strFaceIncludeP

			strLineTempM = strLineTempI + 1
			strLineTempI = strLineTemp.find("|",strLineTempM)
			'''global strCaption'''
			strCaption = strLineTemp[strLineTempM:strLineTempI]
			lstCaption.append(strCaption)
			'''global strCaptionInclude'''
			strCaptionInclude = strCaptionIncludeP

			strLineTempM = strLineTempI + 1
			strLineTempI = strLineTemp.find("|",strLineTempM)
			'''global strPhoto'''
			strPhoto = strLineTemp[strLineTempM:strLineTempI]
			lstPhoto.append(strPhoto)

			'''global strPhotoHeight'''
			strPhotoHeight = strStampHeight * strPhotoRatio
			lstPhotoH.append(strPhotoHeight)
			'''global strPhotoWidth'''
			strPhotoWidth = strStampWidth * strPhotoRatio
			lstPhotoW.append(strPhotoWidth)

			'''If Single, call the Generate code, otherwise calculate the size of the set box'''
			if strSingleSet == 'Singles':
				if strTitle == 'NullField':
					strTitleInclude = 'FALSE'
				if strDate == 'NullField':
					strDateInclude = 'FALSE'
				if strKatalog == 'NullField':
					strKatalogInclude = 'FALSE'
				if strFace == 'NullField':
					strFaceInclude = 'FALSE'
				if strCaption == 'NullField':
					strCaptionInclude = 'FALSE'
				funcGenerateSingles()
			else:		
				funcSetCalc()

			'''loop to the next stamp entry'''
			icnt += 1
			fileHandleB.close()

		'''If Set, build the set'''
		if strSingleSet == 'Set':
			'''If set uses a grouped frame, generate the frame then run the second import to generate text boxes'''
			if strSetFrame == 'Group':
				funcGenerateSetFrameGrouped()
				if strPhotoInclude == 'TRUE':
					funcGenerateSetFrameGroupedPhotos()
				funcGenerateSetFrameGroupedText()
				funcGroupAndAlign()
			else:
				funcGenerateSetFrameIndiv()
				funcGenerateSetFrameIndivText()
				funcGroupAndAlign()
			scribus.setUnit(origUnit)
		elif strSingleSet == 'Set - Multi-Row/Column':
			i1 = len(lstSetRow)
			i2 = lstSetRow.count('0')
			if i1 == i2:
				if strSetFrame == 'Group':
					funcGenerateSetFrameGrouped()
					if strPhotoInclude == 'TRUE':
						funcGenerateSetFrameGroupedPhotos()
					funcGenerateSetFrameGroupedText()
					funcGroupAndAlign()
				else:
					funcGenerateSetFrameIndiv()
					funcGenerateSetFrameIndivText()
					funcGroupAndAlign()
				scribus.setUnit(origUnit)
			else:
				'''global i3'''
				i3 = int(max(lstSetRow))
				'''global acnt'''
				acnt = 0
				while acnt <= i3:
					'''global strSetMaxH'''
					'''global strSetMaxW'''
					'''global strSetTotH'''
					'''global strSetTotW'''
					'''global strSetCount'''
					'''global strSetMaxI'''
					strSetMaxH = 0
					strSetMaxW = 0
					strSetTotH = 0
					strSetTotW = 0
					strSetCount = 0
					strSetMaxI = 0
					funcImportBatchSetRow(acnt)
					funcGenerateSetFrameIndiv()
					funcGenerateSetFrameIndivText()
					funcGroupAndAlign()
					lstPageOffset = lstPageOffsetOrig[:]
					lstStampH = lstStampHOrig[:]
					lstStampW = lstStampWOrig[:]
					lstPhoto = lstPhotoOrig[:]
					lstPhotoH = lstPhotoHOrig[:]
					lstPhotoW = lstPhotoWOrig[:]
					lstTitle = lstTitleOrig[:]
					lstDate = lstDateOrig[:]
					lstKatalog = lstKatalogOrig[:]
					lstFace = lstFaceOrig[:]
					lstCaption = lstCaptionOrig[:]
					acnt += 1
				funcSetMultiYPosition()
				scribus.setUnit(origUnit)

def funcImportBatchSetRow(acnt):
	global lstPageOffset
	global lstStampH
	global lstStampW
	global lstPhoto
	global lstPhotoH
	global lstPhotoW
	global lstTitle
	global lstDate
	global lstKatalog
	global lstFace
	global lstCaption
	global lstPageOffsetOrig
	global lstStampHOrig
	global lstStampWOrig
	global lstPhotoOrig
	global lstPhotoHOrig
	global lstPhotoWOrig
	global lstTitleOrig
	global lstDateOrig
	global lstKatalogOrig
	global lstFaceOrig
	global lstCaptionOrig
	lstPageOffsetOrig = lstPageOffset[:]
	lstStampHOrig = lstStampH[:]
	lstStampWOrig = lstStampW[:]
	lstPhotoOrig = lstPhoto[:]
	lstPhotoHOrig = lstPhotoH[:]
	lstPhotoWOrig = lstPhotoW[:]
	lstTitleOrig = lstTitle[:]
	lstDateOrig = lstDate[:]
	lstKatalogOrig = lstKatalog[:]
	lstFaceOrig = lstFace[:]
	lstCaptionOrig = lstCaption[:]
	global lstPageOffsetTemp
	global lstStampHTemp
	global lstStampWTemp
	global lstPhotoTemp
	global lstPhotoHTemp
	global lstPhotoWTemp
	global lstTitleTemp
	global lstDateTemp
	global lstKatalogTemp
	global lstFaceTemp
	global lstCaptionTemp
	lstPageOffsetTemp = []
	lstStampHTemp = []
	lstStampWTemp = []
	lstPhotoTemp = []
	lstPhotoHTemp = []
	lstPhotoWTemp = []
	lstTitleTemp = []
	lstDateTemp = []
	lstKatalogTemp = []
	lstFaceTemp = []
	lstCaptionTemp = []
	i = 0
	j = len(lstStampH)
	while i < j:
		if lstSetRow[i] == str(acnt):
			strA = lstPageOffset[i]
			lstPageOffsetTemp.append(strA)
			lstStampHTemp.append(lstStampH[i])
			lstStampWTemp.append(lstStampW[i])
			lstPhotoTemp.append(lstPhoto[i])
			lstPhotoHTemp.append(lstPhotoH[i])
			lstPhotoWTemp.append(lstPhotoW[i])
			lstTitleTemp.append(lstTitle[i])
			lstDateTemp.append(lstDate[i])
			lstKatalogTemp.append(lstKatalog[i])
			lstFaceTemp.append(lstFace[i])
			lstCaptionTemp.append(lstCaption[i])
		i += 1
	lstPageOffset[:] = []
	lstStampH[:] = []
	lstStampW[:] = []
	lstPhoto[:] = []
	lstPhotoH[:] = []
	lstPhotoW[:] = []
	lstTitle[:] = []
	lstDate[:] = []
	lstKatalog[:] = []
	lstFace[:] = []
	lstCaption[:] = []
	lstPageOffset = lstPageOffsetTemp[:]
	lstStampH = lstStampHTemp[:]
	lstStampW = lstStampWTemp[:]
	lstPhoto = lstPhotoTemp[:]
	lstPhotoH = lstPhotoHTemp[:]
	lstPhotoW = lstPhotoWTemp[:]
	lstTitle = lstTitleTemp[:]
	lstDate = lstDateTemp[:]
	lstKatalog = lstKatalogTemp[:]
	lstFace = lstFaceTemp[:]
	lstCaption = lstCaptionTemp[:]
	global icnt
	icnt = 0
	n = len(lstStampH)
	while icnt < n:
		funcSetCalc()
		icnt += 1
	lstPageOffsetTemp[:] = []
	lstStampHTemp[:] = []
	lstStampWTemp[:] = []
	lstPhotoTemp[:] = []
	lstPhotoHTemp[:] = []
	lstPhotoWTemp[:] = []
	lstTitleTemp[:] = []
	lstDateTemp[:] = []
	lstKatalogTemp[:] = []
	lstFaceTemp[:] = []
	lstCaptionTemp[:] = []
	
	



	'''global icnt
	icnt = 0
	while icnt < j:
		shpTest1 = scribus.createText(100, 100, 50, 15, 'shpTest1')
		scribus.setText(str(icnt), shpTest1)
		funcSetCalc()
		icnt += 1'''

def funcGenerateSingles():
	'''If generating across multiple pages using the page offset'''
	if int(lstPageOffset[icnt]) > 0:
		pagecountOrig = scribus.pageCount()
		pageoffset = int(intStartPage) + int(lstPageOffset[icnt])
		if pagecountOrig < pageoffset:
			pagediff = pageoffset - pagecountOrig
			for i in range (0,pagediff):
				scribus.newPage(-1)
				pagecount2 = scribus.pageCount()
				scribus.gotoPage(pagecount2)
		else:
			scribus.gotoPage(pageoffset)
		
	'''Calculate frame dimensions'''
	global strFrameInnerHeight
	global strFrameInnerWidth
	global strFrameOuterHeight
	global strFrameOuterWidth

	if strFrameStyle == 'External':
		strFrameInnerHeight = lstStampH[icnt] + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2)
		strFrameInnerWidth = lstStampW[icnt] + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2)
		strFrameOuterHeight = lstStampH[icnt] + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
		strFrameOuterWidth = lstStampW[icnt] + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)
	else:
		strFrameOuterHeight = lstStampH[icnt] * .9
		strFrameOuterWidth = lstStampW[icnt] * .9

	'''Set default placement to page center'''
	global strPlacementX
	global strPlacementY

	pageWidth, pageHeight = scribus.getPageSize()
	topMargin, leftMargin, rightMargin, bottomMargin = scribus.getPageMargins()

	printAreaWidth= pageWidth - leftMargin - rightMargin
	printAreaHeight = pageHeight - topMargin - bottomMargin 
	
	if strFrameStyle == 'External':
		strPlacementX = (round(float((printAreaWidth - strFrameOuterWidth)/2 + leftMargin),4))
		strPlacementY = (round(float((printAreaHeight - strFrameOuterHeight)/2 + topMargin),4))
	else:
		strPlacementX = (round(float((printAreaWidth - lstStampW[icnt])/2 + leftMargin),4))
		strPlacementY = (round(float((printAreaHeight - lstStampH[icnt])/2 + topMargin),4))

	global shpFo

	'''Draw the frame'''
	if strFrameStyle == 'External':
		if strFrameDouble == 'TRUE':
			shpFo = scribus.createRect(strPlacementX + (strFrameThicknessOuter / 2), \
			strPlacementY + (strFrameThicknessOuter / 2), (strFrameOuterWidth - strFrameThicknessOuter), \
			(strFrameOuterHeight - strFrameThicknessOuter), 'shpFo' + rnd)
			scribus.setLineWidth(strFrameThicknessOuter, shpFo)
			lstFo.append(shpFo)

			global shpFi
			shpFi = scribus.createRect(strPlacementX + (strFrameThicknessInner / 2), \
			strPlacementY + (strFrameThicknessInner / 2), (strFrameInnerWidth - strFrameThicknessInner), \
			(strFrameInnerHeight - strFrameThicknessInner), 'shpFi' + rnd)
			scribus.setLineWidth(strFrameThicknessInner, shpFi)
			scribus.setLineShade(int(strFrameShadingInner),shpFi)
			lstFi.append(shpFi)

			strFrameAlignOffset = strFrameThicknessOuter + strFrameSpacing
			scribus.setProperty(shpFi, "xPos", scribus.getProperty(shpFi, "xPos") + strFrameAlignOffset)
			scribus.setProperty(shpFi, "yPos", scribus.getProperty(shpFi, "yPos") + strFrameAlignOffset)
		else:
			shpFo = scribus.createRect(strPlacementX + (strFrameThicknessOuter / 2), \
			strPlacementY + (strFrameThicknessOuter / 2), (strFrameOuterWidth - strFrameThicknessOuter), \
			(strFrameOuterHeight - strFrameThicknessOuter), 'shpFo' + rnd)
			scribus.setLineWidth(strFrameThicknessOuter, shpFo)
			lstFo.append(shpFo)
	else:
		'''Internal frame style'''
		shpFo = scribus.createRect(strPlacementX + (lstStampW[icnt] * .05), strPlacementY + \
		(lstStampH[icnt] * .05), strFrameOuterWidth, strFrameOuterHeight, 'shpFo' + rnd)
		scribus.setLineWidth(strFrameThicknessOuter, shpFo)
		lstFo.append(shpFo)

	'''Add the photo'''
	if strPhotoInclude == 'TRUE':
		if lstPhoto[icnt] != 'NullField':
			global shpP
			shpP = scribus.createImage(strPlacementX + strFrameOffset, strPlacementY + strFrameOffset, \
			lstPhotoW[icnt], lstPhotoH[icnt], 'shpP' + rnd)
			strPhotoAlignOffsetX = strPaddingLeft + ((lstStampW[icnt] - lstPhotoW[icnt]) / 2)
			scribus.setProperty(shpP, "xPos", scribus.getProperty(shpP, "xPos") + strPhotoAlignOffsetX)
			strPhotoAlignOffsetY = strPaddingTop + ((lstStampH[icnt] - lstPhotoH[icnt]) / 2)
			scribus.setProperty(shpP, "yPos", scribus.getProperty(shpP, "yPos") + strPhotoAlignOffsetY)
			scribus.loadImage(lstPhoto[icnt], shpP)	 
			scribus.setScaleImageToFrame(True, True, shpP)
			if strPhotoGreyscale == 'TRUE':
				scribus.setImageGrayscale(shpP)
			lstP.append(shpP)

	'''Cue the text boxes'''
	if strTitleInclude == 'TRUE':
		funcTitlePlacementXSingles()
	if strDateInclude == 'TRUE':
		funcDatePlacementXSingles()
	if strKatalogInclude == 'TRUE':
		funcKatalogPlacementXSingles()
	if strFaceInclude == 'TRUE':
		funcFacePlacementXSingles()
	if strCaptionInclude == 'TRUE':
		funcCaptionPlacementXSingles()
	funcCenterMiddlesSingles()
	funcTopPlacementYSingles()
	funcBottomPlacementYSingles()
	funcRightPlacementYSingles()
	funcLeftPlacementYSingles()
	funcGroupAndAlign()

	scribus.setUnit(origUnit)

'''For Singles, place the Title on the X axis'''
def funcTitlePlacementXSingles():
	'''Create working copy of global Placement variables'''
	strPlacementXt = strPlacementX
	strPlacementYt = strPlacementY

	'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
	if strFrameStyle == 'Internal':
		strFrameOuterWidthI = lstStampW[icnt]
		strFrameOuterHeightI = lstStampH[icnt]
	else:
		strFrameOuterWidthI = strFrameOuterWidth
		strFrameOuterHeightI = strFrameOuterHeight

	'''Add the Titles'''
	global shpTt
	global shpTb
	global shpTr
	global shpTl
	global shpTitleHot

	global shpS1t
	global shpS1b
	global shpS1r
	global shpS1l
	global shpS2t
	global shpS2b
	global shpS2r
	global shpS2l
	global shpS3t
	global shpS3b
	global shpS3r
	global shpS3l
	global shpS4t
	global shpS4b
	global shpS4r
	global shpS4l
	global shpS5t
	global shpS5b
	global shpS5r
	global shpS5l

	strTitleWidth = strFrameOuterWidthI * strTitleRatio / 100
	strTitleHeight = float(10)
	strTitleShift = ((strTitleWidth - strFrameOuterWidthI) / 2)
	if strLayoutTitle == 'Top':
		strTitleLeft = strPlacementXt - strTitleShift
		shpTt = scribus.createText(strTitleLeft, strPlacementYt, strTitleWidth, strTitleHeight, 'shpTt' + rnd)
		lstTopShp.append(shpTt)
		scribus.setText(strTitle, shpTt)
		shpTitleHot = shpTt
		if strStack1 == 'Title':
			shpS1t = shpTt
		elif strStack2 == 'Title':
			shpS2t = shpTt
		elif strStack3 == 'Title':
			shpS3t = shpTt
		elif strStack4 == 'Title':
			shpS4t = shpTt
		elif strStack5 == 'Title':
			shpS5t = shpTt
	elif strLayoutTitle == 'Bottom':
		strTitleLeft = strPlacementXt - strTitleShift
		shpTb = scribus.createText(strTitleLeft, strPlacementYt, strTitleWidth, strTitleHeight, 'shpTb' + rnd)
		lstBottomShp.append(shpTb)
		scribus.setText(strTitle, shpTb)
		shpTitleHot = shpTb
		if strStack1 == 'Title':
			shpS1b = shpTb
		elif strStack2 == 'Title':
			shpS2b = shpTb
		elif strStack3 == 'Title':
			shpS3b = shpTb
		elif strStack4 == 'Title':
			shpS4b = shpTb
		elif strStack5 == 'Title':
			shpS5b = shpTb
	elif strLayoutTitle == 'Right':
		strTitleLeft = strPlacementXt + strFrameOuterWidthI + strMarginRight
		shpTr = scribus.createText(strTitleLeft, strPlacementYt, strTitleWidth, strTitleHeight, 'shpTr' + rnd)
		lstRightShp.append(shpTr)
		scribus.setText(strTitle, shpTr)
		shpTitleHot = shpTr
		if strStack1 == 'Title':
			shpS1r = shpTr
		elif strStack2 == 'Title':
			shpS2r = shpTr
		elif strStack3 == 'Title':
			shpS3r = shpTr
		elif strStack4 == 'Title':
			shpS4r = shpTr
		elif strStack5 == 'Title':
			shpS5r = shpTr
	elif strLayoutTitle == 'Left':
		strTitleLeft = strPlacementXt - strMarginLeft - strTitleWidth
		shpTl = scribus.createText(strTitleLeft, strPlacementYt, strTitleWidth, strTitleHeight, 'shpTl' + rnd)
		lstLeftShp.append(shpTl)
		scribus.setText(strTitle, shpTl)
		shpTitleHot = shpTl
		if strStack1 == 'Title':
			shpS1l = shpTl
		elif strStack2 == 'Title':
			shpS2l = shpTl
		elif strStack3 == 'Title':
			shpS3l = shpTl
		elif strStack4 == 'Title':
			shpS4l = shpTl
		elif strStack5 == 'Title':
			shpS5l = shpTl
	if strTitleStyle == 'Global':
		TextLengthT = scribus.getTextLength(shpTitleHot)
		scribus.selectText(0,TextLengthT,shpTitleHot)
		scribus.setStyle("Title",shpTitleHot)
	else:
		scribus.setFont(strTitleFont, shpTitleHot)
		scribus.setFontSize(float(strTitleFontSize), shpTitleHot)
		if strTitleTextAlign == 'Left':
			scribus.setTextAlignment(0, shpTitleHot)
		elif strTitleTextAlign == "Center":
			scribus.setTextAlignment(1, shpTitleHot)
		elif strTitleTextAlign == 'Right':
			scribus.setTextAlignment(2, shpTitleHot)
		elif strTitleTextAlign == "Justified":
			scribus.setTextAlignment(3, shpTitleHot)	
		scribus.setLineSpacing(float(strTitleFontSize)*float(strTitleFontSpacing), shpTitleHot)
	if strTitleHyphen == 'TRUE':
		scribus.hyphenateText(shpTitleHot)
	(Tw, Th) = scribus.getSize(shpTitleHot)
	while (((scribus.textOverflows(shpTitleHot) == 0)) and (Th > 0)) :
		Th -= 1
		scribus.sizeObject(Tw, Th, shpTitleHot)
	while ((scribus.textOverflows(shpTitleHot) > 0)) :
		Th += 1
		scribus.sizeObject(Tw, Th, shpTitleHot)
	'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
	scribus.sizeObject(Tw, Th+1, shpTitleHot)
	lstTS.append(shpTitleHot)

'''For Singles, place the Date on the X axis'''
def funcDatePlacementXSingles():
	'''Create working copy of global Placement variables'''
	strPlacementXd = strPlacementX
	strPlacementYd = strPlacementY

	'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
	if strFrameStyle == 'Internal':
		strFrameOuterWidthI = lstStampW[icnt]
		strFrameOuterHeightI = lstStampH[icnt]
	else:
		strFrameOuterWidthI = strFrameOuterWidth
		strFrameOuterHeightI = strFrameOuterHeight

	'''Add the Dates'''
	global shpDt
	global shpDb
	global shpDr
	global shpDl
	global shpDateHot

	global shpS1t
	global shpS1b
	global shpS1r
	global shpS1l
	global shpS2t
	global shpS2b
	global shpS2r
	global shpS2l
	global shpS3t
	global shpS3b
	global shpS3r
	global shpS3l
	global shpS4t
	global shpS4b
	global shpS4r
	global shpS4l
	global shpS5t
	global shpS5b
	global shpS5r
	global shpS5l

	strDateWidth = strFrameOuterWidthI * strDateRatio / 100
	strDateHeight = float(10)
	strDateShift = ((strDateWidth - strFrameOuterWidthI) / 2)
	if strLayoutDate == 'Top':
		strDateLeft = strPlacementXd - strDateShift
		shpDt = scribus.createText(strDateLeft, strPlacementYd, strDateWidth, strDateHeight, 'shpDt' + rnd)
		scribus.setText(strDate, shpDt)
		lstTopShp.append(shpDt)
		shpDateHot = shpDt
		if strStack1 == 'Date':
			shpS1t = shpDt
		elif strStack2 == 'Date':
			shpS2t = shpDt
		elif strStack3 == 'Date':
			shpS3t = shpDt
		elif strStack4 == 'Date':
			shpS4t = shpDt
		elif strStack5 == 'Date':
			shpS5t = shpDt
	elif strLayoutDate == 'Bottom':
		strDateLeft = strPlacementXd - strDateShift
		shpDb = scribus.createText(strDateLeft, strPlacementYd, strDateWidth, strDateHeight, 'shpDb' + rnd)
		scribus.setText(strDate, shpDb)
		lstBottomShp.append(shpDb)
		shpDateHot = shpDb
		if strStack1 == 'Date':
			shpS1b = shpDb
		elif strStack2 == 'Date':
			shpS2b = shpDb
		elif strStack3 == 'Date':
			shpS3b = shpDb
		elif strStack4 == 'Date':
			shpS4b = shpDb
		elif strStack5 == 'Date':
			shpS5b = shpDb
	elif strLayoutDate == 'Right':
		strDateLeft = strPlacementXd + strFrameOuterWidthI + strMarginRight
		shpDr = scribus.createText(strDateLeft, strPlacementYd, strDateWidth, strDateHeight, 'shpDr' + rnd)
		scribus.setText(strDate, shpDr)
		lstRightShp.append(shpDr)
		shpDateHot = shpDr
		if strStack1 == 'Date':
			shpS1r = shpDr
		elif strStack2 == 'Date':
			shpS2r = shpDr
		elif strStack3 == 'Date':
			shpS3r = shpDr
		elif strStack4 == 'Date':
			shpS4r = shpDr
		elif strStack5 == 'Date':
			shpS5r = shpDr
	elif strLayoutDate == 'Left':
		strDateLeft = strPlacementXd - strMarginLeft - strDateWidth
		shpDl = scribus.createText(strDateLeft, strPlacementYd, strDateWidth, strDateHeight, 'shpDl' + rnd)
		scribus.setText(strDate, shpDl)
		lstLeftShp.append(shpDl)
		shpDateHot = shpDl
		if strStack1 == 'Date':
			shpS1l = shpDl
		elif strStack2 == 'Date':
			shpS2l = shpDl
		elif strStack3 == 'Date':
			shpS3l = shpDl
		elif strStack4 == 'Date':
			shpS4l = shpDl
		elif strStack5 == 'Date':
			shpS5l = shpDl
	if strDateStyle == 'Global':
		TextLengthD = scribus.getTextLength(shpDateHot)
		scribus.selectText(0,TextLengthD,shpDateHot)
		scribus.setStyle("Date",shpDateHot)
	else:
		scribus.setFont(strDateFont, shpDateHot)
		scribus.setFontSize(float(strDateFontSize), shpDateHot)
		if strDateTextAlign == 'Left':
			scribus.setTextAlignment(0, shpDateHot)
		elif strDateTextAlign == "Center":
			scribus.setTextAlignment(1, shpDateHot)
		elif strDateTextAlign == 'Right':
			scribus.setTextAlignment(2, shpDateHot)
		elif strDateTextAlign == "Justified":
			scribus.setTextAlignment(3, shpDateHot)	   
		scribus.setLineSpacing(float(strDateFontSize)*float(strDateFontSpacing), shpDateHot)
	if strDateHyphen == 'TRUE':
		scribus.hyphenateText(shpDateHot)
	(Dw, Dh) = scribus.getSize(shpDateHot)
	while (((scribus.textOverflows(shpDateHot) == 0)) and (Dh > 0)) :
		Dh -= 1
		scribus.sizeObject(Dw, Dh, shpDateHot)
	while ((scribus.textOverflows(shpDateHot) > 0)) :
		Dh += 1
		scribus.sizeObject(Dw, Dh, shpDateHot)
	'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
	scribus.sizeObject(Dw, Dh+1, shpDateHot)
	lstDS.append(shpDateHot)

'''For Singles, place the Catalog on the X axis'''
def funcKatalogPlacementXSingles():
	'''Create working copy of global Placement variables'''
	strPlacementXk = strPlacementX
	strPlacementYk = strPlacementY

	'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
	if strFrameStyle == 'Internal':
		strFrameOuterWidthI = lstStampW[icnt]
		strFrameOuterHeightI = lstStampH[icnt]
		global strKatalogRatio
		if strKatalogRatio > 90:
			strKatalogRatio = 90
	else:
		strFrameOuterWidthI = strFrameOuterWidth
		strFrameOuterHeightI = strFrameOuterHeight

	'''Add the Katalogs'''
	global shpKt
	global shpKb
	global shpKr
	global shpKl
	global shpKatalogHot

	global shpS1t
	global shpS1b
	global shpS1r
	global shpS1l
	global shpS2t
	global shpS2b
	global shpS2r
	global shpS2l
	global shpS3t
	global shpS3b
	global shpS3r
	global shpS3l
	global shpS4t
	global shpS4b
	global shpS4r
	global shpS4l
	global shpS5t
	global shpS5b
	global shpS5r
	global shpS5l

	strKatalogWidth = strFrameOuterWidthI * strKatalogRatio / 100
	strKatalogHeight = float(10)
	strKatalogShift = ((strKatalogWidth - strFrameOuterWidthI) / 2)
	if strLayoutKatalog == 'Top':
		strKatalogLeft = strPlacementXk - strKatalogShift
		shpKt = scribus.createText(strKatalogLeft, strPlacementYk, strKatalogWidth, strKatalogHeight, 'shpKt' + rnd)
		lstTopShp.append(shpKt)
		scribus.setText(strKatalog, shpKt)
		shpKatalogHot = shpKt
		if strStack1 == 'Catalog':
			shpS1t = shpKt
		elif strStack2 == 'Catalog':
			shpS2t = shpKt
		elif strStack3 == 'Catalog':
			shpS3t = shpKt
		elif strStack4 == 'Catalog':
			shpS4t = shpKt
		elif strStack5 == 'Catalog':
			shpS5t = shpKt
	elif strLayoutKatalog == 'Bottom':
		strKatalogLeft = strPlacementXk - strKatalogShift
		shpKb = scribus.createText(strKatalogLeft, strPlacementYk, strKatalogWidth, strKatalogHeight, 'shpKb' + rnd)
		lstBottomShp.append(shpKb)
		scribus.setText(strKatalog, shpKb)
		shpKatalogHot = shpKb
		if strStack1 == 'Catalog':
			shpS1b = shpKb
		elif strStack2 == 'Catalog':
			shpS2b = shpKb
		elif strStack3 == 'Catalog':
			shpS3b = shpKb
		elif strStack4 == 'Catalog':
			shpS4b = shpKb
		elif strStack5 == 'Catalog':
			shpS5b = shpKb
	elif strLayoutKatalog == 'Right':
		strKatalogLeft = strPlacementXk + strFrameOuterWidthI + strMarginRight
		shpKr = scribus.createText(strKatalogLeft, strPlacementYk, strKatalogWidth, strKatalogHeight, 'shpKr' + rnd)
		lstRightShp.append(shpKr)
		scribus.setText(strKatalog, shpKr)
		shpKatalogHot = shpKr
		if strStack1 == 'Catalog':
			shpS1r = shpKr
		elif strStack2 == 'Catalog':
			shpS2r = shpKr
		elif strStack3 == 'Catalog':
			shpS3r = shpKr
		elif strStack4 == 'Catalog':
			shpS4r = shpKr
		elif strStack5 == 'Catalog':
			shpS5r = shpKr
	elif strLayoutKatalog == 'Left':
		strKatalogLeft = strPlacementXk - strMarginLeft - strKatalogWidth
		shpKl = scribus.createText(strKatalogLeft, strPlacementYk, strKatalogWidth, strKatalogHeight, 'shpKl' + rnd)
		lstLeftShp.append(shpKl)
		scribus.setText(strKatalog, shpKl)
		shpKatalogHot = shpKl
		if strStack1 == 'Catalog':
			shpS1l = shpKl
		elif strStack2 == 'Catalog':
			shpS2l = shpKl
		elif strStack3 == 'Catalog':
			shpS3l = shpKl
		elif strStack4 == 'Catalog':
			shpS4l = shpKl
		elif strStack5 == 'Catalog':
			shpS5l = shpKl
	if strKatalogStyle == 'Global':
		TextLengthK = scribus.getTextLength(shpKatalogHot)
		scribus.selectText(0,TextLengthK,shpKatalogHot)
		scribus.setStyle("Katalog",shpKatalogHot)
	else:
		scribus.setFont(strKatalogFont, shpKatalogHot)
		scribus.setFontSize(float(strKatalogFontSize), shpKatalogHot)
		if strKatalogTextAlign == 'Left':
			scribus.setTextAlignment(0, shpKatalogHot)
		elif strKatalogTextAlign == "Center":
			scribus.setTextAlignment(1, shpKatalogHot)
		elif strKatalogTextAlign == 'Right':
			scribus.setTextAlignment(2, shpKatalogHot)
		elif strKatalogTextAlign == "Justified":
			scribus.setTextAlignment(3, shpKatalogHot)	  
		scribus.setLineSpacing(float(strKatalogFontSize)*float(strKatalogFontSpacing), shpKatalogHot)
	if strKatalogHyphen == 'TRUE':
		scribus.hyphenateText(shpKatalogHot)
	(Kw, Kh) = scribus.getSize(shpKatalogHot)
	while (((scribus.textOverflows(shpKatalogHot) == 0)) and (Kh > 0)) :
		Kh -= 1
		scribus.sizeObject(Kw, Kh, shpKatalogHot)
	while ((scribus.textOverflows(shpKatalogHot) > 0)) :
		Kh += 1
		scribus.sizeObject(Kw, Kh, shpKatalogHot)
	'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
	scribus.sizeObject(Kw, Kh+1, shpKatalogHot)
	lstKS.append(shpKatalogHot)

'''For Singles, place the Face Value on the X axis'''
def funcFacePlacementXSingles():
	'''Create working copy of global Placement variables'''
	strPlacementXf = strPlacementX
	strPlacementYf = strPlacementY

	'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
	if strFrameStyle == 'Internal':
		strFrameOuterWidthI = lstStampW[icnt]
		strFrameOuterHeightI = lstStampH[icnt]
		global strFaceRatio
		if strFaceRatio > 90:
			strFaceRatio = 90
	else:
		strFrameOuterWidthI = strFrameOuterWidth
		strFrameOuterHeightI = strFrameOuterHeight

	'''Add the Face Value'''
	global shpFt
	global shpFb
	global shpFr
	global shpFl
	global shpFaceHot

	global shpS1t
	global shpS1b
	global shpS1r
	global shpS1l
	global shpS2t
	global shpS2b
	global shpS2r
	global shpS2l
	global shpS3t
	global shpS3b
	global shpS3r
	global shpS3l
	global shpS4t
	global shpS4b
	global shpS4r
	global shpS4l
	global shpS5t
	global shpS5b
	global shpS5r
	global shpS5l

	strFaceWidth = strFrameOuterWidthI * strFaceRatio / 100
	strFaceHeight = float(10)
	strFaceShift = ((strFaceWidth - strFrameOuterWidthI) / 2)
	if strLayoutFace == 'Top':
		strFaceLeft = strPlacementXf - strFaceShift
		shpFt = scribus.createText(strFaceLeft, strPlacementYf, strFaceWidth, strFaceHeight, 'shpFt' + rnd)
		lstTopShp.append(shpFt)
		scribus.setText(strFace, shpFt)
		shpFaceHot = shpFt
		if strStack1 == 'Face Value':
			shpS1t = shpFt
		elif strStack2 == 'Face Value':
			shpS2t = shpFt
		elif strStack3 == 'Face Value':
			shpS3t = shpFt
		elif strStack4 == 'Face Value':
			shpS4t = shpFt
		elif strStack5 == 'Face Value':
			shpS5t = shpFt
	elif strLayoutFace == 'Bottom':
		strFaceLeft = strPlacementXf - strFaceShift
		shpFb = scribus.createText(strFaceLeft, strPlacementYf, strFaceWidth, strFaceHeight, 'shpFb' + rnd)
		lstBottomShp.append(shpFb)
		scribus.setText(strFace, shpFb)
		shpFaceHot = shpFb
		if strStack1 == 'Face Value':
			shpS1b = shpFb
		elif strStack2 == 'Face Value':
			shpS2b = shpFb
		elif strStack3 == 'Face Value':
			shpS3b = shpFb
		elif strStack4 == 'Face Value':
			shpS4b = shpFb
		elif strStack5 == 'Face Value':
			shpS5b = shpFb
	elif strLayoutFace == 'Right':
		strFaceLeft = strPlacementXf + strFrameOuterWidthI + strMarginRight
		shpFr = scribus.createText(strFaceLeft, strPlacementYf, strFaceWidth, strFaceHeight, 'shpFr' + rnd)
		lstRightShp.append(shpFr)
		scribus.setText(strFace, shpFr)
		shpFaceHot = shpFr
		if strStack1 == 'Face Value':
			shpS1r = shpFr
		elif strStack2 == 'Face Value':
			shpS2r = shpFr
		elif strStack3 == 'Face Value':
			shpS3r = shpFr
		elif strStack4 == 'Face Value':
			shpS4r = shpFr
		elif strStack5 == 'Face Value':
			shpS5r = shpFr
	elif strLayoutFace == 'Left':
		strFaceLeft = strPlacementXf - strMarginLeft - strFaceWidth
		shpFl = scribus.createText(strFaceLeft, strPlacementYf, strFaceWidth, strFaceHeight, 'shpFl' + rnd)
		lstLeftShp.append(shpFl)
		scribus.setText(strFace, shpFl)
		shpFaceHot = shpFl
		if strStack1 == 'Face Value':
			shpS1l = shpFl
		elif strStack2 == 'Face Value':
			shpS2l = shpFl
		elif strStack3 == 'Face Value':
			shpS3l = shpFl
		elif strStack4 == 'Face Value':
			shpS4l = shpFl
		elif strStack5 == 'Face Value':
			shpS5l = shpFl
	if strFaceStyle == 'Global':
		TextLengthF = scribus.getTextLength(shpFaceHot)
		scribus.selectText(0,TextLengthF,shpFaceHot)
		scribus.setStyle("Face",shpFaceHot)
	elif strFaceStyle == 'Global - Small Caps':
		TextLengthF = scribus.getTextLength(shpFaceHot)
		scribus.selectText(0,TextLengthF,shpFaceHot)
		scribus.setStyle("FaceSC",shpFaceHot)
	else:
		scribus.setFont(strFaceFont, shpFaceHot)
		scribus.setFontSize(float(strFaceFontSize), shpFaceHot)
		if strFaceTextAlign == 'Left':
			scribus.setTextAlignment(0, shpFaceHot)
		elif strFaceTextAlign == "Center":
			scribus.setTextAlignment(1, shpFaceHot)
		elif strFaceTextAlign == 'Right':
			scribus.setTextAlignment(2, shpFaceHot)
		elif strFaceTextAlign == "Justified":
			scribus.setTextAlignment(3, shpFaceHot)	  
		scribus.setLineSpacing(float(strFaceFontSize)*float(strFaceFontSpacing), shpFaceHot)
	if strFaceHyphen == 'TRUE':
		scribus.hyphenateText(shpFaceHot)
	(Fw, Fh) = scribus.getSize(shpFaceHot)
	while (((scribus.textOverflows(shpFaceHot) == 0)) and (Fh > 0)) :
		Fh -= 1
		scribus.sizeObject(Fw, Fh, shpFaceHot)
	while ((scribus.textOverflows(shpFaceHot) > 0)) :
		Fh += 1
		scribus.sizeObject(Fw, Fh, shpFaceHot)
	'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
	scribus.sizeObject(Fw, Fh+1, shpFaceHot)
	lstFS.append(shpFaceHot)

'''For Singles, place the Caption on the X axis'''
def funcCaptionPlacementXSingles():
	'''Create working copy of global Placement variables'''
	strPlacementXc = strPlacementX
	strPlacementYc = strPlacementY

	'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
	if strFrameStyle == 'Internal':
		strFrameOuterWidthI = lstStampW[icnt]
		strFrameOuterHeightI = lstStampH[icnt]
	else:
		strFrameOuterWidthI = strFrameOuterWidth
		strFrameOuterHeightI = strFrameOuterHeight

	'''Add the Captions'''
	global shpCt
	global shpCb
	global shpCr
	global shpCl
	global shpCaptionHot

	global shpS1t
	global shpS1b
	global shpS1r
	global shpS1l
	global shpS2t
	global shpS2b
	global shpS2r
	global shpS2l
	global shpS3t
	global shpS3b
	global shpS3r
	global shpS3l
	global shpS4t
	global shpS4b
	global shpS4r
	global shpS4l
	global shpS5t
	global shpS5b
	global shpS5r
	global shpS5l

	strCaptionWidth = strFrameOuterWidthI * strCaptionRatio / 100
	strCaptionHeight = float(10)
	strCaptionShift = ((strCaptionWidth - strFrameOuterWidthI) / 2)
	if strLayoutCaption == 'Top':
		strCaptionLeft = strPlacementXc - strCaptionShift
		shpCt = scribus.createText(strCaptionLeft, strPlacementYc, strCaptionWidth, strCaptionHeight, 'shpCt' + rnd)
		lstTopShp.append(shpCt)
		scribus.setText(strCaption, shpCt)
		shpCaptionHot = shpCt
		if strStack1 == 'Caption':
			shpS1t = shpCt
		elif strStack2 == 'Caption':
			shpS2t = shpCt
		elif strStack3 == 'Caption':
			shpS3t = shpCt
		elif strStack4 == 'Caption':
			shpS4t = shpCt
		elif strStack5 == 'Caption':
			shpS5t = shpCt
	elif strLayoutCaption == 'Bottom':
		strCaptionLeft = strPlacementXc - strCaptionShift
		shpCb = scribus.createText(strCaptionLeft, strPlacementYc, strCaptionWidth, strCaptionHeight, 'shpCb' + rnd)
		lstBottomShp.append(shpCb)
		scribus.setText(strCaption, shpCb)
		shpCaptionHot = shpCb
		if strStack1 == 'Caption':
			shpS1b = shpCb
		elif strStack2 == 'Caption':
			shpS2b = shpCb
		elif strStack3 == 'Caption':
			shpS3b = shpCb
		elif strStack4 == 'Caption':
			shpS4b = shpCb
		elif strStack5 == 'Caption':
			shpS5b = shpCb
	elif strLayoutCaption == 'Right':
		strCaptionLeft = strPlacementXc + strFrameOuterWidthI + strMarginRight
		shpCr = scribus.createText(strCaptionLeft, strPlacementYc, strCaptionWidth, strCaptionHeight, 'shpCr' + rnd)
		lstRightShp.append(shpCr)
		scribus.setText(strCaption, shpCr)
		shpCaptionHot = shpCr
		if strStack1 == 'Caption':
			shpS1r = shpCr
		elif strStack2 == 'Caption':
			shpS2r = shpCr
		elif strStack3 == 'Caption':
			shpS3r = shpCr
		elif strStack4 == 'Caption':
			shpS4r = shpCr
		elif strStack5 == 'Caption':
			shpS5r = shpCr
	elif strLayoutCaption == 'Left':
		strCaptionLeft = strPlacementXc - strMarginLeft - strCaptionWidth
		shpCl = scribus.createText(strCaptionLeft, strPlacementYc, strCaptionWidth, strCaptionHeight, 'shpCl' + rnd)
		lstLeftShp.append(shpCl)
		scribus.setText(strCaption, shpCl)
		shpCaptionHot = shpCl
		if strStack1 == 'Caption':
			shpS1l = shpCl
		elif strStack2 == 'Caption':
			shpS2l = shpCl
		elif strStack3 == 'Caption':
			shpS3l = shpCl
		elif strStack4 == 'Caption':
			shpS4l = shpCl
		elif strStack5 == 'Caption':
			shpS5l = shpCl
	if strCaptionStyle == 'Global':
		TextLengthC = scribus.getTextLength(shpCaptionHot)
		scribus.selectText(0,TextLengthC,shpCaptionHot)
		scribus.setStyle("Caption",shpCaptionHot)
	else:
		scribus.setFont(strCaptionFont, shpCaptionHot)
		scribus.setFontSize(float(strCaptionFontSize), shpCaptionHot)
		if strCaptionTextAlign == 'Left':
			scribus.setTextAlignment(0, shpCaptionHot)
		elif strCaptionTextAlign == "Center":
			scribus.setTextAlignment(1, shpCaptionHot)
		elif strCaptionTextAlign == 'Right':
			scribus.setTextAlignment(2, shpCaptionHot)
		elif strCaptionTextAlign == "Justified":
			scribus.setTextAlignment(3, shpCaptionHot)	  
		scribus.setLineSpacing(float(strCaptionFontSize)*float(strCaptionFontSpacing), shpCaptionHot)
	if strCaptionHyphen == 'TRUE':
		scribus.hyphenateText(shpCaptionHot)
	(Cw, Ch) = scribus.getSize(shpCaptionHot)
	while (((scribus.textOverflows(shpCaptionHot) == 0)) and (Ch > 0)) :
		Ch -= 1
		scribus.sizeObject(Cw, Ch, shpCaptionHot)
	while ((scribus.textOverflows(shpCaptionHot) > 0)) :
		Ch += 1
		scribus.sizeObject(Cw, Ch, shpCaptionHot)
	'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
	scribus.sizeObject(Cw, Ch+1, shpCaptionHot)
	lstCS.append(shpCaptionHot)

'''For Singles, place the Top text boxes on the Y axis'''
def funcTopPlacementYSingles():
	if strFrameStyle == 'Internal':
		strTempY = scribus.getProperty(shpFo, "yPos") - (((scribus.getProperty(shpFo, "height") * 100/90) - \
		scribus.getProperty(shpFo, "height")) / 2) - strMarginTop
	else:
		strTempY = scribus.getProperty(shpFo, "yPos") - strMarginTop

	if scribus.objectExists(shpS5t):
		scribus.setProperty(shpS5t, "yPos", strTempY - scribus.getProperty(shpS5t, "height"))
		strTempY = scribus.getProperty(shpS5t, "yPos") - strVerticalSpacing
	if scribus.objectExists(shpS4t):
		scribus.setProperty(shpS4t, "yPos", strTempY - scribus.getProperty(shpS4t, "height"))
		strTempY = scribus.getProperty(shpS4t, "yPos") - strVerticalSpacing
	if scribus.objectExists(shpS3t):
		scribus.setProperty(shpS3t, "yPos", strTempY - scribus.getProperty(shpS3t, "height"))
		strTempY = scribus.getProperty(shpS3t, "yPos") - strVerticalSpacing
	if scribus.objectExists(shpS2t):
		scribus.setProperty(shpS2t, "yPos", strTempY - scribus.getProperty(shpS2t, "height"))
		strTempY = scribus.getProperty(shpS2t, "yPos") - strVerticalSpacing
	if scribus.objectExists(shpS1t):
		scribus.setProperty(shpS1t, "yPos", strTempY - scribus.getProperty(shpS1t, "height"))

'''For Singles, place the Bottom text boxes on the Y axis'''
def funcBottomPlacementYSingles():
	'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
	if strFrameStyle == 'Internal':
		strFrameOuterHeightI = lstStampH[icnt]
		strTempY = scribus.getProperty(shpFo, "yPos") - (((scribus.getProperty(shpFo, "height") * 100/90) - \
		scribus.getProperty(shpFo, "height")) / 2) + strFrameOuterHeightI + strMarginBottom
	else:
		strFrameOuterHeightI = strFrameOuterHeight
		strTempY = scribus.getProperty(shpFo, "yPos") + strFrameOuterHeightI + strMarginBottom

	if strStyle == 'Outside':
		if scribus.objectExists(shpS1b):
			scribus.setProperty(shpS1b, "yPos", strTempY)
			strTempY = scribus.getProperty(shpS1b, "yPos") + scribus.getProperty(shpS1b, "height") + strVerticalSpacing
		if scribus.objectExists(shpS2b):
			scribus.setProperty(shpS2b, "yPos", strTempY)
			strTempY = scribus.getProperty(shpS2b, "yPos") + scribus.getProperty(shpS2b, "height") + strVerticalSpacing
		if scribus.objectExists(shpS3b):
			scribus.setProperty(shpS3b, "yPos", strTempY)
			strTempY = scribus.getProperty(shpS3b, "yPos") + scribus.getProperty(shpS3b, "height") + strVerticalSpacing
		if scribus.objectExists(shpS4b):
			scribus.setProperty(shpS4b, "yPos", strTempY)
			strTempY = scribus.getProperty(shpS4b, "yPos") + scribus.getProperty(shpS4b, "height") + strVerticalSpacing
		if scribus.objectExists(shpS5b):
			scribus.setProperty(shpS5b, "yPos", strTempY)
			strTempY = scribus.getProperty(shpS5b, "yPos") + scribus.getProperty(shpS5b, "height") + strVerticalSpacing
	elif strStyle == 'Inside - Catalog':
		if scribus.objectExists('shpKb' + rnd):
			if strFrameStyle == 'Internal':
				scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") - \
				(((scribus.getProperty(shpFo, "height") * 100/90) - scribus.getProperty(shpFo, "height")) / 2) + \
				(lstStampH[icnt] / 2) - (scribus.getProperty(shpKb, "height") / 2))
			else:
				scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") + strFrameOffset + \
				strPaddingTop + (lstStampH[icnt] / 2) - (scribus.getProperty(shpKb, "height") / 2))	
	elif strStyle == 'Inside - Face Value':
		if scribus.objectExists('shpFb' + rnd):
			if strFrameStyle == 'Internal':
				scribus.setProperty(shpFb, "yPos", scribus.getProperty(shpFo, "yPos") - \
				(((scribus.getProperty(shpFo, "height") * 100/90) - scribus.getProperty(shpFo, "height")) / 2) + \
				(lstStampH[icnt] / 2) - (scribus.getProperty(shpFb, "height") / 2))
			else:
				scribus.setProperty(shpFb, "yPos", scribus.getProperty(shpFo, "yPos") + strFrameOffset + \
				strPaddingTop + (lstStampH[icnt] / 2) - (scribus.getProperty(shpFb, "height") / 2))	
	elif strStyle == 'Outside/Inside':
		if scribus.objectExists(shpS1b) and shpS1b != 'shpKb' + rnd:
			scribus.setProperty(shpS1b, "yPos", strTempY)
			strTempY = scribus.getProperty(shpS1b, "yPos") + scribus.getProperty(shpS1b, "height") + strVerticalSpacing
		if scribus.objectExists(shpS2b) and shpS2b != 'shpKb' + rnd:
			scribus.setProperty(shpS2b, "yPos", strTempY)
			strTempY = scribus.getProperty(shpS2b, "yPos") + scribus.getProperty(shpS2b, "height") + strVerticalSpacing
		if scribus.objectExists(shpS3b) and shpS3b != 'shpKb' + rnd:
			scribus.setProperty(shpS3b, "yPos", strTempY)
			strTempY = scribus.getProperty(shpS3b, "yPos") + scribus.getProperty(shpS3b, "height") + strVerticalSpacing
		if scribus.objectExists(shpS4b) and shpS4b != 'shpKb' + rnd:
			scribus.setProperty(shpS4b, "yPos", strTempY)
			strTempY = scribus.getProperty(shpS4b, "yPos") + scribus.getProperty(shpS4b, "height") + strVerticalSpacing
		if scribus.objectExists(shpS5b) and shpS5b != 'shpKb' + rnd:
			scribus.setProperty(shpS5b, "yPos", strTempY)
			strTempY = scribus.getProperty(shpS5b, "yPos") + scribus.getProperty(shpS5b, "height") + strVerticalSpacing
		if scribus.objectExists('shpKb' + rnd):
			scribus.setProperty(shpKb, "yPos", scribus.getProperty(shpFo, "yPos") + \
			strFrameOffset + strPaddingTop + lstPhotoH[icnt] + strOISpacing)

'''For Singles, place the Right text boxes on the Y axis'''
def funcRightPlacementYSingles():
	strFrameOuterHeightI = strFrameOuterHeight
	strVertOffset = (strFrameOuterHeightI - strRightOverallHeight) / 2
	strTempY = scribus.getProperty(shpFo, "yPos") + strVertOffset
	if scribus.objectExists(shpS1r):
		scribus.setProperty(shpS1r, "yPos", strTempY)
		strTempY = scribus.getProperty(shpS1r, "yPos") + scribus.getProperty(shpS1r, "height") + strVerticalSpacing
	if scribus.objectExists(shpS2r):
		scribus.setProperty(shpS2r, "yPos", strTempY)
		strTempY = scribus.getProperty(shpS2r, "yPos") + scribus.getProperty(shpS2r, "height") + strVerticalSpacing
	if scribus.objectExists(shpS3r):
		scribus.setProperty(shpS3r, "yPos", strTempY)
		strTempY = scribus.getProperty(shpS3r, "yPos") + scribus.getProperty(shpS3r, "height") + strVerticalSpacing
	if scribus.objectExists(shpS4r):
		scribus.setProperty(shpS4r, "yPos", strTempY)
		strTempY = scribus.getProperty(shpS4r, "yPos") + scribus.getProperty(shpS4r, "height") + strVerticalSpacing
	if scribus.objectExists(shpS5r):
		scribus.setProperty(shpS5r, "yPos", strTempY)

'''For Singles, place the Left text boxes on the Y axis'''
def funcLeftPlacementYSingles():
	strFrameOuterHeightI = strFrameOuterHeight
	strVertOffset = (strFrameOuterHeightI - strLeftOverallHeight) / 2
	strTempY = scribus.getProperty(shpFo, "yPos") + strVertOffset
	if scribus.objectExists(shpS1l):
		scribus.setProperty(shpS1l, "yPos", strTempY)
		strTempY = scribus.getProperty(shpS1l, "yPos") + scribus.getProperty(shpS1l, "height") + strVerticalSpacing
	if scribus.objectExists(shpS2l):
		scribus.setProperty(shpS2l, "yPos", strTempY)
		strTempY = scribus.getProperty(shpS2l, "yPos") + scribus.getProperty(shpS2l, "height") + strVerticalSpacing
	if scribus.objectExists(shpS3l):
		scribus.setProperty(shpS3l, "yPos", strTempY)
		strTempY = scribus.getProperty(shpS3l, "yPos") + scribus.getProperty(shpS3l, "height") + strVerticalSpacing
	if scribus.objectExists(shpS4l):
		scribus.setProperty(shpS4l, "yPos", strTempY)
		strTempY = scribus.getProperty(shpS4l, "yPos") + scribus.getProperty(shpS4l, "height") + strVerticalSpacing
	if scribus.objectExists(shpS5l):
		scribus.setProperty(shpS5l, "yPos", strTempY)

def funcCenterMiddlesSingles():
	'''For text boxes on Left and Right, center them vertically on the frame'''
	intLe = len(lstLeftShp)
	intLeG = len(lstLeftShpG)
	global strLeftOverallHeight
	global strLeftOverallHeightG
	Bh = 0
	BhG = 0

	if scribus.objectExists(shpS1l):
		intH = scribus.getProperty(shpS1l, "height")
		Bh = Bh + intH
	if scribus.objectExists(shpS2l):
		intH = scribus.getProperty(shpS2l, "height")
		Bh = Bh + intH
	if scribus.objectExists(shpS3l):
		intH = scribus.getProperty(shpS3l, "height")
		Bh = Bh + intH
	if scribus.objectExists(shpS4l):
		intH = scribus.getProperty(shpS4l, "height")
		Bh = Bh + intH
	if scribus.objectExists(shpS5l):
		intH = scribus.getProperty(shpS5l, "height")
		Bh = Bh + intH

	strLeftOverallHeight = Bh + ((intLe - 1) * strVerticalSpacing)
	strLeftOverallHeightG = BhG + ((intLeG - 1) * strVerticalSpacing)

	intRe = len(lstRightShp)
	intReG = len(lstRightShpG)
	global strRightOverallHeight
	global strRightOverallHeightG
	Bk = 0
	BkG = 0

	if scribus.objectExists(shpS1r):
		intK = scribus.getProperty(shpS1r, "height")
		Bk = Bk + intK
	if scribus.objectExists(shpS2r):
		intK = scribus.getProperty(shpS2r, "height")
		Bk = Bk + intK
	if scribus.objectExists(shpS3r):
		intK = scribus.getProperty(shpS3r, "height")
		Bk = Bk + intK
	if scribus.objectExists(shpS4r):
		intK = scribus.getProperty(shpS4r, "height")
		Bk = Bk + intK
	if scribus.objectExists(shpS5r):
		intK = scribus.getProperty(shpS5r, "height")
		Bk = Bk + intK

	strRightOverallHeight = Bk + ((intRe - 1) * strVerticalSpacing)
	strRightOverallHeightG = BkG + ((intReG - 1) * strVerticalSpacing)

def funcSetCalc():	  
	'''Store max height/width of stamps in set, and aggregate height/width'''
	global strSetMaxH
	global strSetMaxW
	global strSetTotH
	global strSetTotW
	global strSetCount
	global strSetMaxI
	if strSetOrientation == 'Horizontal':
		if lstStampH[icnt] > strSetMaxH:
			strSetMaxH = lstStampH[icnt]
			strSetMaxI = icnt
		strSetTotW = strSetTotW + lstStampW[icnt]
	else:
		if lstStampW[icnt] > strSetMaxW:
			strSetMaxW = lstStampW[icnt]
			strSetMaxI = icnt
		strSetTotH = strSetTotH + lstStampH[icnt]
	strSetCount += 1

def funcGenerateSetFrameGrouped():   
	global strFrameInnerHeight
	global strFrameInnerWidth
	global strFrameOuterHeight
	global strFrameOuterWidth

	if strSetOrientation == 'Horizontal':
		strFrameInnerHeight = strSetMaxH + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2)
		strFrameInnerWidth = strSetTotW + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2) + ((strSetCount - 1) * strSetSpacing)
		strFrameOuterHeight = strSetMaxH + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
		strFrameOuterWidth = strSetTotW + strPaddingLeft + strPaddingRight + (strFrameOffset * 2) + ((strSetCount - 1) * strSetSpacing)
	else:
		strFrameInnerHeight = strSetTotH + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2) + ((strSetCount - 1) * strSetSpacing)
		strFrameInnerWidth = strSetMaxW + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2)
		strFrameOuterHeight = strSetTotH + strPaddingTop + strPaddingBottom + (strFrameOffset * 2) + ((strSetCount - 1) * strSetSpacing)
		strFrameOuterWidth = strSetMaxW + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)

	'''Set default placement to page center'''
	global strPlacementX
	global strPlacementY
	global strPlacementXo
	global strPlacementYo

	pageWidth, pageHeight = scribus.getPageSize()
	topMargin, leftMargin, rightMargin, bottomMargin = scribus.getPageMargins()
	
	global printAreaWidth
	global printAreaHeight
	printAreaWidth = pageWidth - leftMargin - rightMargin
	printAreaHeight = pageHeight - topMargin - bottomMargin 
	
	strPlacementX = (round(float((printAreaWidth - strFrameOuterWidth)/2 + leftMargin),4))
	strPlacementY = (round(float((printAreaHeight - strFrameOuterHeight)/2 + topMargin),4))
	strPlacementXo = strPlacementX
	strPlacementYo = strPlacementY

	global shpFo

	'''Draw the frame'''
	if strFrameDouble == 'TRUE':
		shpFo = scribus.createRect(strPlacementX + (strFrameThicknessOuter / 2), \
		strPlacementY + (strFrameThicknessOuter / 2), (strFrameOuterWidth - strFrameThicknessOuter), \
		(strFrameOuterHeight - strFrameThicknessOuter), 'shpFo' + lstRndGrp[0])
		scribus.setLineWidth(strFrameThicknessOuter, shpFo)
		lstFo.append(shpFo)

		global shpFi
		shpFi = scribus.createRect(strPlacementX + (strFrameThicknessInner / 2), \
		strPlacementY + (strFrameThicknessInner / 2), (strFrameInnerWidth - strFrameThicknessInner), \
		(strFrameInnerHeight - strFrameThicknessInner), 'shpFi' + lstRndGrp[0])
		scribus.setLineWidth(strFrameThicknessInner, shpFi)
		scribus.setLineShade(int(strFrameShadingInner),shpFi)
		lstFi.append(shpFi)

		strFrameAlignOffset = strFrameThicknessOuter + strFrameSpacing
		scribus.setProperty(shpFi, "xPos", scribus.getProperty(shpFi, "xPos") + strFrameAlignOffset)
		scribus.setProperty(shpFi, "yPos", scribus.getProperty(shpFi, "yPos") + strFrameAlignOffset)
	else:
		shpFo = scribus.createRect(strPlacementX + (strFrameThicknessOuter / 2), \
		strPlacementY + (strFrameThicknessOuter / 2), (strFrameOuterWidth - strFrameThicknessOuter), \
		(strFrameOuterHeight - strFrameThicknessOuter), 'shpFo' + lstRndGrp[0])
		scribus.setLineWidth(strFrameThicknessOuter, shpFo)
		lstFo.append(shpFo)
	
	global strGroupedFrameTop
	global strGroupedFrameBottom
	global strGroupedFrameLeft
	global strGroupedFrameRight
	strGroupedFrameTop = scribus.getProperty(shpFo, "yPos")
	strGroupedFrameBottom = scribus.getProperty(shpFo, "yPos") + scribus.getProperty(shpFo, "height")
	strGroupedFrameLeft = scribus.getProperty(shpFo, "xPos")
	strGroupedFrameRight = scribus.getProperty(shpFo, "xPos") + scribus.getProperty(shpFo, "width")

def funcGenerateSetFrameGroupedPhotos():
	'''Create working copy of global Placement variables'''
	strPlacementXp = strGroupedFrameLeft
	strPlacementYp = strGroupedFrameTop

	'''Add the photos'''
	pcnt = 0
	while pcnt < strSetCount:
		if strSetOrientation == 'Horizontal':
			if lstPhoto[pcnt] == 'NullField':
				if pcnt == 0:
					strPlacementXp = strPlacementXp + strFrameOffset + strPaddingLeft + lstStampW[pcnt]
				else:
					strPlacementXp = strPlacementXp + strSetSpacing + lstStampW[pcnt]
			else:
				if pcnt == 0:
					strPlacementXp = strPlacementXp + strFrameOffset + strPaddingLeft
				else:
					strPlacementXp = strPlacementXp + strSetSpacing
				shpP = scribus.createImage(strPlacementXp, strPlacementYp, lstPhotoW[pcnt], lstPhotoH[pcnt], 'shpP' + lstRndGrp[pcnt])
				strPhotoAlignOffsetX = ((lstStampW[pcnt] - lstPhotoW[pcnt]) / 2)
				scribus.setProperty(shpP, "xPos", strPlacementXp + strPhotoAlignOffsetX)
				strPhotoAlignOffsetY = strPaddingTop + strFrameOffset + ((strSetMaxH - lstStampH[pcnt]) / 2) + ((lstStampH[pcnt] - lstPhotoH[pcnt]) / 2)
				scribus.setProperty(shpP, "yPos", strPlacementYp + strPhotoAlignOffsetY)
				scribus.loadImage(lstPhoto[pcnt], shpP)
				scribus.setScaleImageToFrame(True, True, shpP)
				if strPhotoGreyscale == 'TRUE':
					scribus.setImageGrayscale(shpP)
				lstPS.append(shpP) 
				strPlacementXp = strPlacementXp + lstStampW[pcnt]
		else:
			if lstPhoto[pcnt] == 'NullField':
				if pcnt == 0:
					strPlacementYp = strPlacementYp + strFrameOffset + strPaddingTop + lstStampH[pcnt]
				else:
					strPlacementYp = strPlacementYp + strSetSpacing + lstStampH[pcnt]
			else:
				if pcnt == 0:
					strPlacementYp = strPlacementYp + strFrameOffset + strPaddingTop
				else:
					strPlacementYp = strPlacementYp + strSetSpacing
				shpP = scribus.createImage(strPlacementXp, strPlacementYp, lstPhotoW[pcnt], lstPhotoH[pcnt], 'shpP' + lstRndGrp[pcnt])
				strPhotoAlignOffsetX = strFrameOffset + strPaddingLeft + ((strSetMaxW - lstStampW[pcnt]) / 2) + ((lstStampW[pcnt] - lstPhotoW[pcnt]) / 2)
				scribus.setProperty(shpP, "xPos", strPlacementXp + strPhotoAlignOffsetX)
				strPhotoAlignOffsetY = ((lstStampH[pcnt] - lstPhotoH[pcnt]) / 2)
				scribus.setProperty(shpP, "yPos", strPlacementYp + strPhotoAlignOffsetY)
				scribus.loadImage(lstPhoto[pcnt], shpP)
				scribus.setScaleImageToFrame(True, True, shpP)
				if strPhotoGreyscale == 'TRUE':
					scribus.setImageGrayscale(shpP)
				lstPS.append(shpP) 
				strPlacementYp = strPlacementYp + lstStampH[pcnt]
		pcnt += 1

def funcGenerateSetFrameGroupedText():
	global strPlacementXb
	global strPlacementYb
	
	strPlacementXb = strPlacementX
	strPlacementYb = strPlacementY
	
	global strTitleInclude
	global strDateInclude
	global strKatalogInclude
	global strFaceInclude
	global strCaptionInclude

	global gcnt
	gcnt = 0
	
	while gcnt < strSetCount:
		'''Set new placement starting point if using individual Titles with group frame'''
		if strSetOrientation == 'Horizontal':
			if gcnt == 0:
				strPlacementYb = scribus.getProperty(shpFo, "yPos")
				strPlacementXb = strPlacementXb + strFrameOffset + strPaddingLeft
		else:
			if gcnt == 0:
				strPlacementYb = scribus.getProperty(shpFo, "yPos")
				strPlacementYb = strPlacementYb + strFrameOffset + strPaddingTop

		strTitleInclude = strTitleIncludeP
		strDateInclude = strDateIncludeP
		strKatalogInclude = strKatalogIncludeP
		strFaceInclude = strFaceIncludeP
		strCaptionInclude = strCaptionIncludeP
	
		if lstTitle[gcnt] == 'NullField':
			strTitleInclude = 'FALSE'
		if lstDate[gcnt] == 'NullField':
			strDateInclude = 'FALSE'
		if lstKatalog[gcnt] == 'NullField':
			strKatalogInclude = 'FALSE'
		if lstFace[gcnt] == 'NullField':
			strFaceInclude = 'FALSE'
		if lstCaption[gcnt] == 'NullField':
			strCaptionInclude = 'FALSE'

		if strTitleInclude == 'TRUE':
			funcTitlePlacementXFrameGrouped()
		if strDateInclude == 'TRUE':
			funcDatePlacementXFrameGrouped()
		if strKatalogInclude == 'TRUE':
			funcKatalogPlacementXFrameGrouped()
		if strFaceInclude == 'TRUE':
			funcFacePlacementXFrameGrouped()
		if strCaptionInclude == 'TRUE':
			funcCaptionPlacementXFrameGrouped()
		funcTopPlacementYFrameGrouped()
		funcBottomPlacementYFrameGrouped()
		funcCenterMiddlesFrameGrouped()
		funcRightPlacementYFrameGrouped()
		funcLeftPlacementYFrameGrouped()

		if strSetOrientation == 'Horizontal':
			strPlacementXb = strPlacementXb + lstStampW[gcnt] + strSetSpacing 
		else:
			strPlacementYb = strPlacementYb + lstStampH[gcnt] + strSetSpacing 

		gcnt += 1

def funcTitlePlacementXFrameGrouped():
	'''Create working copy of global Placement variables'''
	strPlacementXt = strPlacementXb

	'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
	if strFrameStyle == 'Internal':
		strFrameOuterWidthI = lstStampW[gcnt]
		strFrameOuterHeightI = lstStampH[gcnt]
	else:
		strFrameOuterWidthI = strFrameOuterWidth
		strFrameOuterHeightI = strFrameOuterHeight

	'''Substitute stamp width for frame width when building individual components of set'''
	if strSetOrientation == 'Horizontal':
		strFrameOuterWidthI = lstStampW[gcnt]

	'''Add the Titles'''
	global shpTt
	global shpTb
	global shpTr
	global shpTl
	global shpTitleHot

	global shpS1t
	global shpS1b
	global shpS1r
	global shpS1l
	global shpS2t
	global shpS2b
	global shpS2r
	global shpS2l
	global shpS3t
	global shpS3b
	global shpS3r
	global shpS3l
	global shpS4t
	global shpS4b
	global shpS4r
	global shpS4l
	global shpS5t
	global shpS5b
	global shpS5r
	global shpS5l

	if strSetTitle == 'Group' and gcnt == 0:
		strTitleWidth = strFrameOuterWidth * strTitleRatio / 100
		strTitleHeight = float(10)
		strTitleShift = ((strTitleWidth - strFrameOuterWidth) / 2)
		if strLayoutTitle == 'Top':
			strTitleLeft = strPlacementXo - strTitleShift
			shpTt = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTt' + lstRndGrp[gcnt])
			lstTopShp.append(shpTt)
			scribus.setText(lstTitle[gcnt], shpTt)
			shpTitleHot = shpTt
			if strStack1 == 'Title':
				shpS1t = 'shpTt'
			elif strStack2 == 'Title':
				shpS2t = 'shpTt'
			elif strStack3 == 'Title':
				shpS3t = 'shpTt'
			elif strStack4 == 'Title':
				shpS4t = 'shpTt'
			elif strStack5 == 'Title':
				shpS5t = 'shpTt'
		elif strLayoutTitle == 'Bottom':
			strTitleLeft = strPlacementXo - strTitleShift
			shpTb = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTb' + lstRndGrp[gcnt])
			lstBottomShp.append(shpTb)
			scribus.setText(lstTitle[gcnt], shpTb)
			shpTitleHot = shpTb
			if strStack1 == 'Title':
				shpS1b = 'shpTb'
			elif strStack2 == 'Title':
				shpS2b = 'shpTb'
			elif strStack3 == 'Title':
				shpS3b = 'shpTb'
			elif strStack4 == 'Title':
				shpS4b = 'shpTb'
			elif strStack5 == 'Title':
				shpS5b = 'shpTb'
		elif strLayoutTitle == 'Right':
			strTitleLeft = strPlacementXo + strFrameOuterWidth + strMarginRight
			shpTr = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTr' + lstRndGrp[gcnt])
			lstRightShpG.append(shpTr)
			scribus.setText(lstTitle[gcnt], shpTr)
			shpTitleHot = shpTr
			if strStack1 == 'Title':
				shpS1r = 'shpTr'
			elif strStack2 == 'Title':
				shpS2r = 'shpTr'
			elif strStack3 == 'Title':
				shpS3r = 'shpTr'
			elif strStack4 == 'Title':
				shpS4r = 'shpTr'
			elif strStack5 == 'Title':
				shpS5r = 'shpTr'
		elif strLayoutTitle == 'Left':
			strTitleLeft = strPlacementXo - strMarginLeft - strTitleWidth
			shpTl = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTl' + lstRndGrp[gcnt])
			lstLeftShpG.append(shpTl)
			scribus.setText(lstTitle[gcnt], shpTl)
			shpTitleHot = shpTl
			if strStack1 == 'Title':
				shpS1l = 'shpTl'
			elif strStack2 == 'Title':
				shpS2l = 'shpTl'
			elif strStack3 == 'Title':
				shpS3l = 'shpTl'
			elif strStack4 == 'Title':
				shpS4l = 'shpTl'
			elif strStack5 == 'Title':
				shpS5l = 'shpTl'
		if strTitleStyle == 'Global':
			TextLengthT = scribus.getTextLength(shpTitleHot)
			scribus.selectText(0,TextLengthT,shpTitleHot)
			scribus.setStyle("Title",shpTitleHot)
		else:
			scribus.setFont(strTitleFont, shpTitleHot)
			scribus.setFontSize(float(strTitleFontSize), shpTitleHot)
			if strTitleTextAlign == 'Left':
				scribus.setTextAlignment(0, shpTitleHot)
			elif strTitleTextAlign == "Center":
				scribus.setTextAlignment(1, shpTitleHot)
			elif strTitleTextAlign == 'Right':
				scribus.setTextAlignment(2, shpTitleHot)
			elif strTitleTextAlign == "Justified":
				scribus.setTextAlignment(3, shpTitleHot)	
			scribus.setLineSpacing(float(strTitleFontSize)*float(strTitleFontSpacing), shpTitleHot)
		if strTitleHyphen == 'TRUE':
			scribus.hyphenateText(shpTitleHot)
		(Tw, Th) = scribus.getSize(shpTitleHot)
		while (((scribus.textOverflows(shpTitleHot) == 0)) and (Th > 0)) :
			Th -= 1
			scribus.sizeObject(Tw, Th, shpTitleHot)
		while ((scribus.textOverflows(shpTitleHot) > 0)) :
			Th += 1
			scribus.sizeObject(Tw, Th, shpTitleHot)
		'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
		scribus.sizeObject(Tw, Th+1, shpTitleHot)
		lstTS.append(shpTitleHot)
	elif strSetTitle == 'Group' and gcnt > 0:
		pass
	else:
		strTitleWidth = strFrameOuterWidthI * strTitleRatio / 100
		strTitleHeight = float(10)
		strTitleShift = ((strTitleWidth - strFrameOuterWidthI) / 2)
		if strLayoutTitle == 'Top':
			strTitleLeft = strPlacementXt - strTitleShift
			shpTt = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTt' + lstRndGrp[gcnt])
			lstTopShp.append(shpTt)
			scribus.setText(lstTitle[gcnt], shpTt)
			shpTitleHot = shpTt
			if strStack1 == 'Title':
				shpS1t = 'shpTt'
			elif strStack2 == 'Title':
				shpS2t = 'shpTt'
			elif strStack3 == 'Title':
				shpS3t = 'shpTt'
			elif strStack4 == 'Title':
				shpS4t = 'shpTt'
			elif strStack5 == 'Title':
				shpS5t = 'shpTt'
		elif strLayoutTitle == 'Bottom':
			strTitleLeft = strPlacementXt - strTitleShift
			shpTb = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTb' + lstRndGrp[gcnt])
			lstBottomShp.append(shpTb)
			scribus.setText(lstTitle[gcnt], shpTb)
			shpTitleHot = shpTb
			if strStack1 == 'Title':
				shpS1b = 'shpTb'
			elif strStack2 == 'Title':
				shpS2b = 'shpTb'
			elif strStack3 == 'Title':
				shpS3b = 'shpTb'
			elif strStack4 == 'Title':
				shpS4b = 'shpTb'
			elif strStack5 == 'Title':
				shpS5b = 'shpTb'
		elif strLayoutTitle == 'Right':
			strTitleLeft = strPlacementXt + strFrameOuterWidthI + strMarginRight
			shpTr = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTr' + lstRndGrp[gcnt])
			lstRightShp.append(shpTr)
			scribus.setText(lstTitle[gcnt], shpTr)
			shpTitleHot = shpTr
			if strStack1 == 'Title':
				shpS1r = 'shpTr'
			elif strStack2 == 'Title':
				shpS2r = 'shpTr'
			elif strStack3 == 'Title':
				shpS3r = 'shpTr'
			elif strStack4 == 'Title':
				shpS4r = 'shpTr'
			elif strStack5 == 'Title':
				shpS5r = 'shpTr'
		elif strLayoutTitle == 'Left':
			strTitleLeft = strPlacementXt - strMarginLeft - strTitleWidth
			shpTl = scribus.createText(strTitleLeft, strPlacementYo, strTitleWidth, strTitleHeight, 'shpTl' + lstRndGrp[gcnt])
			lstLeftShp.append(shpTl)
			scribus.setText(lstTitle[gcnt], shpTl)
			shpTitleHot = shpTl
			if strStack1 == 'Title':
				shpS1l = 'shpTl'
			elif strStack2 == 'Title':
				shpS2l = 'shpTl'
			elif strStack3 == 'Title':
				shpS3l = 'shpTl'
			elif strStack4 == 'Title':
				shpS4l = 'shpTl'
			elif strStack5 == 'Title':
				shpS5l = 'shpTl'
		if strTitleStyle == 'Global':
			TextLengthT = scribus.getTextLength(shpTitleHot)
			scribus.selectText(0,TextLengthT,shpTitleHot)
			scribus.setStyle("Title",shpTitleHot)
		else:
			scribus.setFont(strTitleFont, shpTitleHot)
			scribus.setFontSize(float(strTitleFontSize), shpTitleHot)
			if strTitleTextAlign == 'Left':
				scribus.setTextAlignment(0, shpTitleHot)
			elif strTitleTextAlign == "Center":
				scribus.setTextAlignment(1, shpTitleHot)
			elif strTitleTextAlign == 'Right':
				scribus.setTextAlignment(2, shpTitleHot)
			elif strTitleTextAlign == "Justified":
				scribus.setTextAlignment(3, shpTitleHot)	
			scribus.setLineSpacing(float(strTitleFontSize)*float(strTitleFontSpacing), shpTitleHot)
		if strTitleHyphen == 'TRUE':
			scribus.hyphenateText(shpTitleHot)
		(Tw, Th) = scribus.getSize(shpTitleHot)
		while (((scribus.textOverflows(shpTitleHot) == 0)) and (Th > 0)) :
			Th -= 1
			scribus.sizeObject(Tw, Th, shpTitleHot)
		while ((scribus.textOverflows(shpTitleHot) > 0)) :
			Th += 1
			scribus.sizeObject(Tw, Th, shpTitleHot)
		'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
		scribus.sizeObject(Tw, Th+1, shpTitleHot)
		lstTS.append(shpTitleHot)

def funcDatePlacementXFrameGrouped():
	'''Create working copy of global Placement variables'''
	strPlacementXd = strPlacementXb

	'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
	if strFrameStyle == 'Internal':
		strFrameOuterWidthI = lstStampW[gcnt]
		strFrameOuterHeightI = lstStampH[gcnt]
	else:
		strFrameOuterWidthI = strFrameOuterWidth
		strFrameOuterHeightI = strFrameOuterHeight

	'''Substitute stamp width for frame width when building individual components of set'''
	if strSetOrientation == 'Horizontal':
		strFrameOuterWidthI = lstStampW[gcnt]

	'''Add the Dates'''
	global shpDt
	global shpDb
	global shpDr
	global shpDl
	global shpDateHot

	global shpS1t
	global shpS1b
	global shpS1r
	global shpS1l
	global shpS2t
	global shpS2b
	global shpS2r
	global shpS2l
	global shpS3t
	global shpS3b
	global shpS3r
	global shpS3l
	global shpS4t
	global shpS4b
	global shpS4r
	global shpS4l
	global shpS5t
	global shpS5b
	global shpS5r
	global shpS5l

	if strSetDate == 'Group' and gcnt == 0:
		strDateWidth = strFrameOuterWidth * strDateRatio / 100
		strDateHeight = float(10)
		strDateShift = ((strDateWidth - strFrameOuterWidth) / 2)
		if strLayoutDate == 'Top':
			strDateLeft = strPlacementXo - strDateShift
			shpDt = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDt' + lstRndGrp[gcnt])
			scribus.setText(lstDate[gcnt], shpDt)
			lstTopShp.append(shpDt)
			shpDateHot = shpDt
			if strStack1 == 'Date':
				shpS1t = 'shpDt'
			elif strStack2 == 'Date':
				shpS2t = 'shpDt'
			elif strStack3 == 'Date':
				shpS3t = 'shpDt'
			elif strStack4 == 'Date':
				shpS4t = 'shpDt'
			elif strStack5 == 'Date':
				shpS5t = 'shpDt'
		elif strLayoutDate == 'Bottom':
			strDateLeft = strPlacementXo - strDateShift
			shpDb = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDb' + lstRndGrp[gcnt])
			scribus.setText(lstDate[gcnt], shpDb)
			lstBottomShp.append(shpDb)
			shpDateHot = shpDb
			if strStack1 == 'Date':
				shpS1b = 'shpDb'
			elif strStack2 == 'Date':
				shpS2b = 'shpDb'
			elif strStack3 == 'Date':
				shpS3b = 'shpDb'
			elif strStack4 == 'Date':
				shpS4b = 'shpDb'
			elif strStack5 == 'Date':
				shpS5b = 'shpDb'
		elif strLayoutDate == 'Right':
			strDateLeft = strPlacementXo + strFrameOuterWidth + strMarginRight
			shpDr = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDr' + lstRndGrp[gcnt])
			scribus.setText(lstDate[gcnt], shpDr)
			lstRightShpG.append(shpDr)
			shpDateHot = shpDr
			if strStack1 == 'Date':
				shpS1r = 'shpDr'
			elif strStack2 == 'Date':
				shpS2r = 'shpDr'
			elif strStack3 == 'Date':
				shpS3r = 'shpDr'
			elif strStack4 == 'Date':
				shpS4r = 'shpDr'
			elif strStack5 == 'Date':
				shpS5r = 'shpDr'
		elif strLayoutDate == 'Left':
			strDateLeft = strPlacementXo - strMarginLeft - strDateWidth
			shpDl = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDl' + lstRndGrp[gcnt])
			scribus.setText(lstDate[gcnt], shpDl)
			lstLeftShpG.append(shpDl)
			shpDateHot = shpDl
			if strStack1 == 'Date':
				shpS1l = 'shpDl'
			elif strStack2 == 'Date':
				shpS2l = 'shpDl'
			elif strStack3 == 'Date':
				shpS3l = 'shpDl'
			elif strStack4 == 'Date':
				shpS4l = 'shpDl'
			elif strStack5 == 'Date':
				shpS5l = 'shpDl'
		if strDateStyle == 'Global':
			TextLengthD = scribus.getTextLength(shpDateHot)
			scribus.selectText(0,TextLengthD,shpDateHot)
			scribus.setStyle("Date",shpDateHot)
		else:
			scribus.setFont(strDateFont, shpDateHot)
			scribus.setFontSize(float(strDateFontSize), shpDateHot)
			if strDateTextAlign == 'Left':
				scribus.setTextAlignment(0, shpDateHot)
			elif strDateTextAlign == "Center":
				scribus.setTextAlignment(1, shpDateHot)
			elif strDateTextAlign == 'Right':
				scribus.setTextAlignment(2, shpDateHot)
			elif strDateTextAlign == "Justified":
				scribus.setTextAlignment(3, shpDateHot)	   
			scribus.setLineSpacing(float(strDateFontSize)*float(strDateFontSpacing), shpDateHot)
		if strDateHyphen == 'TRUE':
			scribus.hyphenateText(shpDateHot)
			
		(Dw, Dh) = scribus.getSize(shpDateHot)
		while (((scribus.textOverflows(shpDateHot) == 0)) and (Dh > 0)) :
			Dh -= 1
			scribus.sizeObject(Dw, Dh, shpDateHot)
		while ((scribus.textOverflows(shpDateHot) > 0)) :
			Dh += 1
			scribus.sizeObject(Dw, Dh, shpDateHot)
		'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
		scribus.sizeObject(Dw, Dh+1, shpDateHot)
		lstDS.append(shpDateHot)
	elif strSetDate == 'Group' and gcnt > 0:
		pass
	else:
		strDateWidth = strFrameOuterWidthI * strDateRatio / 100
		strDateHeight = float(10)
		strDateShift = ((strDateWidth - strFrameOuterWidthI) / 2)
		if strLayoutDate == 'Top':
			strDateLeft = strPlacementXd - strDateShift
			shpDt = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDt' + lstRndGrp[gcnt])
			scribus.setText(lstDate[gcnt], shpDt)
			lstTopShp.append(shpDt)
			shpDateHot = shpDt
			if strStack1 == 'Date':
				shpS1t = 'shpDt'
			elif strStack2 == 'Date':
				shpS2t = 'shpDt'
			elif strStack3 == 'Date':
				shpS3t = 'shpDt'
			elif strStack4 == 'Date':
				shpS4t = 'shpDt'
			elif strStack5 == 'Date':
				shpS5t = 'shpDt'
		elif strLayoutDate == 'Bottom':
			strDateLeft = strPlacementXd - strDateShift
			shpDb = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDb' + lstRndGrp[gcnt])
			scribus.setText(lstDate[gcnt], shpDb)
			lstBottomShp.append(shpDb)
			shpDateHot = shpDb
			if strStack1 == 'Date':
				shpS1b = 'shpDb'
			elif strStack2 == 'Date':
				shpS2b = 'shpDb'
			elif strStack3 == 'Date':
				shpS3b = 'shpDb'
			elif strStack4 == 'Date':
				shpS4b = 'shpDb'
			elif strStack5 == 'Date':
				shpS5b = 'shpDb'
		elif strLayoutDate == 'Right':
			strDateLeft = strPlacementXd + strFrameOuterWidthI + strMarginRight
			shpDr = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDr' + lstRndGrp[gcnt])
			scribus.setText(lstDate[gcnt], shpDr)
			lstRightShp.append(shpDr)
			shpDateHot = shpDr
			if strStack1 == 'Date':
				shpS1r = 'shpDr'
			elif strStack2 == 'Date':
				shpS2r = 'shpDr'
			elif strStack3 == 'Date':
				shpS3r = 'shpDr'
			elif strStack4 == 'Date':
				shpS4r = 'shpDr'
			elif strStack5 == 'Date':
				shpS5r = 'shpDr'
		elif strLayoutDate == 'Left':
			strDateLeft = strPlacementXd - strMarginLeft - strDateWidth
			shpDl = scribus.createText(strDateLeft, strPlacementYo, strDateWidth, strDateHeight, 'shpDl' + lstRndGrp[gcnt])
			scribus.setText(lstDate[gcnt], shpDl)
			lstLeftShp.append(shpDl)
			shpDateHot = shpDl
			if strStack1 == 'Date':
				shpS1l = 'shpDl'
			elif strStack2 == 'Date':
				shpS2l = 'shpDl'
			elif strStack3 == 'Date':
				shpS3l = 'shpDl'
			elif strStack4 == 'Date':
				shpS4l = 'shpDl'
			elif strStack5 == 'Date':
				shpS5l = 'shpDl'
		if strDateStyle == 'Global':
			TextLengthD = scribus.getTextLength(shpDateHot)
			scribus.selectText(0,TextLengthD,shpDateHot)
			scribus.setStyle("Date",shpDateHot)
		else:
			scribus.setFont(strDateFont, shpDateHot)
			scribus.setFontSize(float(strDateFontSize), shpDateHot)
			if strDateTextAlign == 'Left':
				scribus.setTextAlignment(0, shpDateHot)
			elif strDateTextAlign == "Center":
				scribus.setTextAlignment(1, shpDateHot)
			elif strDateTextAlign == 'Right':
				scribus.setTextAlignment(2, shpDateHot)
			elif strDateTextAlign == "Justified":
				scribus.setTextAlignment(3, shpDateHot)	   
			scribus.setLineSpacing(float(strDateFontSize)*float(strDateFontSpacing), shpDateHot)
		if strDateHyphen == 'TRUE':
			scribus.hyphenateText(shpDateHot)
			
		(Dw, Dh) = scribus.getSize(shpDateHot)
		while (((scribus.textOverflows(shpDateHot) == 0)) and (Dh > 0)) :
			Dh -= 1
			scribus.sizeObject(Dw, Dh, shpDateHot)
		while ((scribus.textOverflows(shpDateHot) > 0)) :
			Dh += 1
			scribus.sizeObject(Dw, Dh, shpDateHot)
		'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
		scribus.sizeObject(Dw, Dh+1, shpDateHot)
		lstDS.append(shpDateHot)

def funcKatalogPlacementXFrameGrouped():
	'''Create working copy of global Placement variables'''
	strPlacementXk = strPlacementXb

	'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
	if strFrameStyle == 'Internal':
		strFrameOuterWidthI = lstStampW[gcnt]
		strFrameOuterHeightI = lstStampH[gcnt]
		global strKatalogRatio
		if strKatalogRatio > 90:
			strKatalogRatio = 90
	else:
		strFrameOuterWidthI = strFrameOuterWidth
		strFrameOuterHeightI = strFrameOuterHeight

	'''Substitute stamp width for frame width when building individual components of set'''
	if strSetOrientation == 'Horizontal':
		strFrameOuterWidthI = lstStampW[gcnt]

	'''Add the Katalogs'''
	global shpKt
	global shpKb
	global shpKr
	global shpKl
	global shpKatalogHot

	global shpS1t
	global shpS1b
	global shpS1r
	global shpS1l
	global shpS2t
	global shpS2b
	global shpS2r
	global shpS2l
	global shpS3t
	global shpS3b
	global shpS3r
	global shpS3l
	global shpS4t
	global shpS4b
	global shpS4r
	global shpS4l
	global shpS5t
	global shpS5b
	global shpS5r
	global shpS5l

	if strSetKatalog == 'Group' and gcnt == 0:
		strKatalogWidth = strFrameOuterWidth * strKatalogRatio / 100
		strKatalogHeight = float(10)
		strKatalogShift = ((strKatalogWidth - strFrameOuterWidth) / 2)
		if strLayoutKatalog == 'Top':
			strKatalogLeft = strPlacementXo - strKatalogShift
			shpKt = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKt' + lstRndGrp[gcnt])
			lstTopShp.append(shpKt)
			scribus.setText(lstKatalog[gcnt], shpKt)
			shpKatalogHot = shpKt
			if strStack1 == 'Catalog':
				shpS1t = 'shpKt'
			elif strStack2 == 'Catalog':
				shpS2t = 'shpKt'
			elif strStack3 == 'Catalog':
				shpS3t = 'shpKt'
			elif strStack4 == 'Catalog':
				shpS4t = 'shpKt'
			elif strStack5 == 'Catalog':
				shpS5t = 'shpKt'
		elif strLayoutKatalog == 'Bottom':
			strKatalogLeft = strPlacementXo - strKatalogShift
			shpKb = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKb' + lstRndGrp[gcnt])
			lstBottomShp.append(shpKb)
			scribus.setText(lstKatalog[gcnt], shpKb)
			shpKatalogHot = shpKb
			if strStack1 == 'Catalog':
				shpS1b = 'shpKb'
			elif strStack2 == 'Catalog':
				shpS2b = 'shpKb'
			elif strStack3 == 'Catalog':
				shpS3b = 'shpKb'
			elif strStack4 == 'Catalog':
				shpS4b = 'shpKb'
			elif strStack5 == 'Catalog':
				shpS5b = 'shpKb'
		elif strLayoutKatalog == 'Right':
			strKatalogLeft = strPlacementXo + strFrameOuterWidth + strMarginRight
			shpKr = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKr' + lstRndGrp[gcnt])
			lstRightShpG.append(shpKr)
			scribus.setText(lstKatalog[gcnt], shpKr)
			shpKatalogHot = shpKr
			if strStack1 == 'Catalog':
				shpS1r = 'shpKr'
			elif strStack2 == 'Catalog':
				shpS2r = 'shpKr'
			elif strStack3 == 'Catalog':
				shpS3r = 'shpKr'
			elif strStack4 == 'Catalog':
				shpS4r = 'shpKr'
			elif strStack5 == 'Catalog':
				shpS5r = 'shpKr'
		elif strLayoutKatalog == 'Left':
			strKatalogLeft = strPlacementXo - strMarginLeft - strKatalogWidth
			shpKl = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKl' + lstRndGrp[gcnt])
			lstLeftShpG.append(shpKl)
			scribus.setText(lstKatalog[gcnt], shpKl)
			shpKatalogHot = shpKl
			if strStack1 == 'Catalog':
				shpS1l = 'shpKl'
			elif strStack2 == 'Catalog':
				shpS2l = 'shpKl'
			elif strStack3 == 'Catalog':
				shpS3l = 'shpKl'
			elif strStack4 == 'Catalog':
				shpS4l = 'shpKl'
			elif strStack5 == 'Catalog':
				shpS5l = 'shpKl'
		if strKatalogStyle == 'Global':
			TextLengthK = scribus.getTextLength(shpKatalogHot)
			scribus.selectText(0,TextLengthK,shpKatalogHot)
			scribus.setStyle("Katalog",shpKatalogHot)
		else:
			scribus.setFont(strKatalogFont, shpKatalogHot)
			scribus.setFontSize(float(strKatalogFontSize), shpKatalogHot)
			if strKatalogTextAlign == 'Left':
				scribus.setTextAlignment(0, shpKatalogHot)
			elif strKatalogTextAlign == "Center":
				scribus.setTextAlignment(1, shpKatalogHot)
			elif strKatalogTextAlign == 'Right':
				scribus.setTextAlignment(2, shpKatalogHot)
			elif strKatalogTextAlign == "Justified":
				scribus.setTextAlignment(3, shpKatalogHot)	  
			scribus.setLineSpacing(float(strKatalogFontSize)*float(strKatalogFontSpacing), shpKatalogHot)
		if strKatalogHyphen == 'TRUE':
			scribus.hyphenateText(shpKatalogHot)
		(Kw, Kh) = scribus.getSize(shpKatalogHot)
		while (((scribus.textOverflows(shpKatalogHot) == 0)) and (Kh > 0)) :
			Kh -= 1
			scribus.sizeObject(Kw, Kh, shpKatalogHot)
		while ((scribus.textOverflows(shpKatalogHot) > 0)) :
			Kh += 1
			scribus.sizeObject(Kw, Kh, shpKatalogHot)
		'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
		scribus.sizeObject(Kw, Kh+1, shpKatalogHot)
		lstKS.append(shpKatalogHot)
	elif strSetKatalog == 'Group' and gcnt > 0:
		pass
	else:
		strKatalogWidth = strFrameOuterWidthI * strKatalogRatio / 100
		strKatalogHeight = float(10)
		strKatalogShift = ((strKatalogWidth - strFrameOuterWidthI) / 2)
		if strLayoutKatalog == 'Top':
			strKatalogLeft = strPlacementXk - strKatalogShift
			shpKt = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKt' + lstRndGrp[gcnt])
			lstTopShp.append(shpKt)
			scribus.setText(lstKatalog[gcnt], shpKt)
			shpKatalogHot = shpKt
			if strStack1 == 'Catalog':
				shpS1t = 'shpKt'
			elif strStack2 == 'Catalog':
				shpS2t = 'shpKt'
			elif strStack3 == 'Catalog':
				shpS3t = 'shpKt'
			elif strStack4 == 'Catalog':
				shpS4t = 'shpKt'
			elif strStack5 == 'Catalog':
				shpS5t = 'shpKt'
		elif strLayoutKatalog == 'Bottom':
			strKatalogLeft = strPlacementXk - strKatalogShift
			shpKb = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKb' + lstRndGrp[gcnt])
			lstBottomShp.append(shpKb)
			scribus.setText(lstKatalog[gcnt], shpKb)
			shpKatalogHot = shpKb
			if strStack1 == 'Catalog':
				shpS1b = 'shpKb'
			elif strStack2 == 'Catalog':
				shpS2b = 'shpKb'
			elif strStack3 == 'Catalog':
				shpS3b = 'shpKb'
			elif strStack4 == 'Catalog':
				shpS4b = 'shpKb'
			elif strStack5 == 'Catalog':
				shpS5b = 'shpKb'
		elif strLayoutKatalog == 'Right':
			strKatalogLeft = strPlacementXk + strFrameOuterWidthI + strMarginRight
			shpKr = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKr' + lstRndGrp[gcnt])
			lstRightShp.append(shpKr)
			scribus.setText(lstKatalog[gcnt], shpKr)
			shpKatalogHot = shpKr
			if strStack1 == 'Catalog':
				shpS1r = 'shpKr'
			elif strStack2 == 'Catalog':
				shpS2r = 'shpKr'
			elif strStack3 == 'Catalog':
				shpS3r = 'shpKr'
			elif strStack4 == 'Catalog':
				shpS4r = 'shpKr'
			elif strStack5 == 'Catalog':
				shpS5r = 'shpKr'
		elif strLayoutKatalog == 'Left':
			strKatalogLeft = strPlacementXk - strMarginLeft - strKatalogWidth
			shpKl = scribus.createText(strKatalogLeft, strPlacementYo, strKatalogWidth, strKatalogHeight, 'shpKl' + lstRndGrp[gcnt])
			lstLeftShp.append(shpKl)
			scribus.setText(lstKatalog[gcnt], shpKl)
			shpKatalogHot = shpKl
			if strStack1 == 'Catalog':
				shpS1l = 'shpKl'
			elif strStack2 == 'Catalog':
				shpS2l = 'shpKl'
			elif strStack3 == 'Catalog':
				shpS3l = 'shpKl'
			elif strStack4 == 'Catalog':
				shpS4l = 'shpKl'
			elif strStack5 == 'Catalog':
				shpS5l = 'shpKl'
		if strKatalogStyle == 'Global':
			TextLengthK = scribus.getTextLength(shpKatalogHot)
			scribus.selectText(0,TextLengthK,shpKatalogHot)
			scribus.setStyle("Katalog",shpKatalogHot)
		else:
			scribus.setFont(strKatalogFont, shpKatalogHot)
			scribus.setFontSize(float(strKatalogFontSize), shpKatalogHot)
			if strKatalogTextAlign == 'Left':
				scribus.setTextAlignment(0, shpKatalogHot)
			elif strKatalogTextAlign == "Center":
				scribus.setTextAlignment(1, shpKatalogHot)
			elif strKatalogTextAlign == 'Right':
				scribus.setTextAlignment(2, shpKatalogHot)
			elif strKatalogTextAlign == "Justified":
				scribus.setTextAlignment(3, shpKatalogHot)	  
			scribus.setLineSpacing(float(strKatalogFontSize)*float(strKatalogFontSpacing), shpKatalogHot)
		if strKatalogHyphen == 'TRUE':
			scribus.hyphenateText(shpKatalogHot)
		(Kw, Kh) = scribus.getSize(shpKatalogHot)
		while (((scribus.textOverflows(shpKatalogHot) == 0)) and (Kh > 0)) :
			Kh -= 1
			scribus.sizeObject(Kw, Kh, shpKatalogHot)
		while ((scribus.textOverflows(shpKatalogHot) > 0)) :
			Kh += 1
			scribus.sizeObject(Kw, Kh, shpKatalogHot)
		'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
		scribus.sizeObject(Kw, Kh+1, shpKatalogHot)
		lstKS.append(shpKatalogHot)

def funcFacePlacementXFrameGrouped():
	'''Create working copy of global Placement variables'''
	strPlacementXf = strPlacementXb

	'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
	if strFrameStyle == 'Internal':
		strFrameOuterWidthI = lstStampW[gcnt]
		strFrameOuterHeightI = lstStampH[gcnt]
		global strFaceRatio
		if strFaceRatio > 90:
			strFaceRatio = 90
	else:
		strFrameOuterWidthI = strFrameOuterWidth
		strFrameOuterHeightI = strFrameOuterHeight

	'''Substitute stamp width for frame width when building individual components of set'''
	if strSetOrientation == 'Horizontal':
		strFrameOuterWidthI = lstStampW[gcnt]

	'''Add the Faces'''
	global shpFt
	global shpFb
	global shpFr
	global shpFl
	global shpFaceHot

	global shpS1t
	global shpS1b
	global shpS1r
	global shpS1l
	global shpS2t
	global shpS2b
	global shpS2r
	global shpS2l
	global shpS3t
	global shpS3b
	global shpS3r
	global shpS3l
	global shpS4t
	global shpS4b
	global shpS4r
	global shpS4l
	global shpS5t
	global shpS5b
	global shpS5r
	global shpS5l

	if strSetFace == 'Group' and gcnt == 0:
		strFaceWidth = strFrameOuterWidth * strFaceRatio / 100
		strFaceHeight = float(10)
		strFaceShift = ((strFaceWidth - strFrameOuterWidth) / 2)
		if strLayoutFace == 'Top':
			strFaceLeft = strPlacementXo - strFaceShift
			shpFt = scribus.createText(strFaceLeft, strPlacementYo, strFaceWidth, strFaceHeight, 'shpFt' + lstRndGrp[gcnt])
			lstTopShp.append(shpFt)
			scribus.setText(lstFace[gcnt], shpFt)
			shpFaceHot = shpFt
			if strStack1 == 'Face Value':
				shpS1t = 'shpFt'
			elif strStack2 == 'Face Value':
				shpS2t = 'shpFt'
			elif strStack3 == 'Face Value':
				shpS3t = 'shpFt'
			elif strStack4 == 'Face Value':
				shpS4t = 'shpFt'
			elif strStack5 == 'Face Value':
				shpS5t = 'shpFt'
		elif strLayoutFace == 'Bottom':
			strFaceLeft = strPlacementXo - strFaceShift
			shpFb = scribus.createText(strFaceLeft, strPlacementYo, strFaceWidth, strFaceHeight, 'shpFb' + lstRndGrp[gcnt])
			lstBottomShp.append(shpFb)
			scribus.setText(lstFace[gcnt], shpFb)
			shpFaceHot = shpFb
			if strStack1 == 'Face Value':
				shpS1b = 'shpFb'
			elif strStack2 == 'Face Value':
				shpS2b = 'shpFb'
			elif strStack3 == 'Face Value':
				shpS3b = 'shpFb'
			elif strStack4 == 'Face Value':
				shpS4b = 'shpFb'
			elif strStack5 == 'Face Value':
				shpS5b = 'shpFb'
		elif strLayoutFace == 'Right':
			strFaceLeft = strPlacementXo + strFrameOuterWidth + strMarginRight
			shpFr = scribus.createText(strFaceLeft, strPlacementYo, strFaceWidth, strFaceHeight, 'shpFr' + lstRndGrp[gcnt])
			lstRightShpG.append(shpFr)
			scribus.setText(lstFace[gcnt], shpFr)
			shpFaceHot = shpFr
			if strStack1 == 'Face Value':
				shpS1r = 'shpFr'
			elif strStack2 == 'Face Value':
				shpS2r = 'shpFr'
			elif strStack3 == 'Face Value':
				shpS3r = 'shpFr'
			elif strStack4 == 'Face Value':
				shpS4r = 'shpFr'
			elif strStack5 == 'Face Value':
				shpS5r = 'shpFr'
		elif strLayoutFace == 'Left':
			strFaceLeft = strPlacementXo - strMarginLeft - strFaceWidth
			shpFl = scribus.createText(strFaceLeft, strPlacementYo, strFaceWidth, strFaceHeight, 'shpFl' + lstRndGrp[gcnt])
			lstLeftShpG.append(shpFl)
			scribus.setText(lstFace[gcnt], shpFl)
			shpFaceHot = shpFl
			if strStack1 == 'Face Value':
				shpS1l = 'shpFl'
			elif strStack2 == 'Face Value':
				shpS2l = 'shpFl'
			elif strStack3 == 'Face Value':
				shpS3l = 'shpFl'
			elif strStack4 == 'Face Value':
				shpS4l = 'shpFl'
			elif strStack5 == 'Face Value':
				shpS5l = 'shpFl'
		if strFaceStyle == 'Global':
			TextLengthF = scribus.getTextLength(shpFaceHot)
			scribus.selectText(0,TextLengthF,shpFaceHot)
			scribus.setStyle("Face",shpFaceHot)
		elif strFaceStyle == 'Global - Small Caps':
			TextLengthF = scribus.getTextLength(shpFaceHot)
			scribus.selectText(0,TextLengthF,shpFaceHot)
			scribus.setStyle("FaceSC",shpFaceHot)
		else:
			scribus.setFont(strFaceFont, shpFaceHot)
			scribus.setFontSize(float(strFaceFontSize), shpFaceHot)
			if strFaceTextAlign == 'Left':
				scribus.setTextAlignment(0, shpFaceHot)
			elif strFaceTextAlign == "Center":
				scribus.setTextAlignment(1, shpFaceHot)
			elif strFaceTextAlign == 'Right':
				scribus.setTextAlignment(2, shpFaceHot)
			elif strFaceTextAlign == "Justified":
				scribus.setTextAlignment(3, shpFaceHot)	  
			scribus.setLineSpacing(float(strFaceFontSize)*float(strFaceFontSpacing), shpFaceHot)
		if strFaceHyphen == 'TRUE':
			scribus.hyphenateText(shpFaceHot)
		(Fw, Fh) = scribus.getSize(shpFaceHot)
		while (((scribus.textOverflows(shpFaceHot) == 0)) and (Fh > 0)) :
			Fh -= 1
			scribus.sizeObject(Fw, Fh, shpFaceHot)
		while ((scribus.textOverflows(shpFaceHot) > 0)) :
			Fh += 1
			scribus.sizeObject(Fw, Fh, shpFaceHot)
		'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
		scribus.sizeObject(Fw, Fh+1, shpFaceHot)
		lstFS.append(shpFaceHot)
	elif strSetFace == 'Group' and gcnt > 0:
		pass
	else:
		strFaceWidth = strFrameOuterWidthI * strFaceRatio / 100
		strFaceHeight = float(10)
		strFaceShift = ((strFaceWidth - strFrameOuterWidthI) / 2)
		if strLayoutFace == 'Top':
			strFaceLeft = strPlacementXf - strFaceShift
			shpFt = scribus.createText(strFaceLeft, strPlacementYo, strFaceWidth, strFaceHeight, 'shpFt' + lstRndGrp[gcnt])
			lstTopShp.append(shpFt)
			scribus.setText(lstFace[gcnt], shpFt)
			shpFaceHot = shpFt
			if strStack1 == 'Face Value':
				shpS1t = 'shpFt'
			elif strStack2 == 'Face Value':
				shpS2t = 'shpFt'
			elif strStack3 == 'Face Value':
				shpS3t = 'shpFt'
			elif strStack4 == 'Face Value':
				shpS4t = 'shpFt'
			elif strStack5 == 'Face Value':
				shpS5t = 'shpFt'
		elif strLayoutFace == 'Bottom':
			strFaceLeft = strPlacementXf - strFaceShift
			shpFb = scribus.createText(strFaceLeft, strPlacementYo, strFaceWidth, strFaceHeight, 'shpFb' + lstRndGrp[gcnt])
			lstBottomShp.append(shpFb)
			scribus.setText(lstFace[gcnt], shpFb)
			shpFaceHot = shpFb
			if strStack1 == 'Face Value':
				shpS1b = 'shpFb'
			elif strStack2 == 'Face Value':
				shpS2b = 'shpFb'
			elif strStack3 == 'Face Value':
				shpS3b = 'shpFb'
			elif strStack4 == 'Face Value':
				shpS4b = 'shpFb'
			elif strStack5 == 'Face Value':
				shpS5b = 'shpFb'
		elif strLayoutFace == 'Right':
			strFaceLeft = strPlacementXf + strFrameOuterWidthI + strMarginRight
			shpFr = scribus.createText(strFaceLeft, strPlacementYo, strFaceWidth, strFaceHeight, 'shpFr' + lstRndGrp[gcnt])
			lstRightShp.append(shpFr)
			scribus.setText(lstFace[gcnt], shpFr)
			shpFaceHot = shpFr
			if strStack1 == 'Face Value':
				shpS1r = 'shpFr'
			elif strStack2 == 'Face Value':
				shpS2r = 'shpFr'
			elif strStack3 == 'Face Value':
				shpS3r = 'shpFr'
			elif strStack4 == 'Face Value':
				shpS4r = 'shpFr'
			elif strStack5 == 'Face Value':
				shpS5r = 'shpFr'
		elif strLayoutFace == 'Left':
			strFaceLeft = strPlacementXf - strMarginLeft - strFaceWidth
			shpFl = scribus.createText(strFaceLeft, strPlacementYo, strFaceWidth, strFaceHeight, 'shpFl' + lstRndGrp[gcnt])
			lstLeftShp.append(shpFl)
			scribus.setText(lstFace[gcnt], shpFl)
			shpFaceHot = shpFl
			if strStack1 == 'Face Value':
				shpS1l = 'shpFl'
			elif strStack2 == 'Face Value':
				shpS2l = 'shpFl'
			elif strStack3 == 'Face Value':
				shpS3l = 'shpFl'
			elif strStack4 == 'Face Value':
				shpS4l = 'shpFl'
			elif strStack5 == 'Face Value':
				shpS5l = 'shpFl'
		if strFaceStyle == 'Global':
			TextLengthF = scribus.getTextLength(shpFaceHot)
			scribus.selectText(0,TextLengthF,shpFaceHot)
			scribus.setStyle("Face",shpFaceHot)
		elif strFaceStyle == 'Global - Small Caps':
			TextLengthF = scribus.getTextLength(shpFaceHot)
			scribus.selectText(0,TextLengthF,shpFaceHot)
			scribus.setStyle("FaceSC",shpFaceHot)
		else:
			scribus.setFont(strFaceFont, shpFaceHot)
			scribus.setFontSize(float(strFaceFontSize), shpFaceHot)
			if strFaceTextAlign == 'Left':
				scribus.setTextAlignment(0, shpFaceHot)
			elif strFaceTextAlign == "Center":
				scribus.setTextAlignment(1, shpFaceHot)
			elif strFaceTextAlign == 'Right':
				scribus.setTextAlignment(2, shpFaceHot)
			elif strFaceTextAlign == "Justified":
				scribus.setTextAlignment(3, shpFaceHot)	  
			scribus.setLineSpacing(float(strFaceFontSize)*float(strFaceFontSpacing), shpFaceHot)
		if strFaceHyphen == 'TRUE':
			scribus.hyphenateText(shpFaceHot)
		(Fw, Fh) = scribus.getSize(shpFaceHot)
		while (((scribus.textOverflows(shpFaceHot) == 0)) and (Fh > 0)) :
			Fh -= 1
			scribus.sizeObject(Fw, Fh, shpFaceHot)
		while ((scribus.textOverflows(shpFaceHot) > 0)) :
			Fh += 1
			scribus.sizeObject(Fw, Fh, shpFaceHot)
		'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
		scribus.sizeObject(Fw, Fh+1, shpFaceHot)
		lstFS.append(shpFaceHot)
		
def funcCaptionPlacementXFrameGrouped():
	'''Create working copy of global Placement variables'''
	strPlacementXc = strPlacementXb

	'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
	if strFrameStyle == 'Internal':
		strFrameOuterWidthI = lstStampW[gcnt]
		strFrameOuterHeightI = lstStampH[gcnt]
	else:
		strFrameOuterWidthI = strFrameOuterWidth
		strFrameOuterHeightI = strFrameOuterHeight

	'''Substitute stamp width for frame width when building individual components of set'''
	if strSingleSet == 'Set' and strSetOrientation == 'Horizontal':
		strFrameOuterWidthI = lstStampW[gcnt]

	'''Add the Captions'''
	global shpCt
	global shpCb
	global shpCr
	global shpCl
	global shpCaptionHot

	global shpS1t
	global shpS1b
	global shpS1r
	global shpS1l
	global shpS2t
	global shpS2b
	global shpS2r
	global shpS2l
	global shpS3t
	global shpS3b
	global shpS3r
	global shpS3l
	global shpS4t
	global shpS4b
	global shpS4r
	global shpS4l
	global shpS5t
	global shpS5b
	global shpS5r
	global shpS5l

	if strSetCaption == 'Group' and gcnt == 0:
		strCaptionWidth = strFrameOuterWidth * strCaptionRatio / 100
		strCaptionHeight = float(10)
		strCaptionShift = ((strCaptionWidth - strFrameOuterWidth) / 2)
		if strLayoutCaption == 'Top':
			strCaptionLeft = strPlacementXo - strCaptionShift
			shpCt = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCt' + lstRndGrp[gcnt])
			lstTopShp.append(shpCt)
			scribus.setText(lstCaption[gcnt], shpCt)
			shpCaptionHot = shpCt
			if strStack1 == 'Caption':
				shpS1t = 'shpCt'
			elif strStack2 == 'Caption':
				shpS2t = 'shpCt'
			elif strStack3 == 'Caption':
				shpS3t = 'shpCt'
			elif strStack4 == 'Caption':
				shpS4t = 'shpCt'
			elif strStack5 == 'Caption':
				shpS5t = 'shpCt'
		elif strLayoutCaption == 'Bottom':
			strCaptionLeft = strPlacementXo - strCaptionShift
			shpCb = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCb' + lstRndGrp[gcnt])
			lstBottomShp.append(shpCb)
			scribus.setText(lstCaption[gcnt], shpCb)
			shpCaptionHot = shpCb
			if strStack1 == 'Caption':
				shpS1b = 'shpCb'
			elif strStack2 == 'Caption':
				shpS2b = 'shpCb'
			elif strStack3 == 'Caption':
				shpS3b = 'shpCb'
			elif strStack4 == 'Caption':
				shpS4b = 'shpCb'
			elif strStack5 == 'Caption':
				shpS5b = 'shpCb'
		elif strLayoutCaption == 'Right':
			strCaptionLeft = strPlacementXo + strFrameOuterWidth + strMarginRight
			shpCr = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCr' + lstRndGrp[gcnt])
			lstRightShpG.append(shpCr)
			scribus.setText(lstCaption[gcnt], shpCr)
			shpCaptionHot = shpCr
			if strStack1 == 'Caption':
				shpS1r = 'shpCr'
			elif strStack2 == 'Caption':
				shpS2r = 'shpCr'
			elif strStack3 == 'Caption':
				shpS3r = 'shpCr'
			elif strStack4 == 'Caption':
				shpS4r = 'shpCr'
			elif strStack5 == 'Caption':
				shpS5r = 'shpCr'
		elif strLayoutCaption == 'Left':
			strCaptionLeft = strPlacementXo - strMarginLeft - strCaptionWidth
			shpCl = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCl' + lstRndGrp[gcnt])
			lstLeftShpG.append(shpCl)
			scribus.setText(lstCaption[gcnt], shpCl)
			shpCaptionHot = shpCl
			if strStack1 == 'Caption':
				shpS1l = 'shpCl'
			elif strStack2 == 'Caption':
				shpS2l = 'shpCl'
			elif strStack3 == 'Caption':
				shpS3l = 'shpCl'
			elif strStack4 == 'Caption':
				shpS4l = 'shpCl'
			elif strStack5 == 'Caption':
				shpS5l = 'shpCl'
		if strCaptionStyle == 'Global':
			TextLengthC = scribus.getTextLength(shpCaptionHot)
			scribus.selectText(0,TextLengthC,shpCaptionHot)
			scribus.setStyle("Caption",shpCaptionHot)
		else:
			scribus.setFont(strCaptionFont, shpCaptionHot)
			scribus.setFontSize(float(strCaptionFontSize), shpCaptionHot)
			if strCaptionTextAlign == 'Left':
				scribus.setTextAlignment(0, shpCaptionHot)
			elif strCaptionTextAlign == "Center":
				scribus.setTextAlignment(1, shpCaptionHot)
			elif strCaptionTextAlign == 'Right':
				scribus.setTextAlignment(2, shpCaptionHot)
			elif strCaptionTextAlign == "Justified":
				scribus.setTextAlignment(3, shpCaptionHot)	  
			scribus.setLineSpacing(float(strCaptionFontSize)*float(strCaptionFontSpacing), shpCaptionHot)
		if strCaptionHyphen == 'TRUE':
			scribus.hyphenateText(shpCaptionHot)
		(Cw, Ch) = scribus.getSize(shpCaptionHot)
		while (((scribus.textOverflows(shpCaptionHot) == 0)) and (Ch > 0)) :
			Ch -= 1
			scribus.sizeObject(Cw, Ch, shpCaptionHot)
		while ((scribus.textOverflows(shpCaptionHot) > 0)) :
			Ch += 1
			scribus.sizeObject(Cw, Ch, shpCaptionHot)
		'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
		scribus.sizeObject(Cw, Ch+1, shpCaptionHot)
		lstCS.append(shpCaptionHot)
	elif strSetCaption == 'Group' and gcnt > 0:
		pass
	else:
		strCaptionWidth = strFrameOuterWidthI * strCaptionRatio / 100
		strCaptionHeight = float(10)
		strCaptionShift = ((strCaptionWidth - strFrameOuterWidthI) / 2)
		if strLayoutCaption == 'Top':
			strCaptionLeft = strPlacementXc - strCaptionShift
			shpCt = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCt' + lstRndGrp[gcnt])
			lstTopShp.append(shpCt)
			scribus.setText(lstCaption[gcnt], shpCt)
			shpCaptionHot = shpCt
			if strStack1 == 'Caption':
				shpS1t = 'shpCt'
			elif strStack2 == 'Caption':
				shpS2t = 'shpCt'
			elif strStack3 == 'Caption':
				shpS3t = 'shpCt'
			elif strStack4 == 'Caption':
				shpS4t = 'shpCt'
			elif strStack5 == 'Caption':
				shpS5t = 'shpCt'
		elif strLayoutCaption == 'Bottom':
			strCaptionLeft = strPlacementXc - strCaptionShift
			shpCb = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCb' + lstRndGrp[gcnt])
			lstBottomShp.append(shpCb)
			scribus.setText(lstCaption[gcnt], shpCb)
			shpCaptionHot = shpCb
			if strStack1 == 'Caption':
				shpS1b = 'shpCb'
			elif strStack2 == 'Caption':
				shpS2b = 'shpCb'
			elif strStack3 == 'Caption':
				shpS3b = 'shpCb'
			elif strStack4 == 'Caption':
				shpS4b = 'shpCb'
			elif strStack5 == 'Caption':
				shpS5b = 'shpCb'
		elif strLayoutCaption == 'Right':
			strCaptionLeft = strPlacementXc + strFrameOuterWidthI + strMarginRight
			shpCr = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCr' + lstRndGrp[gcnt])
			lstRightShp.append(shpCr)
			scribus.setText(lstCaption[gcnt], shpCr)
			shpCaptionHot = shpCr
			if strStack1 == 'Caption':
				shpS1r = 'shpCr'
			elif strStack2 == 'Caption':
				shpS2r = 'shpCr'
			elif strStack3 == 'Caption':
				shpS3r = 'shpCr'
			elif strStack4 == 'Caption':
				shpS4r = 'shpCr'
			elif strStack5 == 'Caption':
				shpS5r = 'shpCr'
		elif strLayoutCaption == 'Left':
			strCaptionLeft = strPlacementXc - strMarginLeft - strCaptionWidth
			shpCl = scribus.createText(strCaptionLeft, strPlacementYo, strCaptionWidth, strCaptionHeight, 'shpCl' + lstRndGrp[gcnt])
			lstLeftShp.append(shpCl)
			scribus.setText(lstCaption[gcnt], shpCl)
			shpCaptionHot = shpCl
			if strStack1 == 'Caption':
				shpS1l = 'shpCl'
			elif strStack2 == 'Caption':
				shpS2l = 'shpCl'
			elif strStack3 == 'Caption':
				shpS3l = 'shpCl'
			elif strStack4 == 'Caption':
				shpS4l = 'shpCl'
			elif strStack5 == 'Caption':
				shpS5l = 'shpCl'
		if strCaptionStyle == 'Global':
			TextLengthC = scribus.getTextLength(shpCaptionHot)
			scribus.selectText(0,TextLengthC,shpCaptionHot)
			scribus.setStyle("Caption",shpCaptionHot)
		else:
			scribus.setFont(strCaptionFont, shpCaptionHot)
			scribus.setFontSize(float(strCaptionFontSize), shpCaptionHot)
			if strCaptionTextAlign == 'Left':
				scribus.setTextAlignment(0, shpCaptionHot)
			elif strCaptionTextAlign == "Center":
				scribus.setTextAlignment(1, shpCaptionHot)
			elif strCaptionTextAlign == 'Right':
				scribus.setTextAlignment(2, shpCaptionHot)
			elif strCaptionTextAlign == "Justified":
				scribus.setTextAlignment(3, shpCaptionHot)	  
			scribus.setLineSpacing(float(strCaptionFontSize)*float(strCaptionFontSpacing), shpCaptionHot)
		if strCaptionHyphen == 'TRUE':
			scribus.hyphenateText(shpCaptionHot)
		(Cw, Ch) = scribus.getSize(shpCaptionHot)
		while (((scribus.textOverflows(shpCaptionHot) == 0)) and (Ch > 0)) :
			Ch -= 1
			scribus.sizeObject(Cw, Ch, shpCaptionHot)
		while ((scribus.textOverflows(shpCaptionHot) > 0)) :
			Ch += 1
			scribus.sizeObject(Cw, Ch, shpCaptionHot)
		'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
		scribus.sizeObject(Cw, Ch+1, shpCaptionHot)
		lstCS.append(shpCaptionHot)

def funcTopPlacementYFrameGrouped():
	global strTempY5
	global strTempY4
	global strTempY3
	global strTempY2
	global strTempY1
	
	strTempY5 = strGroupedFrameTop - strMarginTop
	strTempY4 = strGroupedFrameTop - strMarginTop
	strTempY3 = strGroupedFrameTop - strMarginTop
	strTempY2 = strGroupedFrameTop - strMarginTop
	strTempY1 = strGroupedFrameTop - strMarginTop
	
	strTempFo = 'shpFo' + lstRndGrp[0]
	
	f = 0
	while f < (strSetCount):
		strTempS5t = shpS5t + lstRndGrp[f]
		if scribus.objectExists(strTempS5t):
			scribus.setProperty(strTempS5t, "yPos", strGroupedFrameTop - strMarginTop - scribus.getProperty(strTempS5t, "height"))
			if (scribus.getProperty(strTempS5t, "yPos") < strTempY5):
				strTempY5 = scribus.getProperty(strTempS5t, "yPos")
				strTempY4 = strTempY5
				strTempY3 = strTempY5
				strTempY2 = strTempY5
				strTempY1 = strTempY5
		f += 1

	q = 0
	while q < (strSetCount):
		strTempS5t = shpS5t + lstRndGrp[q]
		strTempS4t = shpS4t + lstRndGrp[q]
		if scribus.objectExists(strTempS4t):
			scribus.setProperty(strTempS4t, "yPos", strTempY5 - strVerticalSpacing - scribus.getProperty(strTempS4t, "height"))
			if (scribus.getProperty(strTempS4t, "yPos") < strTempY4):
				strTempY4 = scribus.getProperty(strTempS4t, "yPos")
				strTempY3 = strTempY4
				strTempY2 = strTempY4
				strTempY1 = strTempY4
		q += 1
		
	g = 0
	while g < (strSetCount):
		strTempS5t = shpS5t + lstRndGrp[g]
		strTempS4t = shpS4t + lstRndGrp[g]
		strTempS3t = shpS3t + lstRndGrp[g]
		if scribus.objectExists(strTempS3t):
			scribus.setProperty(strTempS3t, "yPos", strTempY4 - strVerticalSpacing - scribus.getProperty(strTempS3t, "height"))
			if (scribus.getProperty(strTempS3t, "yPos") < strTempY3):
				strTempY3 = scribus.getProperty(strTempS3t, "yPos")
				strTempY2 = strTempY3
				strTempY1 = strTempY3
		g += 1

	h = 0
	while h < (strSetCount):
		strTempS5t = shpS5t + lstRndGrp[h]
		strTempS4t = shpS4t + lstRndGrp[h]
		strTempS3t = shpS3t + lstRndGrp[h]
		strTempS2t = shpS2t + lstRndGrp[h]
		if scribus.objectExists(strTempS2t):
			scribus.setProperty(strTempS2t, "yPos", strTempY3 - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
			if (scribus.getProperty(strTempS2t, "yPos") < strTempY2):
				strTempY2 = scribus.getProperty(strTempS2t, "yPos")
				strTempY1 = strTempY2
		h += 1

	j = 0
	while j < (strSetCount):
		strTempS5t = shpS5t + lstRndGrp[j]
		strTempS4t = shpS4t + lstRndGrp[j]
		strTempS3t = shpS3t + lstRndGrp[j]
		strTempS2t = shpS2t + lstRndGrp[j]
		strTempS1t = shpS1t + lstRndGrp[j]
		if scribus.objectExists(strTempS1t):
			scribus.setProperty(strTempS1t, "yPos", strTempY2 - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
			if (scribus.getProperty(strTempS1t, "yPos") < strTempY1):
				strTempY1 = scribus.getProperty(strTempS1t, "yPos")
		j += 1

def funcBottomPlacementYFrameGrouped():
	global strTempY1
	global strTempY2
	global strTempY3
	global strTempY4
	global strTempY5
	
	strTempY1 = strGroupedFrameBottom
	strTempY2 = strGroupedFrameBottom
	strTempY3 = strGroupedFrameBottom
	strTempY4 = strGroupedFrameBottom
	strTempY5 = strGroupedFrameBottom
	
	strTempFo = 'shpFo' + lstRndGrp[0]
	
	if strStyle == 'Outside':
		f = 0
		while f < (strSetCount):
			strTempS1b = shpS1b + lstRndGrp[f]
			if scribus.objectExists(strTempS1b):
				scribus.setProperty(strTempS1b, "yPos", strGroupedFrameBottom + strMarginBottom)
				if ((scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height")) > strTempY1):
					strTempY1 = (scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height"))
			f += 1
		g = 0
		while g < (strSetCount):
			strTempS1b = shpS1b + lstRndGrp[g]
			strTempS2b = shpS2b + lstRndGrp[g]
			if scribus.objectExists(strTempS2b):
				scribus.setProperty(strTempS2b, "yPos", strTempY1 + strVerticalSpacing)
				if ((scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height")) > strTempY2):
					strTempY2 = (scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height"))
			g += 1
		h = 0
		while h < (strSetCount):
			strTempS1b = shpS1b + lstRndGrp[h]
			strTempS2b = shpS2b + lstRndGrp[h]
			strTempS3b = shpS3b + lstRndGrp[h]
			if scribus.objectExists(strTempS3b):
				scribus.setProperty(strTempS3b, "yPos", strTempY2 + strVerticalSpacing)
				if ((scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height")) > strTempY3):
					strTempY3 = (scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height"))
			h += 1
		q = 0
		while q < (strSetCount):
			strTempS1b = shpS1b + lstRndGrp[q]
			strTempS2b = shpS2b + lstRndGrp[q]
			strTempS3b = shpS3b + lstRndGrp[q]
			strTempS4b = shpS4b + lstRndGrp[q]
			if scribus.objectExists(strTempS4b):
				scribus.setProperty(strTempS4b, "yPos", strTempY3 + strVerticalSpacing)
				if ((scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")) > strTempY4):
					strTempY4 = (scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height"))
			q += 1
		j = 0
		while j < (strSetCount):
			strTempS1b = shpS1b + lstRndGrp[j]
			strTempS2b = shpS2b + lstRndGrp[j]
			strTempS3b = shpS3b + lstRndGrp[j]
			strTempS4b = shpS4b + lstRndGrp[j]
			strTempS5b = shpS5b + lstRndGrp[j]
			if scribus.objectExists(strTempS5b):
				scribus.setProperty(strTempS5b, "yPos", strTempY4 + strVerticalSpacing)
				if ((scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")) > strTempY5):
					strTempY5 = (scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height"))
			j += 1
	elif strStyle == 'Inside - Catalog':
		v = 0
		while v < (strSetCount):
			strTempKb = 'shpKb' + lstRndGrp[v]
			if scribus.objectExists(strTempKb):
				if strSetOrientation == 'Horizontal':
					scribus.setProperty(strTempKb, "yPos", strGroupedFrameTop + strFrameOffset + \
					strPaddingTop + (strSetMaxH / 2) - (scribus.getProperty(strTempKb, "height") / 2))
				elif strSetOrientation == 'Vertical':
					if strSetKatalog == 'Individual':
						scribus.setProperty(strTempKb, "yPos", strTempTop + (lstStampH[v] / 2) - (scribus.getProperty(strTempKb, "height") / 2))
						strTempTop = strTempTop + lstStampH[v] + strSetSpacing
					else:
						scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
						(strFrameOuterHeight / 2) - (scribus.getProperty(strTempKb, "height") / 2))
				elif strFrameStyle == 'Internal':
					scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") - \
					(((scribus.getProperty(strTempFo, "height") * 100/90) - scribus.getProperty(strTempFo, "height")) / 2) + \
					(lstStampH[v] / 2) - (scribus.getProperty(strTempKb, "height") / 2))
			v += 1
	elif strStyle == 'Inside - Face Value':
		v = 0
		while v < (strSetCount):
			strTempFb = 'shpFb' + lstRndGrp[v]
			if scribus.objectExists(strTempFb):
				if strSetOrientation == 'Horizontal':
					scribus.setProperty(strTempFb, "yPos", strGroupedFrameTop + strFrameOffset + \
					strPaddingTop + (strSetMaxH / 2) - (scribus.getProperty(strTempFb, "height") / 2))
				elif strSetOrientation == 'Vertical':
					if strSetFace == 'Individual':
						scribus.setProperty(strTempFb, "yPos", strTempTop + (lstStampH[v] / 2) - (scribus.getProperty(strTempFb, "height") / 2))
						strTempTop = strTempTop + lstStampH[v] + strSetSpacing
					else:
						scribus.setProperty(strTempFb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
						(strFrameOuterHeight / 2) - (scribus.getProperty(strTempFb, "height") / 2))
				elif strFrameStyle == 'Internal':
					scribus.setProperty(strTempFb, "yPos", scribus.getProperty(strTempFo, "yPos") - \
					(((scribus.getProperty(strTempFo, "height") * 100/90) - scribus.getProperty(strTempFo, "height")) / 2) + \
					(lstStampH[v] / 2) - (scribus.getProperty(strTempFb, "height") / 2))
			v += 1
	elif strStyle == 'Outside/Inside':
		strTempTop = scribus.getProperty(strTempFo, "yPos") + strFrameOffset + strPaddingTop
		f = 0
		while f < (strSetCount):
			strTempS1b = shpS1b + lstRndGrp[f]
			if scribus.objectExists(strTempS1b) and shpS1b != 'shpKb':
				scribus.setProperty(strTempS1b, "yPos", strGroupedFrameBottom + strMarginBottom)
				if ((scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height")) > strTempY1):
					strTempY1 = (scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height"))
			f += 1
		g = 0
		while g < (strSetCount):
			strTempS1b = shpS1b + lstRndGrp[g]
			strTempS2b = shpS2b + lstRndGrp[g]
			if scribus.objectExists(strTempS2b) and shpS1b != 'shpKb':
				scribus.setProperty(strTempS2b, "yPos", strTempY1 + strVerticalSpacing)
				if ((scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height")) > strTempY2):
					strTempY2 = (scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height"))
			else:
				strTempY2 = strTempY1
			g += 1
		h = 0
		while h < (strSetCount):
			strTempS1b = shpS1b + lstRndGrp[h]
			strTempS2b = shpS2b + lstRndGrp[h]
			strTempS3b = shpS3b + lstRndGrp[h]
			if scribus.objectExists(strTempS3b) and shpS1b != 'shpKb':
				scribus.setProperty(strTempS3b, "yPos", strTempY2 + strVerticalSpacing)
				if ((scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height")) > strTempY3):
					strTempY3 = (scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height"))
			else:
				strTempY3 = strTempY2
			h += 1
		q = 0
		while q < (strSetCount):
			strTempS1b = shpS1b + lstRndGrp[q]
			strTempS2b = shpS2b + lstRndGrp[q]
			strTempS3b = shpS3b + lstRndGrp[q]
			strTempS4b = shpS4b + lstRndGrp[q]
			if scribus.objectExists(strTempS4b) and shpS1b != 'shpKb':
				scribus.setProperty(strTempS4b, "yPos", strTempY3 + strVerticalSpacing)
				if ((scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")) > strTempY4):
					strTempY4 = (scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height"))
			else:
				strTempY4 = strTempY3
			q += 1
		j = 0
		while j < (strSetCount):
			strTempS1b = shpS1b + lstRndGrp[j]
			strTempS2b = shpS2b + lstRndGrp[j]
			strTempS3b = shpS3b + lstRndGrp[j]
			strTempS4b = shpS4b + lstRndGrp[j]
			strTempS5b = shpS5b + lstRndGrp[j]
			if scribus.objectExists(strTempS5b) and shpS1b != 'shpKb':
				scribus.setProperty(strTempS5b, "yPos", strTempY4 + strVerticalSpacing)
				if ((scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")) > strTempY5):
					strTempY5 = (scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height"))
			else:
				strTempY5 = strTempY4
			j += 1
		if scribus.objectExists(strTempKb):
			if strSetOrientation == 'Horizontal':
				scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
				strFrameOffset + strPaddingTop + strSetMaxH + strOISpacing)
			elif strSetOrientation == 'Vertical' and strSetKatalog == 'Individual':
				scribus.setProperty(strTempKb, "yPos", strTempTop + lstPhotoH[h] + strOISpacing)
				strTempTop = strTempTop + lstPhotoH[h] + strOISpacing + scribus.getProperty(strTempKb, "height")
			elif strSetOrientation == 'Vertical' and strSetKatalog == 'Group':
				scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
				strFrameOffset + strPaddingTop + strSetTotH + (strVerticalSpacing * (strSetCount - 1)) + strOISpacing)

def funcRightPlacementYFrameGrouped():
	strTempFo = 'shpFo' + lstRndGrp[0]
	strPlacementYr = strGroupedFrameTop + strFrameOffset + strPaddingTop
	
	k = 0
	while k < strSetCount:
		strTempS1r = shpS1r + lstRndGrp[k]
		strTempS2r = shpS2r + lstRndGrp[k]
		strTempS3r = shpS3r + lstRndGrp[k]
		strTempS4r = shpS4r + lstRndGrp[k]
		strTempS5r = shpS5r + lstRndGrp[k]
		if strSetOrientation == 'Horizontal':
			strFrameOuterHeightI = strFrameOuterHeight
			strVertOffset = (strFrameOuterHeightI - lstRightOverallHeightG[k]) / 2
			strTempY = scribus.getProperty(strTempFo, "yPos") + strVertOffset
			if scribus.objectExists(strTempS1r):
				scribus.setProperty(strTempS1r, "yPos", strTempY)
				strTempY = scribus.getProperty(strTempS1r, "yPos") + scribus.getProperty(strTempS1r, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS2r):
				scribus.setProperty(strTempS2r, "yPos", strTempY)
				strTempY = scribus.getProperty(strTempS2r, "yPos") + scribus.getProperty(strTempS2r, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS3r):
				scribus.setProperty(strTempS3r, "yPos", strTempY)
				strTempY = scribus.getProperty(strTempS3r, "yPos") + scribus.getProperty(strTempS3r, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS4r):
				scribus.setProperty(strTempS4r, "yPos", strTempY)
				strTempY = scribus.getProperty(strTempS4r, "yPos") + scribus.getProperty(strTempS4r, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS5r):
				scribus.setProperty(strTempS5r, "yPos", strTempY)
		else:
			strVertOffsetI = (lstStampH[k] - lstRightOverallHeight[k]) / 2
			strVertOffsetG = (strFrameOuterHeight - lstRightOverallHeightG[k]) / 2
			strTempY = strPlacementYr + strVertOffsetI
			strTempYG = scribus.getProperty(strTempFo, "yPos") + strVertOffsetG
			if scribus.objectExists(strTempS1r):
				if strSetStack1 == 'Individual':
					scribus.setProperty(strTempS1r, "yPos", strTempY)
					strTempY = scribus.getProperty(strTempS1r, "yPos") + scribus.getProperty(strTempS1r, "height") + strVerticalSpacing
				else:
					scribus.setProperty(strTempS1r, "yPos", strTempYG)
					strTempYG = scribus.getProperty(strTempS1r, "yPos") + scribus.getProperty(strTempS1r, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS2r):
				if strSetStack2 == 'Individual':
					scribus.setProperty(strTempS2r, "yPos", strTempY)
					strTempY = scribus.getProperty(strTempS2r, "yPos") + scribus.getProperty(strTempS2r, "height") + strVerticalSpacing
				else:
					scribus.setProperty(strTempS2r, "yPos", strTempYG)
					strTempYG = scribus.getProperty(strTempS2r, "yPos") + scribus.getProperty(strTempS2r, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS3r):
				if strSetStack3 == 'Individual':
					scribus.setProperty(strTempS3r, "yPos", strTempY)
					strTempY = scribus.getProperty(strTempS3r, "yPos") + scribus.getProperty(strTempS3r, "height") + strVerticalSpacing
				else:
					scribus.setProperty(strTempS3r, "yPos", strTempYG)
					strTempYG = scribus.getProperty(strTempS3r, "yPos") + scribus.getProperty(strTempS3r, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS4r):
				if strSetStack4 == 'Individual':
					scribus.setProperty(strTempS4r, "yPos", strTempY)
					strTempY = scribus.getProperty(strTempS4r, "yPos") + scribus.getProperty(strTempS4r, "height") + strVerticalSpacing
				else:
					scribus.setProperty(strTempS4r, "yPos", strTempYG)
					strTempYG = scribus.getProperty(strTempS4r, "yPos") + scribus.getProperty(strTempS4r, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS5r):
				if strSetStack5 == 'Individual':
					scribus.setProperty(strTempS5r, "yPos", strTempY)
				else:
					scribus.setProperty(strTempS5r, "yPos", strTempYG)
			strPlacementYr = strPlacementYr + lstStampH[k] + strSetSpacing
		k += 1

def funcLeftPlacementYFrameGrouped():
	strTempFo = 'shpFo' + lstRndGrp[0]
	strPlacementYl = strGroupedFrameTop + strFrameOffset + strPaddingTop
	
	k = 0
	while k < strSetCount:
		strTempS1l = shpS1l + lstRndGrp[k]
		strTempS2l = shpS2l + lstRndGrp[k]
		strTempS3l = shpS3l + lstRndGrp[k]
		strTempS4l = shpS4l + lstRndGrp[k]
		strTempS5l = shpS5l + lstRndGrp[k]
		if strSetOrientation == 'Horizontal':
			strFrameOuterHeightI = strFrameOuterHeight
			strVertOffset = (strFrameOuterHeightI - lstLeftOverallHeightG[k]) / 2
			strTempY = scribus.getProperty(strTempFo, "yPos") + strVertOffset
			if scribus.objectExists(strTempS1l):
				scribus.setProperty(strTempS1l, "yPos", strTempY)
				strTempY = scribus.getProperty(strTempS1l, "yPos") + scribus.getProperty(strTempS1l, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS2l):
				scribus.setProperty(strTempS2l, "yPos", strTempY)
				strTempY = scribus.getProperty(strTempS2l, "yPos") + scribus.getProperty(strTempS2l, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS3l):
				scribus.setProperty(strTempS3l, "yPos", strTempY)
				strTempY = scribus.getProperty(strTempS3l, "yPos") + scribus.getProperty(strTempS3l, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS4l):
				scribus.setProperty(strTempS4l, "yPos", strTempY)
				strTempY = scribus.getProperty(strTempS4l, "yPos") + scribus.getProperty(strTempS4l, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS5l):
				scribus.setProperty(strTempS5l, "yPos", strTempY)
		else:
			strVertOffsetI = (lstStampH[k] - lstLeftOverallHeight[k]) / 2
			strVertOffsetG = (strFrameOuterHeight - lstLeftOverallHeightG[k]) / 2
			strTempY = strPlacementYl + strVertOffsetI
			strTempYG = scribus.getProperty(strTempFo, "yPos") + strVertOffsetG
			if scribus.objectExists(strTempS1l):
				if strSetStack1 == 'Individual':
					scribus.setProperty(strTempS1l, "yPos", strTempY)
					strTempY = scribus.getProperty(strTempS1l, "yPos") + scribus.getProperty(strTempS1l, "height") + strVerticalSpacing
				else:
					scribus.setProperty(strTempS1l, "yPos", strTempYG)
					strTempYG = scribus.getProperty(strTempS1l, "yPos") + scribus.getProperty(strTempS1l, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS2l):
				if strSetStack2 == 'Individual':
					scribus.setProperty(strTempS2l, "yPos", strTempY)
					strTempY = scribus.getProperty(strTempS2l, "yPos") + scribus.getProperty(strTempS2l, "height") + strVerticalSpacing
				else:
					scribus.setProperty(strTempS2l, "yPos", strTempYG)
					strTempYG = scribus.getProperty(strTempS2l, "yPos") + scribus.getProperty(strTempS2l, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS3l):
				if strSetStack3 == 'Individual':
					scribus.setProperty(strTempS3l, "yPos", strTempY)
					strTempY = scribus.getProperty(strTempS3l, "yPos") + scribus.getProperty(strTempS3l, "height") + strVerticalSpacing
				else:
					scribus.setProperty(strTempS3l, "yPos", strTempYG)
					strTempYG = scribus.getProperty(strTempS3l, "yPos") + scribus.getProperty(strTempS3l, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS4l):
				if strSetStack4 == 'Individual':
					scribus.setProperty(strTempS4l, "yPos", strTempY)
					strTempY = scribus.getProperty(strTempS4l, "yPos") + scribus.getProperty(strTempS4l, "height") + strVerticalSpacing
				else:
					scribus.setProperty(strTempS4l, "yPos", strTempYG)
					strTempYG = scribus.getProperty(strTempS4l, "yPos") + scribus.getProperty(strTempS4l, "height") + strVerticalSpacing
			if scribus.objectExists(strTempS5l):
				if strSetStack5 == 'Individual':
					scribus.setProperty(strTempS5l, "yPos", strTempY)
				else:
					scribus.setProperty(strTempS5l, "yPos", strTempYG)
			strPlacementYl = strPlacementYl + lstStampH[k] + strSetSpacing
		k += 1

def funcCenterMiddlesFrameGrouped():
	'''For text boxes on Left and Right, center them vertically on the frame'''
	intLe = len(lstLeftShp)
	intLeG = len(lstLeftShpG)
	global strLeftOverallHeight
	global strLeftOverallHeightG
	
	global lstLeftOverallHeight
	lstLeftOverallHeight = []
	global lstLeftOverallHeightG
	lstLeftOverallHeightG = []
	
	intRe = len(lstRightShp)
	intReG = len(lstRightShpG)
	global strRightOverallHeight
	global strRightOverallHeightG
	
	global lstRightOverallHeight
	lstRightOverallHeight = []
	global lstRightOverallHeightG
	lstRightOverallHeightG = []
	
	z = 0
	while z < strSetCount:
		strTempS1r = shpS1r + lstRndGrp[z]
		strTempS2r = shpS2r + lstRndGrp[z]
		strTempS3r = shpS3r + lstRndGrp[z]
		strTempS4r = shpS4r + lstRndGrp[z]
		strTempS5r = shpS5r + lstRndGrp[z]
		strTempS1l = shpS1l + lstRndGrp[z]
		strTempS2l = shpS2l + lstRndGrp[z]
		strTempS3l = shpS3l + lstRndGrp[z]
		strTempS4l = shpS4l + lstRndGrp[z]
		strTempS5l = shpS5l + lstRndGrp[z]
		
		Bh = 0
		BhG = 0
		Bk = 0
		BkG = 0
		intShpCountIL = 0
		intShpCountIR = 0
		intShpCountGL = 0
		intShpCountGR = 0

		if scribus.objectExists(strTempS1l):
			if strSetStack1 == 'Group':
				intKG = scribus.getProperty(strTempS1l, "height")
				BhG = BhG + intKG
				intShpCountGL = intShpCountGL + 1
			else:
				intK = scribus.getProperty(strTempS1l, "height")
				Bh = Bh + intK
				intShpCountIL = intShpCountIL + 1
		if scribus.objectExists(strTempS2l):
			if strSetStack2 == 'Group':
				intKG = scribus.getProperty(strTempS2l, "height")
				BhG = BhG + intKG
				intShpCountGL = intShpCountGL + 1
			else:
				intK = scribus.getProperty(strTempS2l, "height")
				Bh = Bh + intK
				intShpCountIL = intShpCountIL + 1
		if scribus.objectExists(strTempS3l):
			if strSetStack3 == 'Group':
				intKG = scribus.getProperty(strTempS3l, "height")
				BhG = BhG + intKG
				intShpCountGL = intShpCountGL + 1
			else:
				intK = scribus.getProperty(strTempS3l, "height")
				Bh = Bh + intK
				intShpCountIL = intShpCountIL + 1
		if scribus.objectExists(strTempS4l):
			if strSetStack4 == 'Group':
				intKG = scribus.getProperty(strTempS4l, "height")
				BhG = BhG + intKG
				intShpCountGL = intShpCountGL + 1
			else:
				intK = scribus.getProperty(strTempS4l, "height")
				Bh = Bh + intK
				intShpCountIL = intShpCountIL + 1
		if scribus.objectExists(strTempS5l):
			if strSetStack5 == 'Group':
				intKG = scribus.getProperty(strTempS5l, "height")
				BhG = BhG + intKG
				intShpCountGL = intShpCountGL + 1
			else:
				intK = scribus.getProperty(strTempS5l, "height")
				Bh = Bh + intK
				intShpCountIL = intShpCountIL + 1

		strLeftOverallHeight = Bh + ((intShpCountIL - 1) * strVerticalSpacing)
		lstLeftOverallHeight.append(strLeftOverallHeight)
		strLeftOverallHeightG = BhG + ((intShpCountGL - 1) * strVerticalSpacing)
		lstLeftOverallHeightG.append(strLeftOverallHeightG)

		if scribus.objectExists(strTempS1r):
			if strSetStack1 == 'Group':
				intKG = scribus.getProperty(strTempS1r, "height")
				BkG = BkG + intKG
				intShpCountGR = intShpCountGR + 1
			else:
				intK = scribus.getProperty(strTempS1r, "height")
				Bk = Bk + intK
				intShpCountIR = intShpCountIR + 1
		if scribus.objectExists(strTempS2r):
			if strSetStack2 == 'Group':
				intKG = scribus.getProperty(strTempS2r, "height")
				BkG = BkG + intKG
				intShpCountGR = intShpCountGR + 1
			else:
				intK = scribus.getProperty(strTempS2r, "height")
				Bk = Bk + intK
				intShpCountIR = intShpCountIR + 1
		if scribus.objectExists(strTempS3r):
			if strSetStack3 == 'Group':
				intKG = scribus.getProperty(strTempS3r, "height")
				BkG = BkG + intKG
				intShpCountGR = intShpCountGR + 1
			else:
				intK = scribus.getProperty(strTempS3r, "height")
				Bk = Bk + intK
				intShpCountIR = intShpCountIR + 1
		if scribus.objectExists(strTempS4r):
			if strSetStack4 == 'Group':
				intKG = scribus.getProperty(strTempS4r, "height")
				BkG = BkG + intKG
				intShpCountGR = intShpCountGR + 1
			else:
				intK = scribus.getProperty(strTempS4r, "height")
				Bk = Bk + intK
				intShpCountIR = intShpCountIR + 1
		if scribus.objectExists(strTempS5r):
			if strSetStack5 == 'Group':
				intKG = scribus.getProperty(strTempS5r, "height")
				BkG = BkG + intKG
				intShpCountGR = intShpCountGR + 1
			else:
				intK = scribus.getProperty(strTempS5r, "height")
				Bk = Bk + intK
				intShpCountIR = intShpCountIR + 1

		strRightOverallHeight = Bk + ((intShpCountIR - 1) * strVerticalSpacing)
		lstRightOverallHeight.append(strRightOverallHeight)
		strRightOverallHeightG = BkG + ((intShpCountGR -1) * strVerticalSpacing)
		lstRightOverallHeightG.append(strRightOverallHeightG)

		z += 1

def funcGenerateSetFrameIndiv():
	'''Set default placement to page center'''
	global strPlacementX
	global strPlacementY

	global topMargin, leftMargin, rightMargin, bottomMargin
	pageWidth, pageHeight = scribus.getPageSize()
	topMargin, leftMargin, rightMargin, bottomMargin = scribus.getPageMargins()

	global printAreaWidth
	global printAreaHeight
	printAreaWidth = pageWidth - leftMargin - rightMargin
	printAreaHeight = pageHeight - topMargin - bottomMargin 
	
	if strSetOrientation == 'Horizontal':
		strPlacementX = (round(float((printAreaWidth - (strSetTotW + ((strPaddingLeft + strPaddingRight) * strSetCount) + (strSetSpacing * (strSetCount - 1)) + (strFrameOffset * 2 * strSetCount)))/2 + leftMargin),4))
		strPlacementY = (round(float((printAreaHeight - (strSetMaxH + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)))/2 + topMargin),4))
	else:	 
		strPlacementY = (round(float((printAreaHeight - (strSetTotH + ((strPaddingTop + strPaddingBottom) * strSetCount) + (strSetSpacing * (strSetCount - 1)) + (strFrameOffset * 2 * strSetCount)))/2 + topMargin),4))
		strPlacementX = (round(float((printAreaWidth - (strSetMaxW + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)))/2 + leftMargin),4))
		
	'''Create working copy of global Placement variables'''
	global strPlacementXi
	global strPlacementYi
	strPlacementXi = strPlacementX
	strPlacementYi = strPlacementY
		
	'''Add the individual frames'''
	global fcnt
	fcnt = 0

	global lstRndIndiv
	lstRndIndiv = []
	global lstFoX
	lstFoX = []
	global lstFoY
	lstFoY = []
	
	global strFrameTop
	strFrameTop = printAreaHeight
	global strTempY5
	global strTempY4
	global strTempY3
	global strTempY2
	global strTempY1

	strTempY5 = printAreaHeight
	strTempY4 = printAreaHeight
	strTempY3 = printAreaHeight
	strTempY2 = printAreaHeight
	strTempY1 = printAreaHeight

	while fcnt < strSetCount:
		global rndf
		rndf = str(randint(10000,999999999))
		lstRndIndiv.append(rndf)
		if fcnt == 0:
			global rndfirst
			rndfirst = rndf
	
		'''Calculate frame dimensions'''
		global strFrameInnerHeight
		global strFrameInnerWidth
		global strFrameOuterHeight
		global strFrameOuterWidth
		global strFrameInnerHeightFI
		global strFrameInnerWidthFI
		global strFrameOuterHeightFI
		global strFrameOuterWidthFI

		if strSetOrientation == 'Horizontal':
			strFrameInnerHeight = strSetMaxH + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2)
			strFrameInnerWidth = strSetTotW + ((strPaddingLeft + strPaddingRight) * strSetCount) + ((strFrameThicknessInner * 2) * strSetCount) + ((strSetCount - 1) * strSetSpacing)
			strFrameOuterHeight = strSetMaxH + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
			strFrameOuterWidth = strSetTotW + ((strPaddingLeft + strPaddingRight) * strSetCount) + ((strFrameOffset * 2) * strSetCount) + ((strSetCount - 1) * strSetSpacing)
		else:
			strFrameInnerHeight = strSetTotH + ((strPaddingTop + strPaddingBottom) * strSetCount) + ((strFrameThicknessInner * 2) * strSetCount) + ((strSetCount - 1) * strSetSpacing)
			strFrameInnerWidth = strSetMaxW + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2)
			strFrameOuterHeight = strSetTotH + ((strPaddingTop + strPaddingBottom) * strSetCount) + ((strFrameOffset * 2) * strSetCount) + ((strSetCount - 1) * strSetSpacing)
			strFrameOuterWidth = strSetMaxW + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)

		'''if strFrameStyle == 'External':'''
		strFrameInnerHeightFI = lstStampH[fcnt] + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2)
		strFrameInnerWidthFI = lstStampW[fcnt] + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2)
		strFrameOuterHeightFI = lstStampH[fcnt] + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
		strFrameOuterWidthFI = lstStampW[fcnt] + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)
		'''else:'''
		strFrameOuterHeightNFI = (lstStampH[fcnt] * .9)
		strFrameOuterWidthNFI = (lstStampW[fcnt] * .9)
		
		global shpFo
		global shpFi

		'''shpTest2b = scribus.createText(100, 100, 50, 15, 'shpTest2b')
		scribus.setText(str(scribus.currentPage()), shpTest2b)'''
		if strSetOrientation == 'Horizontal':
			if strSetHFrameAlign == 'Center':
				strPlacementYi = (round(float((printAreaHeight - (lstStampH[fcnt] + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)))/2 + topMargin),4))
			elif strSetHFrameAlign == 'Top':
				strPlacementYi = (round(float((printAreaHeight - strFrameOuterHeight)/2 + topMargin),4))
			elif strSetHFrameAlign == 'Bottom':
				strPlacementYi = (round(float((printAreaHeight - strFrameOuterHeight)/2 + topMargin),4)) + strSetMaxH - lstStampH[fcnt]
			'''Draw the frame'''
			if strFrameStyle == 'External':
				if strFrameDouble == 'TRUE':
					shpFo = scribus.createRect(strPlacementXi + (strFrameThicknessOuter / 2), \
					strPlacementYi + (strFrameThicknessOuter / 2), (strFrameOuterWidthFI - strFrameThicknessOuter), \
					(strFrameOuterHeightFI - strFrameThicknessOuter), 'shpFo' + rndf)
					xPosit = strPlacementXi + (strFrameThicknessOuter / 2)
					yPosit = strPlacementYi
					lstFoX.append(xPosit)
					lstFoY.append(yPosit)
					scribus.setLineWidth(strFrameThicknessOuter, shpFo)
					lstFoS.append(shpFo)
					if scribus.getProperty(shpFo, "yPos") < strFrameTop:
						strFrameTop = scribus.getProperty(shpFo, "yPos")

					shpFi = scribus.createRect(strPlacementXi + (strFrameThicknessInner / 2), \
					strPlacementYi + (strFrameThicknessInner / 2), (strFrameInnerWidthFI - strFrameThicknessInner), \
					(strFrameInnerHeightFI - strFrameThicknessInner), 'shpFi' + rndf)
					scribus.setLineWidth(strFrameThicknessInner, shpFi)
					scribus.setLineShade(int(strFrameShadingInner),shpFi)
					lstFiS.append(shpFi)
					strFrameAlignOffsetI = strFrameThicknessOuter + strFrameSpacing
					scribus.setProperty(shpFi, "xPos", scribus.getProperty(shpFi, "xPos") + strFrameAlignOffsetI)
					scribus.setProperty(shpFi, "yPos", scribus.getProperty(shpFi, "yPos") + strFrameAlignOffsetI)
				else:
					shpFo = scribus.createRect(strPlacementXi + (strFrameThicknessOuter / 2), \
					strPlacementYi + (strFrameThicknessOuter / 2), (strFrameOuterWidthFI - strFrameThicknessOuter), \
					(strFrameOuterHeightFI - strFrameThicknessOuter), 'shpFo' + rndf)
					xPosit = strPlacementXi + (strFrameThicknessOuter / 2)
					yPosit = strPlacementYi
					lstFoX.append(xPosit)
					lstFoY.append(yPosit)
					scribus.setLineWidth(strFrameThicknessOuter, shpFo)
					lstFoS.append(shpFo)
					if scribus.getProperty(shpFo, "yPos") < strFrameTop:
						strFrameTop = scribus.getProperty(shpFo, "yPos")
				if strPhotoInclude == 'TRUE':
					funcGenerateSetFrameIndivPhotos(fcnt)
				strPlacementXi = strPlacementXi + strFrameOuterWidthFI + strSetSpacing
			else:
				shpFo = scribus.createRect(strPlacementXi + (lstStampW[fcnt] * .05) + (strFrameThicknessOuter / 2), \
				strPlacementYi + (lstStampH[fcnt] * .05) + (strFrameThicknessOuter / 2), strFrameOuterWidthNFI, \
				strFrameOuterHeightNFI, 'shpFo' + rndf)
				xPosit = strPlacementXi + (strFrameThicknessOuter / 2)
				yPosit = strPlacementYi
				lstFoX.append(xPosit)
				lstFoY.append(yPosit)
				scribus.setLineWidth(strFrameThicknessOuter, shpFo)
				lstFoS.append(shpFo)
				if scribus.getProperty(shpFo, "yPos") < strFrameTop:
					strFrameTop = scribus.getProperty(shpFo, "yPos")
				strPlacementXi = strPlacementXi + lstStampW[fcnt] + strSetSpacing
		else:
			if strSetVFrameAlign == 'Center':
				strPlacementXi = (round(float((printAreaWidth - (lstStampW[fcnt] + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)))/2 + leftMargin),4))
			elif strSetVFrameAlign == 'Left':
				strPlacementXi = (round(float((printAreaWidth - strFrameOuterWidth)/2 + leftMargin),4))
			elif strSetVFrameAlign == 'Right':
				strPlacementXi = (round(float((printAreaWidth - strFrameOuterWidth)/2 + leftMargin),4)) + strSetMaxW - lstStampW[fcnt]
			if strFrameStyle == 'External':
				if strFrameDouble == 'TRUE':
					shpFo = scribus.createRect(strPlacementXi + (strFrameThicknessOuter / 2), \
					strPlacementYi + (strFrameThicknessOuter / 2), (strFrameOuterWidthFI - strFrameThicknessOuter), \
					(strFrameOuterHeightFI - strFrameThicknessOuter), 'shpFo' + rndf)
					xPosit = strPlacementXi
					yPosit = strPlacementYi + (strFrameThicknessOuter / 2)
					lstFoX.append(xPosit)
					lstFoY.append(yPosit)
					scribus.setLineWidth(strFrameThicknessOuter, shpFo)
					lstFoS.append(shpFo)

					shpFi = scribus.createRect(strPlacementXi + (strFrameThicknessInner / 2), \
					strPlacementYi + (strFrameThicknessInner / 2), (strFrameInnerWidthFI - strFrameThicknessInner), \
					(strFrameInnerHeightFI - strFrameThicknessInner), 'shpFi' + rndf)
					scribus.setLineWidth(strFrameThicknessInner, shpFi)
					scribus.setLineShade(int(strFrameShadingInner),shpFi)
					lstFiS.append(shpFi)
					strFrameAlignOffsetI = strFrameThicknessOuter + strFrameSpacing
					scribus.setProperty(shpFi, "xPos", scribus.getProperty(shpFi, "xPos") + strFrameAlignOffsetI)
					scribus.setProperty(shpFi, "yPos", scribus.getProperty(shpFi, "yPos") + strFrameAlignOffsetI)
				else:
					shpFo = scribus.createRect(strPlacementXi + (strFrameThicknessOuter / 2), \
					strPlacementYi + (strFrameThicknessOuter / 2), (strFrameOuterWidthFI - strFrameThicknessOuter), \
					(strFrameOuterHeightFI - strFrameThicknessOuter), 'shpFo' + rndf)
					xPosit = strPlacementXi
					yPosit = strPlacementYi + (strFrameThicknessOuter / 2)
					lstFoX.append(xPosit)
					lstFoY.append(yPosit)
					scribus.setLineWidth(strFrameThicknessOuter, shpFo)
					lstFoS.append(shpFo)
				if strPhotoInclude == 'TRUE':
					funcGenerateSetFrameIndivPhotos(fcnt)
				strPlacementYi = strPlacementYi + strFrameOuterHeightFI + strSetSpacing
			else:
				shpFo = scribus.createRect(strPlacementXi + (lstStampW[fcnt] * .05) + (strFrameThicknessOuter / 2), \
				strPlacementYi + (lstStampH[fcnt] * .05) + (strFrameThicknessOuter / 2), strFrameOuterWidthNFI, \
				strFrameOuterHeightNFI, 'shpFo' + rndf)
				xPosit = strPlacementXi
				yPosit = strPlacementYi + (strFrameThicknessOuter / 2)
				lstFoX.append(xPosit)
				lstFoY.append(yPosit)
				scribus.setLineWidth(strFrameThicknessOuter, shpFo)
				lstFoS.append(shpFo)
				'''funcGenerateSetTextFI(fcnt)'''
				strPlacementYi = strPlacementYi + lstStampH[fcnt] + strSetSpacing
		fcnt += 1

def funcGenerateSetFrameIndivPhotos(fcnt):
	if lstPhoto[fcnt] != 'NullField':
		shpP = scribus.createImage(strPlacementXi, strPlacementYi, lstPhotoW[fcnt], lstPhotoH[fcnt], 'shpP' + rndf)
		strPhotoAlignOffsetX = strPaddingLeft + strFrameOffset + ((lstStampW[fcnt] - lstPhotoW[fcnt]) / 2)
		scribus.setProperty(shpP, "xPos", scribus.getProperty(shpP, "xPos") + strPhotoAlignOffsetX)
		strPhotoAlignOffsetY = strPaddingTop + strFrameOffset + ((lstStampH[fcnt] - lstPhotoH[fcnt]) / 2)
		scribus.setProperty(shpP, "yPos", scribus.getProperty(shpP, "yPos") + strPhotoAlignOffsetY)
		scribus.loadImage(lstPhoto[fcnt], shpP)
		scribus.setScaleImageToFrame(True, True, shpP)
		if strPhotoGreyscale == 'TRUE':
			scribus.setImageGrayscale(shpP)
		lstPS.append(shpP)

def funcGenerateSetFrameIndivText():
	if strTitleInclude == 'TRUE':
		funcTitlePlacementXFrameIndivText()
	if strDateInclude == 'TRUE':
		funcDatePlacementXFrameIndivText()
	if strKatalogInclude == 'TRUE':
		funcKatalogPlacementXFrameIndivText()
	if strFaceInclude == 'TRUE':
		funcFacePlacementXFrameIndivText()
	if strCaptionInclude == 'TRUE':
		funcCaptionPlacementXFrameIndivText()
	if strStyle == 'Inside - Catalog' or strStyle == 'Inside - Face Value':
		global strSetFrameTextAlign
		strSetFrameTextAlign = 'Individual'
	if strSetFrameTextAlign == 'Individual':
		funcTopPlacementYFrameIndivTextIndAlign()
		funcBottomPlacementYFrameIndivTextIndAlign()
	else:
		funcTopPlacementYFrameIndivTextGrpAlign()
		funcBottomPlacementYFrameIndivTextGrpAlign()
	funcCenterMiddlesFrameIndiv()
	funcRightPlacementYFrameIndivText()
	funcLeftPlacementYFrameIndivText()
	
def funcTitlePlacementXFrameIndivText():
	f = 0
	while f < (strSetCount):
		if lstTitle[f] == 'NullField':
			pass
		else:
			strFrameInnerHeightFI = lstStampH[f] + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2)
			strFrameInnerWidthFI = lstStampW[f] + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2)
			strFrameOuterHeightFI = lstStampH[f] + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
			strFrameOuterWidthFI = lstStampW[f] + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)
			strFrameOuterHeightNFI = (lstStampH[f] * .9)
			strFrameOuterWidthNFI = (lstStampW[f] * .9)

			'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
			if strFrameStyle == 'Internal':
				strFrameOuterWidthI = lstStampW[f]
				strFrameOuterHeightI = lstStampH[f]
			else:
				strFrameOuterWidthI = strFrameOuterWidthFI
				strFrameOuterHeightI = strFrameOuterHeightFI

			'''Add the Titles'''
			global shpTt
			global shpTb
			global shpTr
			global shpTl
			global shpTitleHot
			
			global shpS1t
			global shpS1b
			global shpS1r
			global shpS1l
			global shpS2t
			global shpS2b
			global shpS2r
			global shpS2l
			global shpS3t
			global shpS3b
			global shpS3r
			global shpS3l
			global shpS4t
			global shpS4b
			global shpS4r
			global shpS4l
			global shpS5t
			global shpS5b
			global shpS5r
			global shpS5l

			if strSetTitle == 'Group' and f == 0:
				strTitleWidth = strFrameOuterWidth * strTitleRatio / 100
				strTitleHeight = float(10)
				strTitleShift = ((strTitleWidth - strFrameOuterWidth) / 2)
				if strLayoutTitle == 'Top':
					strTitleLeft = lstFoX[f] - strTitleShift
					shpTt = scribus.createText(strTitleLeft, lstFoY[f], strTitleWidth, strTitleHeight, 'shpTt' + lstRndIndiv[f])
					lstTopShp.append(shpTt)
					scribus.setText(lstTitle[f], shpTt)
					shpTitleHot = shpTt
					if strStack1 == 'Title':
						shpS1t = 'shpTt'
					elif strStack2 == 'Title':
						shpS2t = 'shpTt'
					elif strStack3 == 'Title':
						shpS3t = 'shpTt'
					elif strStack4 == 'Title':
						shpS4t = 'shpTt'
					elif strStack5 == 'Title':
						shpS5t = 'shpTt'
				elif strLayoutTitle == 'Bottom':
					strTitleLeft = lstFoX[f] - strTitleShift
					shpTb = scribus.createText(strTitleLeft, lstFoY[f], strTitleWidth, strTitleHeight, 'shpTb' + lstRndIndiv[f])
					lstBottomShp.append(shpTb)
					scribus.setText(lstTitle[f], shpTb)
					shpTitleHot = shpTb
					if strStack1 == 'Title':
						shpS1b = 'shpTb'
					elif strStack2 == 'Title':
						shpS2b = 'shpTb'
					elif strStack3 == 'Title':
						shpS3b = 'shpTb'
					elif strStack4 == 'Title':
						shpS4b = 'shpTb'
					elif strStack5 == 'Title':
						shpS5b = 'shpTb'
				elif strLayoutTitle == 'Right':
					strTitleLeft = lstFoX[f] + strFrameOuterWidth + strMarginRight
					shpTr = scribus.createText(strTitleLeft, lstFoY[f], strTitleWidth, strTitleHeight, 'shpTr' + lstRndIndiv[f])
					lstRightShpG.append(shpTr)
					scribus.setText(lstTitle[f], shpTr)
					shpTitleHot = shpTr
					if strStack1 == 'Title':
						shpS1r = 'shpTr'
					elif strStack2 == 'Title':
						shpS2r = 'shpTr'
					elif strStack3 == 'Title':
						shpS3r = 'shpTr'
					elif strStack4 == 'Title':
						shpS4r = 'shpTr'
					elif strStack5 == 'Title':
						shpS5r = 'shpTr'
				elif strLayoutTitle == 'Left':
					strTitleLeft = lstFoX[f] - strMarginLeft - strTitleWidth
					shpTl = scribus.createText(strTitleLeft, lstFoY[f], strTitleWidth, strTitleHeight, 'shpTl' + lstRndIndiv[f])
					lstLeftShpG.append(shpTl)
					scribus.setText(lstTitle[f], shpTl)
					shpTitleHot = shpTl
					if strStack1 == 'Title':
						shpS1l = 'shpTl'
					elif strStack2 == 'Title':
						shpS2l = 'shpTl'
					elif strStack3 == 'Title':
						shpS3l = 'shpTl'
					elif strStack4 == 'Title':
						shpS4l = 'shpTl'
					elif strStack5 == 'Title':
						shpS5l = 'shpTl'
				if strTitleStyle == 'Global':
					TextLengthT = scribus.getTextLength(shpTitleHot)
					scribus.selectText(0,TextLengthT,shpTitleHot)
					scribus.setStyle("Title",shpTitleHot)
				else:
					scribus.setFont(strTitleFont, shpTitleHot)
					scribus.setFontSize(float(strTitleFontSize), shpTitleHot)
					if strTitleTextAlign == 'Left':
						scribus.setTextAlignment(0, shpTitleHot)
					elif strTitleTextAlign == "Center":
						scribus.setTextAlignment(1, shpTitleHot)
					elif strTitleTextAlign == 'Right':
						scribus.setTextAlignment(2, shpTitleHot)
					elif strTitleTextAlign == "Justified":
						scribus.setTextAlignment(3, shpTitleHot)	
					scribus.setLineSpacing(float(strTitleFontSize)*float(strTitleFontSpacing), shpTitleHot)
				if strTitleHyphen == 'TRUE':
					scribus.hyphenateText(shpTitleHot)
				(Tw, Th) = scribus.getSize(shpTitleHot)
				while (((scribus.textOverflows(shpTitleHot) == 0)) and (Th > 0)) :
					Th -= 1
					scribus.sizeObject(Tw, Th, shpTitleHot)
				while ((scribus.textOverflows(shpTitleHot) > 0)) :
					Th += 1
					scribus.sizeObject(Tw, Th, shpTitleHot)
				'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
				scribus.sizeObject(Tw, Th+1, shpTitleHot)
				lstTS.append(shpTitleHot)
			elif strSetTitle == 'Group' and f > 0:
				pass
			elif strSetTitle == 'Individual':
				strTitleWidth = strFrameOuterWidthI * strTitleRatio / 100
				strTitleHeight = float(10)
				strTitleShift = ((strTitleWidth - strFrameOuterWidthI) / 2)
				if strLayoutTitle == 'Top':
					strTitleLeft = lstFoX[f] - strTitleShift
					shpTt = scribus.createText(strTitleLeft, lstFoY[f], strTitleWidth, strTitleHeight, 'shpTt' + lstRndIndiv[f])
					lstTopShp.append(shpTt)
					scribus.setText(lstTitle[f], shpTt)
					shpTitleHot = shpTt
					if strStack1 == 'Title':
						shpS1t = 'shpTt'
					elif strStack2 == 'Title':
						shpS2t = 'shpTt'
					elif strStack3 == 'Title':
						shpS3t = 'shpTt'
					elif strStack4 == 'Title':
						shpS4t = 'shpTt'
					elif strStack5 == 'Title':
						shpS5t = 'shpTt'
				elif strLayoutTitle == 'Bottom':
					strTitleLeft = lstFoX[f] - strTitleShift
					shpTb = scribus.createText(strTitleLeft, lstFoY[f], strTitleWidth, strTitleHeight, 'shpTb' + lstRndIndiv[f])
					lstBottomShp.append(shpTb)
					scribus.setText(lstTitle[f], shpTb)
					shpTitleHot = shpTb
					if strStack1 == 'Title':
						shpS1b = 'shpTb'
					elif strStack2 == 'Title':
						shpS2b = 'shpTb'
					elif strStack3 == 'Title':
						shpS3b = 'shpTb'
					elif strStack4 == 'Title':
						shpS4b = 'shpTb'
					elif strStack5 == 'Title':
						shpS5b = 'shpTb'
				elif strLayoutTitle == 'Right':
					strTitleLeft = lstFoX[f] + strFrameOuterWidthI + strMarginRight
					shpTr = scribus.createText(strTitleLeft, lstFoY[f], strTitleWidth, strTitleHeight, 'shpTr' + lstRndIndiv[f])
					lstRightShp.append(shpTr)
					scribus.setText(lstTitle[f], shpTr)
					shpTitleHot = shpTr
					if strStack1 == 'Title':
						shpS1r = 'shpTr'
					elif strStack2 == 'Title':
						shpS2r = 'shpTr'
					elif strStack3 == 'Title':
						shpS3r = 'shpTr'
					elif strStack4 == 'Title':
						shpS4r = 'shpTr'
					elif strStack5 == 'Title':
						shpS5r = 'shpTr'
				elif strLayoutTitle == 'Left':
					strTitleLeft = lstFoX[f] - strMarginLeft - strTitleWidth
					shpTl = scribus.createText(strTitleLeft, lstFoY[f], strTitleWidth, strTitleHeight, 'shpTl' + lstRndIndiv[f])
					lstLeftShp.append(shpTl)
					scribus.setText(lstTitle[f], shpTl)
					shpTitleHot = shpTl
					if strStack1 == 'Title':
						shpS1l = 'shpTl'
					elif strStack2 == 'Title':
						shpS2l = 'shpTl'
					elif strStack3 == 'Title':
						shpS3l = 'shpTl'
					elif strStack4 == 'Title':
						shpS4l = 'shpTl'
					elif strStack5 == 'Title':
						shpS5l = 'shpTl'
				if strTitleStyle == 'Global':
					TextLengthT = scribus.getTextLength(shpTitleHot)
					scribus.selectText(0,TextLengthT,shpTitleHot)
					scribus.setStyle("Title",shpTitleHot)
				else:
					scribus.setFont(strTitleFont, shpTitleHot)
					scribus.setFontSize(float(strTitleFontSize), shpTitleHot)
					if strTitleTextAlign == 'Left':
						scribus.setTextAlignment(0, shpTitleHot)
					elif strTitleTextAlign == "Center":
						scribus.setTextAlignment(1, shpTitleHot)
					elif strTitleTextAlign == 'Right':
						scribus.setTextAlignment(2, shpTitleHot)
					elif strTitleTextAlign == "Justified":
						scribus.setTextAlignment(3, shpTitleHot)	
					scribus.setLineSpacing(float(strTitleFontSize)*float(strTitleFontSpacing), shpTitleHot)
				if strTitleHyphen == 'TRUE':
					scribus.hyphenateText(shpTitleHot)
				(Tw, Th) = scribus.getSize(shpTitleHot)
				while (((scribus.textOverflows(shpTitleHot) == 0)) and (Th > 0)) :
					Th -= 1
					scribus.sizeObject(Tw, Th, shpTitleHot)
				while ((scribus.textOverflows(shpTitleHot) > 0)) :
					Th += 1
					scribus.sizeObject(Tw, Th, shpTitleHot)
				'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
				scribus.sizeObject(Tw, Th+1, shpTitleHot)
				lstTS.append(shpTitleHot)
		f += 1
	if strSetFrameTextAlign == 'Group':
		strTempTx = 0
		a = 0
		while a < strSetCount:
			if scribus.objectExists('shpTr' + lstRndIndiv[a]):
				tx = scribus.getProperty('shpTr' + lstRndIndiv[a], "xPos")
				if tx > strTempTx:
					strTempTx = tx
			a += 1
		b = 0
		while b < strSetCount:
			if scribus.objectExists('shpTr' + lstRndIndiv[b]):
				scribus.setProperty('shpTr' + lstRndIndiv[b], "xPos", strTempTx)
			b += 1 
		strTempTx = printAreaWidth
		c = 0
		while c < strSetCount:
			if scribus.objectExists('shpTl' + lstRndIndiv[c]):
				tx = scribus.getProperty('shpTl' + lstRndIndiv[c], "xPos") + scribus.getProperty('shpTl' + lstRndIndiv[c], "width")
				if tx < strTempTx:
					strTempTx = tx
			c += 1
		d = 0
		while d < strSetCount:
			if scribus.objectExists('shpTl' + lstRndIndiv[d]):
				scribus.setProperty('shpTl' + lstRndIndiv[d], "xPos", strTempTx - scribus.getProperty('shpTl' + lstRndIndiv[d], "width"))
			d += 1 

def funcDatePlacementXFrameIndivText():
	f = 0
	while f < (strSetCount):
		if lstDate[f] == 'NullField':
			pass
		else:
			strFrameInnerHeightFI = lstStampH[f] + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2)
			strFrameInnerWidthFI = lstStampW[f] + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2)
			strFrameOuterHeightFI = lstStampH[f] + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
			strFrameOuterWidthFI = lstStampW[f] + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)
			strFrameOuterHeightNFI = (lstStampH[f] * .9)
			strFrameOuterWidthNFI = (lstStampW[f] * .9)

			'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
			if strFrameStyle == 'Internal':
				strFrameOuterWidthI = lstStampW[f]
				strFrameOuterHeightI = lstStampH[f]
			else:
				strFrameOuterWidthI = strFrameOuterWidthFI
				strFrameOuterHeightI = strFrameOuterHeightFI

			'''Add the Dates'''
			global shpDt
			global shpDb
			global shpDr
			global shpDl
			global shpDateHot

			global shpS1t
			global shpS1b
			global shpS1r
			global shpS1l
			global shpS2t
			global shpS2b
			global shpS2r
			global shpS2l
			global shpS3t
			global shpS3b
			global shpS3r
			global shpS3l
			global shpS4t
			global shpS4b
			global shpS4r
			global shpS4l
			global shpS5t
			global shpS5b
			global shpS5r
			global shpS5l

			if strSetDate == 'Group' and f == 0:
				strDateWidth = strFrameOuterWidth * strDateRatio / 100
				strDateHeight = float(10)
				strDateShift = ((strDateWidth - strFrameOuterWidth) / 2)
				if strLayoutDate == 'Top':
					strDateLeft = lstFoX[f] - strDateShift
					shpDt = scribus.createText(strDateLeft, lstFoY[f], strDateWidth, strDateHeight, 'shpDt' + lstRndIndiv[f])
					scribus.setText(lstDate[f], shpDt)
					lstTopShp.append(shpDt)
					shpDateHot = shpDt
					if strStack1 == 'Date':
						shpS1t = 'shpDt'
					elif strStack2 == 'Date':
						shpS2t = 'shpDt'
					elif strStack3 == 'Date':
						shpS3t = 'shpDt'
					elif strStack4 == 'Date':
						shpS4t = 'shpDt'
					elif strStack5 == 'Date':
						shpS5t = 'shpDt'
				elif strLayoutDate == 'Bottom':
					strDateLeft = lstFoX[f] - strDateShift
					shpDb = scribus.createText(strDateLeft, lstFoY[f], strDateWidth, strDateHeight, 'shpDb' + lstRndIndiv[f])
					scribus.setText(lstDate[f], shpDb)
					lstBottomShp.append(shpDb)
					shpDateHot = shpDb
					if strStack1 == 'Date':
						shpS1b = 'shpDb'
					elif strStack2 == 'Date':
						shpS2b = 'shpDb'
					elif strStack3 == 'Date':
						shpS3b = 'shpDb'
					elif strStack4 == 'Date':
						shpS4b = 'shpDb'
					elif strStack5 == 'Date':
						shpS5b = 'shpDb'
				elif strLayoutDate == 'Right':
					strDateLeft = lstFoX[f] + strFrameOuterWidth + strMarginRight
					shpDr = scribus.createText(strDateLeft, lstFoY[f], strDateWidth, strDateHeight, 'shpDr' + lstRndIndiv[f])
					scribus.setText(lstDate[f], shpDr)
					lstRightShpG.append(shpDr)
					shpDateHot = shpDr
					if strStack1 == 'Date':
						shpS1r = 'shpDr'
					elif strStack2 == 'Date':
						shpS2r = 'shpDr'
					elif strStack3 == 'Date':
						shpS3r = 'shpDr'
					elif strStack4 == 'Date':
						shpS4r = 'shpDr'
					elif strStack5 == 'Date':
						shpS5r = 'shpDr'
				elif strLayoutDate == 'Left':
					strDateLeft = lstFoX[f] - strMarginLeft - strDateWidth
					shpDl = scribus.createText(strDateLeft, lstFoY[f], strDateWidth, strDateHeight, 'shpDl' + lstRndIndiv[f])
					scribus.setText(lstDate[f], shpDl)
					lstLeftShpG.append(shpDl)
					shpDateHot = shpDl
					if strStack1 == 'Date':
						shpS1l = 'shpDl'
					elif strStack2 == 'Date':
						shpS2l = 'shpDl'
					elif strStack3 == 'Date':
						shpS3l = 'shpDl'
					elif strStack4 == 'Date':
						shpS4l = 'shpDl'
					elif strStack5 == 'Date':
						shpS5l = 'shpDl'
				if strDateStyle == 'Global':
					TextLengthD = scribus.getTextLength(shpDateHot)
					scribus.selectText(0,TextLengthD,shpDateHot)
					scribus.setStyle("Date",shpDateHot)
				else:
					scribus.setFont(strDateFont, shpDateHot)
					scribus.setFontSize(float(strDateFontSize), shpDateHot)
					if strDateTextAlign == 'Left':
						scribus.setTextAlignment(0, shpDateHot)
					elif strDateTextAlign == "Center":
						scribus.setTextAlignment(1, shpDateHot)
					elif strDateTextAlign == 'Right':
						scribus.setTextAlignment(2, shpDateHot)
					elif strDateTextAlign == "Justified":
						scribus.setTextAlignment(3, shpDateHot)	   
					scribus.setLineSpacing(float(strDateFontSize)*float(strDateFontSpacing), shpDateHot)
				if strDateHyphen == 'TRUE':
					scribus.hyphenateText(shpDateHot)
				(Dw, Dh) = scribus.getSize(shpDateHot)
				while (((scribus.textOverflows(shpDateHot) == 0)) and (Dh > 0)) :
					Dh -= 1
					scribus.sizeObject(Dw, Dh, shpDateHot)
				while ((scribus.textOverflows(shpDateHot) > 0)) :
					Dh += 1
					scribus.sizeObject(Dw, Dh, shpDateHot)
				'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
				scribus.sizeObject(Dw, Dh+1, shpDateHot)
				lstDS.append(shpDateHot)
			elif strSetDate == 'Group' and f > 0:
				pass
			elif strSetDate == 'Individual':
				strDateWidth = strFrameOuterWidthI * strDateRatio / 100
				strDateHeight = float(10)
				strDateShift = ((strDateWidth - strFrameOuterWidthI) / 2)
				if strLayoutDate == 'Top':
					strDateLeft = lstFoX[f] - strDateShift
					shpDt = scribus.createText(strDateLeft, lstFoY[f], strDateWidth, strDateHeight, 'shpDt' + lstRndIndiv[f])
					scribus.setText(lstDate[f], shpDt)
					lstTopShp.append(shpDt)
					shpDateHot = shpDt
					if strStack1 == 'Date':
						shpS1t = 'shpDt'
					elif strStack2 == 'Date':
						shpS2t = 'shpDt'
					elif strStack3 == 'Date':
						shpS3t = 'shpDt'
					elif strStack4 == 'Date':
						shpS4t = 'shpDt'
					elif strStack5 == 'Date':
						shpS5t = 'shpDt'
				elif strLayoutDate == 'Bottom':
					strDateLeft = lstFoX[f] - strDateShift
					shpDb = scribus.createText(strDateLeft, lstFoY[f], strDateWidth, strDateHeight, 'shpDb' + lstRndIndiv[f])
					scribus.setText(lstDate[f], shpDb)
					lstBottomShp.append(shpDb)
					shpDateHot = shpDb
					if strStack1 == 'Date':
						shpS1b = 'shpDb'
					elif strStack2 == 'Date':
						shpS2b = 'shpDb'
					elif strStack3 == 'Date':
						shpS3b = 'shpDb'
					elif strStack4 == 'Date':
						shpS4b = 'shpDb'
					elif strStack5 == 'Date':
						shpS5b = 'shpDb'
				elif strLayoutDate == 'Right':
					strDateLeft = lstFoX[f] + strFrameOuterWidthI + strMarginRight
					shpDr = scribus.createText(strDateLeft, lstFoY[f], strDateWidth, strDateHeight, 'shpDr' + lstRndIndiv[f])
					scribus.setText(lstDate[f], shpDr)
					lstRightShp.append(shpDr)
					shpDateHot = shpDr
					if strStack1 == 'Date':
						shpS1r = 'shpDr'
					elif strStack2 == 'Date':
						shpS2r = 'shpDr'
					elif strStack3 == 'Date':
						shpS3r = 'shpDr'
					elif strStack4 == 'Date':
						shpS4r = 'shpDr'
					elif strStack5 == 'Date':
						shpS5r = 'shpDr'
				elif strLayoutDate == 'Left':
					strDateLeft = lstFoX[f] - strMarginLeft - strDateWidth
					shpDl = scribus.createText(strDateLeft, lstFoY[f], strDateWidth, strDateHeight, 'shpDl' + lstRndIndiv[f])
					scribus.setText(lstDate[f], shpDl)
					lstLeftShp.append(shpDl)
					shpDateHot = shpDl
					if strStack1 == 'Date':
						shpS1l = 'shpDl'
					elif strStack2 == 'Date':
						shpS2l = 'shpDl'
					elif strStack3 == 'Date':
						shpS3l = 'shpDl'
					elif strStack4 == 'Date':
						shpS4l = 'shpDl'
					elif strStack5 == 'Date':
						shpS5l = 'shpDl'
				if strDateStyle == 'Global':
					TextLengthD = scribus.getTextLength(shpDateHot)
					scribus.selectText(0,TextLengthD,shpDateHot)
					scribus.setStyle("Date",shpDateHot)
				else:
					scribus.setFont(strDateFont, shpDateHot)
					scribus.setFontSize(float(strDateFontSize), shpDateHot)
					if strDateTextAlign == 'Left':
						scribus.setTextAlignment(0, shpDateHot)
					elif strDateTextAlign == "Center":
						scribus.setTextAlignment(1, shpDateHot)
					elif strDateTextAlign == 'Right':
						scribus.setTextAlignment(2, shpDateHot)
					elif strDateTextAlign == "Justified":
						scribus.setTextAlignment(3, shpDateHot)	   
					scribus.setLineSpacing(float(strDateFontSize)*float(strDateFontSpacing), shpDateHot)
				if strDateHyphen == 'TRUE':
					scribus.hyphenateText(shpDateHot)
				(Dw, Dh) = scribus.getSize(shpDateHot)
				while (((scribus.textOverflows(shpDateHot) == 0)) and (Dh > 0)) :
					Dh -= 1
					scribus.sizeObject(Dw, Dh, shpDateHot)
				while ((scribus.textOverflows(shpDateHot) > 0)) :
					Dh += 1
					scribus.sizeObject(Dw, Dh, shpDateHot)
				'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
				scribus.sizeObject(Dw, Dh+1, shpDateHot)
				lstDS.append(shpDateHot)
		f += 1
	if strSetFrameTextAlign == 'Group':
		strTempDx = 0
		a = 0
		while a < strSetCount:
			if scribus.objectExists('shpDr' + lstRndIndiv[a]):
				dx = scribus.getProperty('shpDr' + lstRndIndiv[a], "xPos")
				if dx > strTempDx:
					strTempDx = dx
			a += 1
		b = 0
		while b < strSetCount:
			if scribus.objectExists('shpDr' + lstRndIndiv[b]):
				scribus.setProperty('shpDr' + lstRndIndiv[b], "xPos", strTempDx)
			b += 1 
		strTempDx = printAreaWidth
		c = 0
		while c < strSetCount:
			if scribus.objectExists('shpDl' + lstRndIndiv[c]):
				dx = scribus.getProperty('shpDl' + lstRndIndiv[c], "xPos") + scribus.getProperty('shpDl' + lstRndIndiv[c], "width")
				if dx < strTempDx:
					strTempDx = dx
			c += 1
		d = 0
		while d < strSetCount:
			if scribus.objectExists('shpDl' + lstRndIndiv[d]):
				scribus.setProperty('shpDl' + lstRndIndiv[d], "xPos", strTempDx - scribus.getProperty('shpDl' + lstRndIndiv[d], "width"))
			d += 1 

def funcKatalogPlacementXFrameIndivText():
	f = 0
	while f < (strSetCount):
		if lstKatalog[f] == 'NullField':
			pass
		else:
			strFrameInnerHeightFI = lstStampH[f] + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2)
			strFrameInnerWidthFI = lstStampW[f] + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2)
			strFrameOuterHeightFI = lstStampH[f] + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
			strFrameOuterWidthFI = lstStampW[f] + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)
			strFrameOuterHeightNFI = (lstStampH[f] * .9)
			strFrameOuterWidthNFI = (lstStampW[f] * .9)

			'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
			if strFrameStyle == 'Internal':
				strFrameOuterWidthI = lstStampW[f]
				strFrameOuterHeightI = lstStampH[f]
			else:
				strFrameOuterWidthI = strFrameOuterWidthFI
				strFrameOuterHeightI = strFrameOuterHeightFI

			'''Add the Katalogs'''
			global shpKt
			global shpKb
			global shpKr
			global shpKl
			global shpKatalogHot

			global shpS1t
			global shpS1b
			global shpS1r
			global shpS1l
			global shpS2t
			global shpS2b
			global shpS2r
			global shpS2l
			global shpS3t
			global shpS3b
			global shpS3r
			global shpS3l
			global shpS4t
			global shpS4b
			global shpS4r
			global shpS4l
			global shpS5t
			global shpS5b
			global shpS5r
			global shpS5l

			if strSetKatalog == 'Group' and f == 0:
				strKatalogWidth = strFrameOuterWidth * strKatalogRatio / 100
				strKatalogHeight = float(10)
				strKatalogShift = ((strKatalogWidth - strFrameOuterWidth) / 2)
				if strLayoutKatalog == 'Top':
					'''strKatalogLeft = strPlacementXo - strKatalogShift'''
					strKatalogLeft = lstFoX[f] - strKatalogShift
					shpKt = scribus.createText(strKatalogLeft, lstFoY[f], strKatalogWidth, strKatalogHeight, 'shpKt' + lstRndIndiv[f])
					lstTopShp.append(shpKt)
					scribus.setText(lstKatalog[f], shpKt)
					shpKatalogHot = shpKt
					if strStack1 == 'Catalog':
						shpS1t = 'shpKt'
					elif strStack2 == 'Catalog':
						shpS2t = 'shpKt'
					elif strStack3 == 'Catalog':
						shpS3t = 'shpKt'
					elif strStack4 == 'Catalog':
						shpS4t = 'shpKt'
					elif strStack5 == 'Catalog':
						shpS5t = 'shpKt'
				elif strLayoutKatalog == 'Bottom':
					strKatalogLeft = lstFoX[f] - strKatalogShift
					shpKb = scribus.createText(strKatalogLeft, lstFoY[f], strKatalogWidth, strKatalogHeight, 'shpKb' + lstRndIndiv[f])
					lstBottomShp.append(shpKb)
					scribus.setText(lstKatalog[f], shpKb)
					shpKatalogHot = shpKb
					if strStack1 == 'Catalog':
						shpS1b = 'shpKb'
					elif strStack2 == 'Catalog':
						shpS2b = 'shpKb'
					elif strStack3 == 'Catalog':
						shpS3b = 'shpKb'
					elif strStack4 == 'Catalog':
						shpS4b = 'shpKb'
					elif strStack5 == 'Catalog':
						shpS5b = 'shpKb'
				elif strLayoutKatalog == 'Right':
					strKatalogLeft = lstFoX[f] + strFrameOuterWidth + strMarginRight
					shpKr = scribus.createText(strKatalogLeft, lstFoY[f], strKatalogWidth, strKatalogHeight, 'shpKr' + lstRndIndiv[f])
					lstRightShpG.append(shpKr)
					scribus.setText(lstKatalog[f], shpKr)
					shpKatalogHot = shpKr
					if strStack1 == 'Catalog':
						shpS1r = 'shpKr'
					elif strStack2 == 'Catalog':
						shpS2r = 'shpKr'
					elif strStack3 == 'Catalog':
						shpS3r = 'shpKr'
					elif strStack4 == 'Catalog':
						shpS4r = 'shpKr'
					elif strStack5 == 'Catalog':
						shpS5r = 'shpKr'
				elif strLayoutKatalog == 'Left':
					strKatalogLeft = lstFoX[f] - strMarginLeft - strKatalogWidth
					shpKl = scribus.createText(strKatalogLeft, lstFoY[f], strKatalogWidth, strKatalogHeight, 'shpKl' + lstRndIndiv[f])
					lstLeftShpG.append(shpKl)
					scribus.setText(lstKatalog[f], shpKl)
					shpKatalogHot = shpKl
					if strStack1 == 'Catalog':
						shpS1l = 'shpKl'
					elif strStack2 == 'Catalog':
						shpS2l = 'shpKl'
					elif strStack3 == 'Catalog':
						shpS3l = 'shpKl'
					elif strStack4 == 'Catalog':
						shpS4l = 'shpKl'
					elif strStack5 == 'Catalog':
						shpS5l = 'shpKl'
				if strKatalogStyle == 'Global':
					TextLengthK = scribus.getTextLength(shpKatalogHot)
					scribus.selectText(0,TextLengthK,shpKatalogHot)
					scribus.setStyle("Katalog",shpKatalogHot)
				else:
					scribus.setFont(strKatalogFont, shpKatalogHot)
					scribus.setFontSize(float(strKatalogFontSize), shpKatalogHot)
					if strKatalogTextAlign == 'Left':
						scribus.setTextAlignment(0, shpKatalogHot)
					elif strKatalogTextAlign == "Center":
						scribus.setTextAlignment(1, shpKatalogHot)
					elif strKatalogTextAlign == 'Right':
						scribus.setTextAlignment(2, shpKatalogHot)
					elif strKatalogTextAlign == "Justified":
						scribus.setTextAlignment(3, shpKatalogHot)	  
					scribus.setLineSpacing(float(strKatalogFontSize)*float(strKatalogFontSpacing), shpKatalogHot)
				if strKatalogHyphen == 'TRUE':
					scribus.hyphenateText(shpKatalogHot)
				(Kw, Kh) = scribus.getSize(shpKatalogHot)
				while (((scribus.textOverflows(shpKatalogHot) == 0)) and (Kh > 0)) :
					Kh -= 1
					scribus.sizeObject(Kw, Kh, shpKatalogHot)
				while ((scribus.textOverflows(shpKatalogHot) > 0)) :
					Kh += 1
					scribus.sizeObject(Kw, Kh, shpKatalogHot)
				'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
				scribus.sizeObject(Kw, Kh+1, shpKatalogHot)
				lstKS.append(shpKatalogHot)
			elif strSetKatalog == 'Group' and f > 0:
				pass
			elif strSetKatalog == 'Individual':
				strKatalogWidth = strFrameOuterWidthI * strKatalogRatio / 100
				strKatalogHeight = float(10)
				strKatalogShift = ((strKatalogWidth - strFrameOuterWidthI) / 2)
				if strLayoutKatalog == 'Top':
					strKatalogLeft = lstFoX[f] - strKatalogShift
					shpKt = scribus.createText(strKatalogLeft, lstFoY[f], strKatalogWidth, strKatalogHeight, 'shpKt' + lstRndIndiv[f])
					lstTopShp.append(shpKt)
					scribus.setText(lstKatalog[f], shpKt)
					shpKatalogHot = shpKt
					if strStack1 == 'Catalog':
						shpS1t = 'shpKt'
					elif strStack2 == 'Catalog':
						shpS2t = 'shpKt'
					elif strStack3 == 'Catalog':
						shpS3t = 'shpKt'
					elif strStack4 == 'Catalog':
						shpS4t = 'shpKt'
					elif strStack5 == 'Catalog':
						shpS5t = 'shpKt'
				elif strLayoutKatalog == 'Bottom':
					strKatalogLeft = lstFoX[f] - strKatalogShift
					shpKb = scribus.createText(strKatalogLeft, lstFoY[f], strKatalogWidth, strKatalogHeight, 'shpKb' + lstRndIndiv[f])
					lstBottomShp.append(shpKb)
					scribus.setText(lstKatalog[f], shpKb)
					shpKatalogHot = shpKb
					if strStack1 == 'Catalog':
						shpS1b = 'shpKb'
					elif strStack2 == 'Catalog':
						shpS2b = 'shpKb'
					elif strStack3 == 'Catalog':
						shpS3b = 'shpKb'
					elif strStack4 == 'Catalog':
						shpS4b = 'shpKb'
					elif strStack5 == 'Catalog':
						shpS5b = 'shpKb'
				elif strLayoutKatalog == 'Right':
					strKatalogLeft = lstFoX[f] + strFrameOuterWidthI + strMarginRight
					shpKr = scribus.createText(strKatalogLeft, lstFoY[f], strKatalogWidth, strKatalogHeight, 'shpKr' + lstRndIndiv[f])
					lstRightShp.append(shpKr)
					scribus.setText(lstKatalog[f], shpKr)
					shpKatalogHot = shpKr
					if strStack1 == 'Catalog':
						shpS1r = 'shpKr'
					elif strStack2 == 'Catalog':
						shpS2r = 'shpKr'
					elif strStack3 == 'Catalog':
						shpS3r = 'shpKr'
					elif strStack4 == 'Catalog':
						shpS4r = 'shpKr'
					elif strStack5 == 'Catalog':
						shpS5r = 'shpKr'
				elif strLayoutKatalog == 'Left':
					strKatalogLeft = lstFoX[f] - strMarginLeft - strKatalogWidth
					shpKl = scribus.createText(strKatalogLeft, lstFoY[f], strKatalogWidth, strKatalogHeight, 'shpKl' + lstRndIndiv[f])
					lstLeftShp.append(shpKl)
					scribus.setText(lstKatalog[f], shpKl)
					shpKatalogHot = shpKl
					if strStack1 == 'Catalog':
						shpS1l = 'shpKl'
					elif strStack2 == 'Catalog':
						shpS2l = 'shpKl'
					elif strStack3 == 'Catalog':
						shpS3l = 'shpKl'
					elif strStack4 == 'Catalog':
						shpS4l = 'shpKl'
					elif strStack5 == 'Catalog':
						shpS5l = 'shpKl'
				if strKatalogStyle == 'Global':
					TextLengthK = scribus.getTextLength(shpKatalogHot)
					scribus.selectText(0,TextLengthK,shpKatalogHot)
					scribus.setStyle("Katalog",shpKatalogHot)
				else:
					scribus.setFont(strKatalogFont, shpKatalogHot)
					scribus.setFontSize(float(strKatalogFontSize), shpKatalogHot)
					if strKatalogTextAlign == 'Left':
						scribus.setTextAlignment(0, shpKatalogHot)
					elif strKatalogTextAlign == "Center":
						scribus.setTextAlignment(1, shpKatalogHot)
					elif strKatalogTextAlign == 'Right':
						scribus.setTextAlignment(2, shpKatalogHot)
					elif strKatalogTextAlign == "Justified":
						scribus.setTextAlignment(3, shpKatalogHot)	  
					scribus.setLineSpacing(float(strKatalogFontSize)*float(strKatalogFontSpacing), shpKatalogHot)
				if strKatalogHyphen == 'TRUE':
					scribus.hyphenateText(shpKatalogHot)
				(Kw, Kh) = scribus.getSize(shpKatalogHot)
				while (((scribus.textOverflows(shpKatalogHot) == 0)) and (Kh > 0)) :
					Kh -= 1
					scribus.sizeObject(Kw, Kh, shpKatalogHot)
				while ((scribus.textOverflows(shpKatalogHot) > 0)) :
					Kh += 1
					scribus.sizeObject(Kw, Kh, shpKatalogHot)
				'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
				scribus.sizeObject(Kw, Kh+1, shpKatalogHot)
				lstKS.append(shpKatalogHot)
		f += 1
	if strSetFrameTextAlign == 'Group':
		strTempKx = 0
		a = 0
		while a < strSetCount:
			if scribus.objectExists('shpKr' + lstRndIndiv[a]):
				kx = scribus.getProperty('shpKr' + lstRndIndiv[a], "xPos")
				if kx > strTempKx:
					strTempKx = kx
			a += 1
		b = 0
		while b < strSetCount:
			if scribus.objectExists('shpKr' + lstRndIndiv[b]):
				scribus.setProperty('shpKr' + lstRndIndiv[b], "xPos", strTempKx)
			b += 1 
		strTempKx = printAreaWidth
		c = 0
		while c < strSetCount:
			if scribus.objectExists('shpKl' + lstRndIndiv[c]):
				kx = scribus.getProperty('shpKl' + lstRndIndiv[c], "xPos") + scribus.getProperty('shpKl' + lstRndIndiv[c], "width")
				if kx < strTempKx:
					strTempKx = kx
			c += 1
		d = 0
		while d < strSetCount:
			if scribus.objectExists('shpKl' + lstRndIndiv[d]):
				scribus.setProperty('shpKl' + lstRndIndiv[d], "xPos", strTempKx - scribus.getProperty('shpKl' + lstRndIndiv[d], "width"))
			d += 1 

def funcFacePlacementXFrameIndivText():
	f = 0
	while f < (strSetCount):
		if lstFace[f] == 'NullField':
			pass
		else:
			strFrameInnerHeightFI = lstStampH[f] + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2)
			strFrameInnerWidthFI = lstStampW[f] + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2)
			strFrameOuterHeightFI = lstStampH[f] + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
			strFrameOuterWidthFI = lstStampW[f] + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)
			strFrameOuterHeightNFI = (lstStampH[f] * .9)
			strFrameOuterWidthNFI = (lstStampW[f] * .9)

			'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
			if strFrameStyle == 'Internal':
				strFrameOuterWidthI = lstStampW[f]
				strFrameOuterHeightI = lstStampH[f]
			else:
				strFrameOuterWidthI = strFrameOuterWidthFI
				strFrameOuterHeightI = strFrameOuterHeightFI

			'''Add the Faces'''
			global shpFt
			global shpFb
			global shpFr
			global shpFl
			global shpFaceHot

			global shpS1t
			global shpS1b
			global shpS1r
			global shpS1l
			global shpS2t
			global shpS2b
			global shpS2r
			global shpS2l
			global shpS3t
			global shpS3b
			global shpS3r
			global shpS3l
			global shpS4t
			global shpS4b
			global shpS4r
			global shpS4l
			global shpS5t
			global shpS5b
			global shpS5r
			global shpS5l

			if strSetFace == 'Group' and f == 0:
				strFaceWidth = strFrameOuterWidth * strFaceRatio / 100
				strFaceHeight = float(10)
				strFaceShift = ((strFaceWidth - strFrameOuterWidth) / 2)
				if strLayoutFace == 'Top':
					'''strFaceLeft = strPlacementXo - strFaceShift'''
					strFaceLeft = lstFoX[f] - strFaceShift
					shpFt = scribus.createText(strFaceLeft, lstFoY[f], strFaceWidth, strFaceHeight, 'shpFt' + lstRndIndiv[f])
					lstTopShp.append(shpFt)
					scribus.setText(lstFace[f], shpFt)
					shpFaceHot = shpFt
					if strStack1 == 'Face Value':
						shpS1t = 'shpFt'
					elif strStack2 == 'Face Value':
						shpS2t = 'shpFt'
					elif strStack3 == 'Face Value':
						shpS3t = 'shpFt'
					elif strStack4 == 'Face Value':
						shpS4t = 'shpFt'
					elif strStack5 == 'Face Value':
						shpS5t = 'shpFt'
				elif strLayoutFace == 'Bottom':
					strFaceLeft = lstFoX[f] - strFaceShift
					shpFb = scribus.createText(strFaceLeft, lstFoY[f], strFaceWidth, strFaceHeight, 'shpFb' + lstRndIndiv[f])
					lstBottomShp.append(shpFb)
					scribus.setText(lstFace[f], shpFb)
					shpFaceHot = shpFb
					if strStack1 == 'Face Value':
						shpS1b = 'shpFb'
					elif strStack2 == 'Face Value':
						shpS2b = 'shpFb'
					elif strStack3 == 'Face Value':
						shpS3b = 'shpFb'
					elif strStack4 == 'Face Value':
						shpS4b = 'shpFb'
					elif strStack5 == 'Face Value':
						shpS5b = 'shpFb'
				elif strLayoutFace == 'Right':
					strFaceLeft = lstFoX[f] + strFrameOuterWidth + strMarginRight
					shpFr = scribus.createText(strFaceLeft, lstFoY[f], strFaceWidth, strFaceHeight, 'shpFr' + lstRndIndiv[f])
					lstRightShpG.append(shpFr)
					scribus.setText(lstFace[f], shpFr)
					shpFaceHot = shpFr
					if strStack1 == 'Face Value':
						shpS1r = 'shpFr'
					elif strStack2 == 'Face Value':
						shpS2r = 'shpFr'
					elif strStack3 == 'Face Value':
						shpS3r = 'shpFr'
					elif strStack4 == 'Face Value':
						shpS4r = 'shpFr'
					elif strStack5 == 'Face Value':
						shpS5r = 'shpFr'
				elif strLayoutFace == 'Left':
					strFaceLeft = lstFoX[f] - strMarginLeft - strFaceWidth
					shpFl = scribus.createText(strFaceLeft, lstFoY[f], strFaceWidth, strFaceHeight, 'shpFl' + lstRndIndiv[f])
					lstLeftShpG.append(shpFl)
					scribus.setText(lstFace[f], shpFl)
					shpFaceHot = shpFl
					if strStack1 == 'Face Value':
						shpS1l = 'shpFl'
					elif strStack2 == 'Face Value':
						shpS2l = 'shpFl'
					elif strStack3 == 'Face Value':
						shpS3l = 'shpFl'
					elif strStack4 == 'Face Value':
						shpS4l = 'shpFl'
					elif strStack5 == 'Face Value':
						shpS5l = 'shpFl'
				if strFaceStyle == 'Global':
					TextLengthF = scribus.getTextLength(shpFaceHot)
					scribus.selectText(0,TextLengthF,shpFaceHot)
					scribus.setStyle("Face",shpFaceHot)
				elif strFaceStyle == 'Global - Small Caps':
					TextLengthF = scribus.getTextLength(shpFaceHot)
					scribus.selectText(0,TextLengthF,shpFaceHot)
					scribus.setStyle("FaceSC",shpFaceHot)
				else:
					scribus.setFont(strFaceFont, shpFaceHot)
					scribus.setFontSize(float(strFaceFontSize), shpFaceHot)
					if strFaceTextAlign == 'Left':
						scribus.setTextAlignment(0, shpFaceHot)
					elif strFaceTextAlign == "Center":
						scribus.setTextAlignment(1, shpFaceHot)
					elif strFaceTextAlign == 'Right':
						scribus.setTextAlignment(2, shpFaceHot)
					elif strFaceTextAlign == "Justified":
						scribus.setTextAlignment(3, shpFaceHot)	  
					scribus.setLineSpacing(float(strFaceFontSize)*float(strFaceFontSpacing), shpFaceHot)
				if strFaceHyphen == 'TRUE':
					scribus.hyphenateText(shpFaceHot)
				(Fw, Fh) = scribus.getSize(shpFaceHot)
				while (((scribus.textOverflows(shpFaceHot) == 0)) and (Fh > 0)) :
					Fh -= 1
					scribus.sizeObject(Fw, Fh, shpFaceHot)
				while ((scribus.textOverflows(shpFaceHot) > 0)) :
					Fh += 1
					scribus.sizeObject(Fw, Fh, shpFaceHot)
				'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
				scribus.sizeObject(Fw, Fh+1, shpFaceHot)
				lstFS.append(shpFaceHot)
			elif strSetFace == 'Group' and f > 0:
				pass
			elif strSetFace == 'Individual':
				strFaceWidth = strFrameOuterWidthI * strFaceRatio / 100
				strFaceHeight = float(10)
				strFaceShift = ((strFaceWidth - strFrameOuterWidthI) / 2)
				if strLayoutFace == 'Top':
					strFaceLeft = lstFoX[f] - strFaceShift
					shpFt = scribus.createText(strFaceLeft, lstFoY[f], strFaceWidth, strFaceHeight, 'shpFt' + lstRndIndiv[f])
					lstTopShp.append(shpFt)
					scribus.setText(lstFace[f], shpFt)
					shpFaceHot = shpFt
					if strStack1 == 'Face Value':
						shpS1t = 'shpFt'
					elif strStack2 == 'Face Value':
						shpS2t = 'shpFt'
					elif strStack3 == 'Face Value':
						shpS3t = 'shpFt'
					elif strStack4 == 'Face Value':
						shpS4t = 'shpFt'
					elif strStack5 == 'Face Value':
						shpS5t = 'shpFt'
				elif strLayoutFace == 'Bottom':
					strFaceLeft = lstFoX[f] - strFaceShift
					shpFb = scribus.createText(strFaceLeft, lstFoY[f], strFaceWidth, strFaceHeight, 'shpFb' + lstRndIndiv[f])
					lstBottomShp.append(shpFb)
					scribus.setText(lstFace[f], shpFb)
					shpFaceHot = shpFb
					if strStack1 == 'Face Value':
						shpS1b = 'shpFb'
					elif strStack2 == 'Face Value':
						shpS2b = 'shpFb'
					elif strStack3 == 'Face Value':
						shpS3b = 'shpFb'
					elif strStack4 == 'Face Value':
						shpS4b = 'shpFb'
					elif strStack5 == 'Face Value':
						shpS5b = 'shpFb'
				elif strLayoutFace == 'Right':
					strFaceLeft = lstFoX[f] + strFrameOuterWidthI + strMarginRight
					shpFr = scribus.createText(strFaceLeft, lstFoY[f], strFaceWidth, strFaceHeight, 'shpFr' + lstRndIndiv[f])
					lstRightShp.append(shpFr)
					scribus.setText(lstFace[f], shpFr)
					shpFaceHot = shpFr
					if strStack1 == 'Face Value':
						shpS1r = 'shpFr'
					elif strStack2 == 'Face Value':
						shpS2r = 'shpFr'
					elif strStack3 == 'Face Value':
						shpS3r = 'shpFr'
					elif strStack4 == 'Face Value':
						shpS4r = 'shpFr'
					elif strStack5 == 'Face Value':
						shpS5r = 'shpFr'
				elif strLayoutFace == 'Left':
					strFaceLeft = lstFoX[f] - strMarginLeft - strFaceWidth
					shpFl = scribus.createText(strFaceLeft, lstFoY[f], strFaceWidth, strFaceHeight, 'shpFl' + lstRndIndiv[f])
					lstLeftShp.append(shpFl)
					scribus.setText(lstFace[f], shpFl)
					shpFaceHot = shpFl
					if strStack1 == 'Face Value':
						shpS1l = 'shpFl'
					elif strStack2 == 'Face Value':
						shpS2l = 'shpFl'
					elif strStack3 == 'Face Value':
						shpS3l = 'shpFl'
					elif strStack4 == 'Face Value':
						shpS4l = 'shpFl'
					elif strStack5 == 'Face Value':
						shpS5l = 'shpFl'
				if strFaceStyle == 'Global':
					TextLengthF = scribus.getTextLength(shpFaceHot)
					scribus.selectText(0,TextLengthF,shpFaceHot)
					scribus.setStyle("Face",shpFaceHot)
				elif strFaceStyle == 'Global - Small Caps':
					TextLengthF = scribus.getTextLength(shpFaceHot)
					scribus.selectText(0,TextLengthF,shpFaceHot)
					scribus.setStyle("FaceSC",shpFaceHot)
				else:
					scribus.setFont(strFaceFont, shpFaceHot)
					scribus.setFontSize(float(strFaceFontSize), shpFaceHot)
					if strFaceTextAlign == 'Left':
						scribus.setTextAlignment(0, shpFaceHot)
					elif strFaceTextAlign == "Center":
						scribus.setTextAlignment(1, shpFaceHot)
					elif strFaceTextAlign == 'Right':
						scribus.setTextAlignment(2, shpFaceHot)
					elif strFaceTextAlign == "Justified":
						scribus.setTextAlignment(3, shpFaceHot)	  
					scribus.setLineSpacing(float(strFaceFontSize)*float(strFaceFontSpacing), shpFaceHot)
				if strFaceHyphen == 'TRUE':
					scribus.hyphenateText(shpFaceHot)
				(Fw, Fh) = scribus.getSize(shpFaceHot)
				while (((scribus.textOverflows(shpFaceHot) == 0)) and (Fh > 0)) :
					Fh -= 1
					scribus.sizeObject(Fw, Fh, shpFaceHot)
				while ((scribus.textOverflows(shpFaceHot) > 0)) :
					Fh += 1
					scribus.sizeObject(Fw, Fh, shpFaceHot)
				'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
				scribus.sizeObject(Fw, Fh+1, shpFaceHot)
				lstFS.append(shpFaceHot)
		f += 1
	if strSetFrameTextAlign == 'Group':
		strTempFx = 0
		a = 0
		while a < strSetCount:
			if scribus.objectExists('shpFr' + lstRndIndiv[a]):
				fx = scribus.getProperty('shpFr' + lstRndIndiv[a], "xPos")
				if fx > strTempFx:
					strTempFx = fx
			a += 1
		b = 0
		while b < strSetCount:
			if scribus.objectExists('shpFr' + lstRndIndiv[b]):
				scribus.setProperty('shpFr' + lstRndIndiv[b], "xPos", strTempFx)
			b += 1 
		strTempFx = printAreaWidth
		c = 0
		while c < strSetCount:
			if scribus.objectExists('shpFl' + lstRndIndiv[c]):
				fx = scribus.getProperty('shpFl' + lstRndIndiv[c], "xPos") + scribus.getProperty('shpFl' + lstRndIndiv[c], "width")
				if fx < strTempFx:
					strTempFx = fx
			c += 1
		d = 0
		while d < strSetCount:
			if scribus.objectExists('shpFl' + lstRndIndiv[d]):
				scribus.setProperty('shpFl' + lstRndIndiv[d], "xPos", strTempFx - scribus.getProperty('shpFl' + lstRndIndiv[d], "width"))
			d += 1 
			
def funcCaptionPlacementXFrameIndivText():
	f = 0
	while f < (strSetCount):
		if lstCaption[f] == 'NullField':
			pass
		else:
			strFrameInnerHeightFI = lstStampH[f] + strPaddingTop + strPaddingBottom + (strFrameThicknessInner * 2)
			strFrameInnerWidthFI = lstStampW[f] + strPaddingLeft + strPaddingRight + (strFrameThicknessInner * 2)
			strFrameOuterHeightFI = lstStampH[f] + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
			strFrameOuterWidthFI = lstStampW[f] + strPaddingLeft + strPaddingRight + (strFrameOffset * 2)
			strFrameOuterHeightNFI = (lstStampH[f] * .9)
			strFrameOuterWidthNFI = (lstStampW[f] * .9)

			'''If Internal frame style, substitute stamp dimensions as proxy for frame dimensions'''
			if strFrameStyle == 'Internal':
				strFrameOuterWidthI = lstStampW[f]
				strFrameOuterHeightI = lstStampH[f]
			else:
				strFrameOuterWidthI = strFrameOuterWidthFI
				strFrameOuterHeightI = strFrameOuterHeightFI

			'''Add the Captions'''
			global shpCt
			global shpCb
			global shpCr
			global shpCl
			global shpCaptionHot

			global shpS1t
			global shpS1b
			global shpS1r
			global shpS1l
			global shpS2t
			global shpS2b
			global shpS2r
			global shpS2l
			global shpS3t
			global shpS3b
			global shpS3r
			global shpS3l
			global shpS4t
			global shpS4b
			global shpS4r
			global shpS4l
			global shpS5t
			global shpS5b
			global shpS5r
			global shpS5l

			if strSetCaption == 'Group' and f == 0:
				strCaptionWidth = strFrameOuterWidth * strCaptionRatio / 100
				strCaptionHeight = float(10)
				strCaptionShift = ((strCaptionWidth - strFrameOuterWidth) / 2)
				if strLayoutCaption == 'Top':
					strCaptionLeft = lstFoX[f] - strCaptionShift
					shpCt = scribus.createText(strCaptionLeft, lstFoY[f], strCaptionWidth, strCaptionHeight, 'shpCt' + lstRndIndiv[f])
					lstTopShp.append(shpCt)
					scribus.setText(lstCaption[f], shpCt)
					shpCaptionHot = shpCt
					if strStack1 == 'Caption':
						shpS1t = 'shpCt'
					elif strStack2 == 'Caption':
						shpS2t = 'shpCt'
					elif strStack3 == 'Caption':
						shpS3t = 'shpCt'
					elif strStack4 == 'Caption':
						shpS4t = 'shpCt'
					elif strStack5 == 'Caption':
						shpS5t = 'shpCt'
				elif strLayoutCaption == 'Bottom':
					strCaptionLeft = lstFoX[f] - strCaptionShift
					shpCb = scribus.createText(strCaptionLeft, lstFoY[f], strCaptionWidth, strCaptionHeight, 'shpCb' + lstRndIndiv[f])
					lstBottomShp.append(shpCb)
					scribus.setText(lstCaption[f], shpCb)
					shpCaptionHot = shpCb
					if strStack1 == 'Caption':
						shpS1b = 'shpCb'
					elif strStack2 == 'Caption':
						shpS2b = 'shpCb'
					elif strStack3 == 'Caption':
						shpS3b = 'shpCb'
					elif strStack4 == 'Caption':
						shpS4b = 'shpCb'
					elif strStack5 == 'Caption':
						shpS5b = 'shpCb'
				elif strLayoutCaption == 'Right':
					strCaptionLeft = lstFoX[f] + strFrameOuterWidth + strMarginRight
					shpCr = scribus.createText(strCaptionLeft, lstFoY[f], strCaptionWidth, strCaptionHeight, 'shpCr' + lstRndIndiv[f])
					lstRightShpG.append(shpCr)
					scribus.setText(lstCaption[f], shpCr)
					shpCaptionHot = shpCr
					if strStack1 == 'Caption':
						shpS1r = 'shpCr'
					elif strStack2 == 'Caption':
						shpS2r = 'shpCr'
					elif strStack3 == 'Caption':
						shpS3r = 'shpCr'
					elif strStack4 == 'Caption':
						shpS4r = 'shpCr'
					elif strStack5 == 'Caption':
						shpS5r = 'shpCr'
				elif strLayoutCaption == 'Left':
					strCaptionLeft = lstFoX[f] - strMarginLeft - strCaptionWidth
					shpCl = scribus.createText(strCaptionLeft, lstFoY[f], strCaptionWidth, strCaptionHeight, 'shpCl' + lstRndIndiv[f])
					lstLeftShpG.append(shpCl)
					scribus.setText(lstCaption[f], shpCl)
					shpCaptionHot = shpCl
					if strStack1 == 'Caption':
						shpS1l = 'shpCl'
					elif strStack2 == 'Caption':
						shpS2l = 'shpCl'
					elif strStack3 == 'Caption':
						shpS3l = 'shpCl'
					elif strStack4 == 'Caption':
						shpS4l = 'shpCl'
					elif strStack5 == 'Caption':
						shpS5l = 'shpCl'
				if strCaptionStyle == 'Global':
					TextLengthC = scribus.getTextLength(shpCaptionHot)
					scribus.selectText(0,TextLengthC,shpCaptionHot)
					scribus.setStyle("Caption",shpCaptionHot)
				else:
					scribus.setFont(strCaptionFont, shpCaptionHot)
					scribus.setFontSize(float(strCaptionFontSize), shpCaptionHot)
					if strCaptionTextAlign == 'Left':
						scribus.setTextAlignment(0, shpCaptionHot)
					elif strCaptionTextAlign == "Center":
						scribus.setTextAlignment(1, shpCaptionHot)
					elif strCaptionTextAlign == 'Right':
						scribus.setTextAlignment(2, shpCaptionHot)
					elif strCaptionTextAlign == "Justified":
						scribus.setTextAlignment(3, shpCaptionHot)	  
					scribus.setLineSpacing(float(strCaptionFontSize)*float(strCaptionFontSpacing), shpCaptionHot)
				if strCaptionHyphen == 'TRUE':
					scribus.hyphenateText(shpCaptionHot)
				(Cw, Ch) = scribus.getSize(shpCaptionHot)
				while (((scribus.textOverflows(shpCaptionHot) == 0)) and (Ch > 0)) :
					Ch -= 1
					scribus.sizeObject(Cw, Ch, shpCaptionHot)
				while ((scribus.textOverflows(shpCaptionHot) > 0)) :
					Ch += 1
					scribus.sizeObject(Cw, Ch, shpCaptionHot)
				'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
				scribus.sizeObject(Cw, Ch+1, shpCaptionHot)
				lstCS.append(shpCaptionHot)
			elif strSetCaption == 'Group' and f > 0:
				pass
			elif strSetCaption == 'Individual':
				strCaptionWidth = strFrameOuterWidthI * strCaptionRatio / 100
				strCaptionHeight = float(10)
				strCaptionShift = ((strCaptionWidth - strFrameOuterWidthI) / 2)
				if strLayoutCaption == 'Top':
					strCaptionLeft = lstFoX[f] - strCaptionShift
					shpCt = scribus.createText(strCaptionLeft, lstFoY[f], strCaptionWidth, strCaptionHeight, 'shpCt' + lstRndIndiv[f])
					lstTopShp.append(shpCt)
					scribus.setText(lstCaption[f], shpCt)
					shpCaptionHot = shpCt
					if strStack1 == 'Caption':
						shpS1t = 'shpCt'
					elif strStack2 == 'Caption':
						shpS2t = 'shpCt'
					elif strStack3 == 'Caption':
						shpS3t = 'shpCt'
					elif strStack4 == 'Caption':
						shpS4t = 'shpCt'
					elif strStack5 == 'Caption':
						shpS5t = 'shpCt'
				elif strLayoutCaption == 'Bottom':
					strCaptionLeft = lstFoX[f] - strCaptionShift
					shpCb = scribus.createText(strCaptionLeft, lstFoY[f], strCaptionWidth, strCaptionHeight, 'shpCb' + lstRndIndiv[f])
					lstBottomShp.append(shpCb)
					scribus.setText(lstCaption[f], shpCb)
					shpCaptionHot = shpCb
					if strStack1 == 'Caption':
						shpS1b = 'shpCb'
					elif strStack2 == 'Caption':
						shpS2b = 'shpCb'
					elif strStack3 == 'Caption':
						shpS3b = 'shpCb'
					elif strStack4 == 'Caption':
						shpS4b = 'shpCb'
					elif strStack5 == 'Caption':
						shpS5b = 'shpCb'
				elif strLayoutCaption == 'Right':
					strCaptionLeft = lstFoX[f] + strFrameOuterWidthI + strMarginRight
					shpCr = scribus.createText(strCaptionLeft, lstFoY[f], strCaptionWidth, strCaptionHeight, 'shpCr' + lstRndIndiv[f])
					lstRightShp.append(shpCr)
					scribus.setText(lstCaption[f], shpCr)
					shpCaptionHot = shpCr
					if strStack1 == 'Caption':
						shpS1r = 'shpCr'
					elif strStack2 == 'Caption':
						shpS2r = 'shpCr'
					elif strStack3 == 'Caption':
						shpS3r = 'shpCr'
					elif strStack4 == 'Caption':
						shpS4r = 'shpCr'
					elif strStack5 == 'Caption':
						shpS5r = 'shpCr'
				elif strLayoutCaption == 'Left':
					strCaptionLeft = lstFoX[f] - strMarginLeft - strCaptionWidth
					shpCl = scribus.createText(strCaptionLeft, lstFoY[f], strCaptionWidth, strCaptionHeight, 'shpCl' + lstRndIndiv[f])
					lstLeftShp.append(shpCl)
					scribus.setText(lstCaption[f], shpCl)
					shpCaptionHot = shpCl
					if strStack1 == 'Caption':
						shpS1l = 'shpCl'
					elif strStack2 == 'Caption':
						shpS2l = 'shpCl'
					elif strStack3 == 'Caption':
						shpS3l = 'shpCl'
					elif strStack4 == 'Caption':
						shpS4l = 'shpCl'
					elif strStack5 == 'Caption':
						shpS5l = 'shpCl'
				if strCaptionStyle == 'Global':
					TextLengthC = scribus.getTextLength(shpCaptionHot)
					scribus.selectText(0,TextLengthC,shpCaptionHot)
					scribus.setStyle("Caption",shpCaptionHot)
				else:
					scribus.setFont(strCaptionFont, shpCaptionHot)
					scribus.setFontSize(float(strCaptionFontSize), shpCaptionHot)
					if strCaptionTextAlign == 'Left':
						scribus.setTextAlignment(0, shpCaptionHot)
					elif strCaptionTextAlign == "Center":
						scribus.setTextAlignment(1, shpCaptionHot)
					elif strCaptionTextAlign == 'Right':
						scribus.setTextAlignment(2, shpCaptionHot)
					elif strCaptionTextAlign == "Justified":
						scribus.setTextAlignment(3, shpCaptionHot)	  
					scribus.setLineSpacing(float(strCaptionFontSize)*float(strCaptionFontSpacing), shpCaptionHot)
				if strCaptionHyphen == 'TRUE':
					scribus.hyphenateText(shpCaptionHot)
				(Cw, Ch) = scribus.getSize(shpCaptionHot)
				while (((scribus.textOverflows(shpCaptionHot) == 0)) and (Ch > 0)) :
					Ch -= 1
					scribus.sizeObject(Cw, Ch, shpCaptionHot)
				while ((scribus.textOverflows(shpCaptionHot) > 0)) :
					Ch += 1
					scribus.sizeObject(Cw, Ch, shpCaptionHot)
				'''v1.5.1 temp fix to Scribus 1.5.7 textbox height bug'''
				scribus.sizeObject(Cw, Ch+1, shpCaptionHot)
				lstCS.append(shpCaptionHot)
		f += 1
	if strSetFrameTextAlign == 'Group':
		strTempCx = 0
		a = 0
		while a < strSetCount:
			if scribus.objectExists('shpCr' + lstRndIndiv[a]):
				cx = scribus.getProperty('shpCr' + lstRndIndiv[a], "xPos")
				if cx > strTempCx:
					strTempCx = cx
			a += 1
		b = 0
		while b < strSetCount:
			if scribus.objectExists('shpCr' + lstRndIndiv[b]):
				scribus.setProperty('shpCr' + lstRndIndiv[b], "xPos", strTempCx)
			b += 1 
		strTempCx = printAreaWidth
		c = 0
		while c < strSetCount:
			if scribus.objectExists('shpCl' + lstRndIndiv[c]):
				cx = scribus.getProperty('shpCl' + lstRndIndiv[c], "xPos") + scribus.getProperty('shpCl' + lstRndIndiv[c], "width")
				if cx < strTempCx:
					strTempCx = cx
			c += 1
		d = 0
		while d < strSetCount:
			if scribus.objectExists('shpCl' + lstRndIndiv[d]):
				scribus.setProperty('shpCl' + lstRndIndiv[d], "xPos", strTempCx - scribus.getProperty('shpCl' + lstRndIndiv[d], "width"))
			d += 1 

def funcTopPlacementYFrameIndivTextIndAlign():
	global strTempY5
	global strTempY4
	global strTempY3
	global strTempY2
	global strTempY1

	f = 0
	while f < (strSetCount):
		strTempS5t = shpS5t + lstRndIndiv[f]
		strTempFo = 'shpFo' + lstRndIndiv[f]
		if scribus.objectExists(strTempS5t):
			if strSetStack5 == 'Group':
				scribus.setProperty(strTempS5t, "yPos", strFrameTop - strMarginTop - scribus.getProperty(strTempS5t, "height"))
				if scribus.getProperty(strTempS5t, "yPos") < strTempY5:
					strTempY5 = scribus.getProperty(strTempS5t, "yPos")
					strTempY4 = strTempY5
					strTempY3 = strTempY5
					strTempY2 = strTempY5
					strTempY1 = strTempY5
			else:
				scribus.setProperty(strTempS5t, "yPos", scribus.getProperty(strTempFo, "yPos") - strMarginTop - scribus.getProperty(strTempS5t, "height"))
				if scribus.getProperty(strTempS5t, "yPos") < strTempY5:
					strTempY5 = scribus.getProperty(strTempS5t, "yPos")
					strTempY4 = strTempY5
					strTempY3 = strTempY5
					strTempY2 = strTempY5
					strTempY1 = strTempY5
		f += 1

	q = 0
	while q < (strSetCount):
		strTempS5t = shpS5t + lstRndIndiv[q]
		strTempFo = 'shpFo' + lstRndIndiv[q]
		strTempS4t = shpS4t + lstRndIndiv[q]
		if scribus.objectExists(strTempS4t):
			if scribus.objectExists(strTempS5t):
				if strSetStack5 == 'Group' and scribus.objectExists(shpS5t + rndfirst):
					scribus.setProperty(strTempS4t, "yPos", scribus.getProperty(shpS5t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS4t, "height"))
				else:
					if strSetStack4 == 'Group':
						scribus.setProperty(strTempS4t, "yPos", strTempY5 - strVerticalSpacing - scribus.getProperty(strTempS4t, "height"))
					else:
						scribus.setProperty(strTempS4t, "yPos", scribus.getProperty(strTempS5t, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS4t, "height"))
				if (scribus.getProperty(strTempS4t, "yPos") < strTempY4):
					strTempY4 = scribus.getProperty(strTempS4t, "yPos")
					strTempY3 = strTempY4
					strTempY2 = strTempY4
					strTempY1 = strTempY4
			else:
				if strSetStack5 == 'Group' and scribus.objectExists(shpS5t + rndfirst):
					scribus.setProperty(strTempS4t, "yPos", strTempY5 - strVerticalSpacing - scribus.getProperty(strTempS4t, "height"))
				else:
					if strSetStack4 == 'Group':
						scribus.setProperty(strTempS4t, "yPos", strFrameTop - strMarginTop - scribus.getProperty(strTempS4t, "height"))
					else:
						scribus.setProperty(strTempS4t, "yPos", scribus.getProperty(strTempFo, "yPos") - strMarginTop - scribus.getProperty(strTempS4t, "height"))
				if scribus.getProperty(strTempS4t, "yPos") < strTempY4:
					strTempY4 = scribus.getProperty(strTempS4t, "yPos")
					strTempY3 = strTempY4
					strTempY2 = strTempY4
					strTempY1 = strTempY4
		q += 1
			
	g = 0
	while g < (strSetCount):
		strTempS5t = shpS5t + lstRndIndiv[g]
		strTempFo = shpFo + lstRndIndiv[g]
		strTempS4t = shpS4t + lstRndIndiv[g]
		strTempS3t = shpS3t + lstRndIndiv[g]
		if scribus.objectExists(strTempS3t):
			if scribus.objectExists(strTempS4t):
				if strSetStack4 == 'Group' and scribus.objectExists(shpS4t + rndfirst):
					scribus.setProperty(strTempS3t, "yPos", scribus.getProperty(shpS4t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS3t, "height"))
				else:
					if strSetStack3 == 'Group':
						scribus.setProperty(strTempS3t, "yPos", strTempY4 - strVerticalSpacing - scribus.getProperty(strTempS3t, "height"))
					else:
						scribus.setProperty(strTempS3t, "yPos", scribus.getProperty(strTempS4t, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS3t, "height"))
				if (scribus.getProperty(strTempS3t, "yPos") < strTempY3):
					strTempY3 = scribus.getProperty(strTempS3t, "yPos")
					strTempY2 = strTempY3
					strTempY1 = strTempY3
			elif scribus.objectExists(strTempS5t):
				if strSetStack4 == 'Group' and scribus.objectExists(shpS4t + rndfirst):
					scribus.setProperty(strTempS3t, "yPos", scribus.getProperty(shpS4t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS3t, "height"))
				elif strSetStack5 == 'Group' and scribus.objectExists(shpS5t + rndfirst):
					scribus.setProperty(strTempS3t, "yPos", scribus.getProperty(shpS5t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS3t, "height"))
				elif strSetStack3 == 'Group':
					scribus.setProperty(strTempS3t, "yPos", strTempY5 - strVerticalSpacing - scribus.getProperty(strTempS3t, "height"))
				else:
					scribus.setProperty(strTempS3t, "yPos", scribus.getProperty(strTempS5t, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS3t, "height"))
				if (scribus.getProperty(strTempS3t, "yPos") < strTempY3):
					strTempY3 = scribus.getProperty(strTempS3t, "yPos")
			elif strSetStack4 == 'Group' and scribus.objectExists(shpS4t + rndfirst):
				scribus.setProperty(strTempS3t, "yPos", strTempY4 - strVerticalSpacing - scribus.getProperty(strTempS3t, "height"))
			elif strSetStack5 == 'Group' and scribus.objectExists(shpS5t + rndfirst):
				scribus.setProperty(strTempS3t, "yPos", strTempY5 - strVerticalSpacing - scribus.getProperty(strTempS3t, "height"))
			elif strSetStack3 == 'Group':
				scribus.setProperty(strTempS3t, "yPos", strFrameTop - strMarginTop - scribus.getProperty(strTempS3t, "height"))
			else:
				scribus.setProperty(strTempS3t, "yPos", scribus.getProperty(strTempFo, "yPos") - strMarginTop - scribus.getProperty(strTempS3t, "height"))
			if scribus.getProperty(strTempS3t, "yPos") < strTempY3:
				strTempY3 = scribus.getProperty(strTempS3t, "yPos")
				strTempY2 = strTempY3
				strTempY1 = strTempY3
		g += 1

	h = 0
	while h < (strSetCount):
		strTempS5t = shpS5t + lstRndIndiv[h]
		strTempFo = 'shpFo' + lstRndIndiv[h]
		strTempS4t = shpS4t + lstRndIndiv[h]
		strTempS3t = shpS3t + lstRndIndiv[h]
		strTempS2t = shpS2t + lstRndIndiv[h]
		if scribus.objectExists(strTempS2t):
			if scribus.objectExists(strTempS3t):
				if strSetStack3 == 'Group' and scribus.objectExists(shpS3t + rndfirst):
					scribus.setProperty(strTempS2t, "yPos", scribus.getProperty(shpS3t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				else:
					if strSetStack2 == 'Group':
						scribus.setProperty(strTempS2t, "yPos", strTempY3 - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
					else:
						scribus.setProperty(strTempS2t, "yPos", scribus.getProperty(strTempS3t, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				if (scribus.getProperty(strTempS2t, "yPos") < strTempY2):
					strTempY2 = scribus.getProperty(strTempS2t, "yPos")
			elif scribus.objectExists(strTempS4t):
				if strSetStack3 == 'Group' and scribus.objectExists(shpS3t + rndfirst):
					scribus.setProperty(strTempS2t, "yPos", scribus.getProperty(shpS3t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				elif strSetStack4 == 'Group' and scribus.objectExists(shpS4t + rndfirst):
					scribus.setProperty(strTempS2t, "yPos", scribus.getProperty(shpS4t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				elif strSetStack5 == 'Group' and scribus.objectExists(shpS5t + rndfirst):
					scribus.setProperty(strTempS2t, "yPos", scribus.getProperty(shpS5t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				elif strSetStack2 == 'Group':
					scribus.setProperty(strTempS2t, "yPos", strTempY4 - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				else:
					scribus.setProperty(strTempS2t, "yPos", scribus.getProperty(strTempS4t, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				if (scribus.getProperty(strTempS2t, "yPos") < strTempY2):
					strTempY2 = scribus.getProperty(strTempS2t, "yPos")
			elif scribus.objectExists(strTempS5t):
				if strSetStack3 == 'Group' and scribus.objectExists(shpS3t + rndfirst):
					scribus.setProperty(strTempS2t, "yPos", scribus.getProperty(shpS3t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				elif strSetStack4 == 'Group' and scribus.objectExists(shpS4t + rndfirst):
					scribus.setProperty(strTempS2t, "yPos", scribus.getProperty(shpS4t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				elif strSetStack5 == 'Group' and scribus.objectExists(shpS5t + rndfirst):
					scribus.setProperty(strTempS2t, "yPos", scribus.getProperty(shpS5t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				elif strSetStack2 == 'Group':
					scribus.setProperty(strTempS2t, "yPos", strTempY5 - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				else:
					scribus.setProperty(strTempS2t, "yPos", scribus.getProperty(strTempS5t, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
				if (scribus.getProperty(strTempS2t, "yPos") < strTempY2):
					strTempY2 = scribus.getProperty(strTempS2t, "yPos")
			elif strSetStack3 == 'Group' and scribus.objectExists(shpS3t + rndfirst):
				scribus.setProperty(strTempS2t, "yPos", strTempY3 - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
			elif strSetStack4 == 'Group' and scribus.objectExists(shpS4t + rndfirst):
				scribus.setProperty(strTempS2t, "yPos", strTempY4 - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
			elif strSetStack5 == 'Group' and scribus.objectExists(shpS5t + rndfirst):
				scribus.setProperty(strTempS2t, "yPos", strTempY5 - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
			elif strSetStack2 == 'Group':
				scribus.setProperty(strTempS2t, "yPos", strFrameTop - strMarginTop - scribus.getProperty(strTempS2t, "height"))
			else:
				scribus.setProperty(strTempS2t, "yPos", scribus.getProperty(strTempFo, "yPos") - strMarginTop - scribus.getProperty(strTempS2t, "height"))
			if scribus.getProperty(strTempS2t, "yPos") < strTempY2:
				strTempY2 = scribus.getProperty(strTempS2t, "yPos")
		h += 1

	j = 0
	while j < (strSetCount):
		strTempS5t = shpS5t + lstRndIndiv[j]
		strTempFo = 'shpFo' + lstRndIndiv[j]
		strTempS4t = shpS4t + lstRndIndiv[j]
		strTempS3t = shpS3t + lstRndIndiv[j]
		strTempS2t = shpS2t + lstRndIndiv[j]
		strTempS1t = shpS1t + lstRndIndiv[j]
		if scribus.objectExists(strTempS1t):
			if scribus.objectExists(strTempS2t):
				if strSetStack2 == 'Group' and scribus.objectExists(shpS2t + rndfirst):
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(shpS2t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				else:
					if strSetStack1 == 'Group':
						scribus.setProperty(strTempS1t, "yPos", strTempY2 - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
					else:
						scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(strTempS2t, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				if (scribus.getProperty(strTempS1t, "yPos") < strTempY1):
					strTempY1 = scribus.getProperty(strTempS1t, "yPos")
			elif scribus.objectExists(strTempS3t):
				if strSetStack2 == 'Group' and scribus.objectExists(shpS2t + rndfirst):
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(shpS2t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				elif strSetStack3 == 'Group' and scribus.objectExists(shpS3t + rndfirst):
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(shpS3t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))		
				elif strSetStack1 == 'Group':
					scribus.setProperty(strTempS1t, "yPos", strTempY3 - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				else:
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(strTempS3t, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				if (scribus.getProperty(strTempS1t, "yPos") < strTempY1):
					strTempY1 = scribus.getProperty(strTempS1t, "yPos")
			elif scribus.objectExists(strTempS4t):
				if strSetStack2 == 'Group' and scribus.objectExists(shpS2t + rndfirst):
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(shpS2t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				elif strSetStack3 == 'Group' and scribus.objectExists(shpS3t + rndfirst):
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(shpS3t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				elif strSetStack4 == 'Group' and scribus.objectExists(shpS4t + rndfirst):
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(shpS4t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))		
				elif strSetStack5 == 'Group' and scribus.objectExists(shpS5t + rndfirst):
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(shpS5t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))					
				elif strSetStack1 == 'Group':
					scribus.setProperty(strTempS1t, "yPos", strTempY4 - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				else:
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(strTempS4t, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				if (scribus.getProperty(strTempS1t, "yPos") < strTempY1):
					strTempY1 = scribus.getProperty(strTempS1t, "yPos")
			elif scribus.objectExists(strTempS5t):
				if strSetStack2 == 'Group' and scribus.objectExists(shpS2t + rndfirst):
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(shpS2t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				elif strSetStack3 == 'Group' and scribus.objectExists(shpS3t + rndfirst):
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(shpS3t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				elif strSetStack4 == 'Group' and scribus.objectExists(shpS4t + rndfirst):
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(shpS4t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))	
				elif strSetStack5 == 'Group' and scribus.objectExists(shpS5t + rndfirst):
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(shpS5t + rndfirst, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))		
				elif strSetStack1 == 'Group':
					scribus.setProperty(strTempS1t, "yPos", strTempY5 - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				else:
					scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(strTempS5t, "yPos") - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
				if (scribus.getProperty(strTempS1t, "yPos") < strTempY1):
					strTempY1 = scribus.getProperty(strTempS1t, "yPos")
			elif strSetStack2 == 'Group' and scribus.objectExists(shpS2t + rndfirst):
				scribus.setProperty(strTempS1t, "yPos", strTempY2 - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
			elif strSetStack3 == 'Group' and scribus.objectExists(shpS3t + rndfirst):
				scribus.setProperty(strTempS1t, "yPos", strTempY3 - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
			elif strSetStack4 == 'Group' and scribus.objectExists(shpS4t + rndfirst):
				scribus.setProperty(strTempS1t, "yPos", strTempY4 - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
			elif strSetStack5 == 'Group' and scribus.objectExists(shpS5t + rndfirst):
				scribus.setProperty(strTempS1t, "yPos", strTempY5 - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
			elif strSetStack1 == 'Group':
				scribus.setProperty(strTempS1t, "yPos", strFrameTop - strMarginTop - scribus.getProperty(strTempS1t, "height"))
			else:
				scribus.setProperty(strTempS1t, "yPos", scribus.getProperty(strTempFo, "yPos") - strMarginTop - scribus.getProperty(strTempS1t, "height"))
			if scribus.getProperty(strTempS1t, "yPos") < strTempY1:
				strTempY1 = scribus.getProperty(strTempS1t, "yPos")
		j += 1

def funcBottomPlacementYFrameIndivTextIndAlign():
	global strTempY1
	global strTempY2
	global strTempY3
	global strTempY4
	global strTempY5

	strFoBottom = 0
	e = 0
	while e < strSetCount:
		if scribus.objectExists('shpFo' + lstRndIndiv[e]):
			if scribus.getProperty('shpFo' + lstRndIndiv[e], "yPos") + scribus.getProperty('shpFo' + lstRndIndiv[e], "height") > strFoBottom:
				strFoBottom = scribus.getProperty('shpFo' + lstRndIndiv[e], "yPos") + scribus.getProperty('shpFo' + lstRndIndiv[e], "height")
		e += 1

	strTempY1 = strFoBottom
	strTempY2 = strFoBottom
	strTempY3 = strFoBottom
	strTempY4 = strFoBottom
	strTempY5 = strFoBottom

	
	if strStyle == 'Outside':
	
		f = 0
		while f < (strSetCount):
			strTempS1b = shpS1b + lstRndIndiv[f]
			strTempFo = 'shpFo' + lstRndIndiv[f]
			if scribus.objectExists(strTempS1b):
				if strSetStack1 == 'Group':
					scribus.setProperty(strTempS1b, "yPos", strFoBottom + strMarginBottom)
				else:
					scribus.setProperty(strTempS1b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					 scribus.getProperty(strTempFo, "height") + strMarginBottom)
				if scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height") > strTempY1:
					strTempY1 = scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height")
					strTempY2 = strTempY1
					strTempY3 = strTempY1
					strTempY4 = strTempY1
					strTempY5 = strTempY1
			f += 1
	
		g = 0
		while g < (strSetCount):
			strTempS1b = shpS1b + lstRndIndiv[g]
			strTempS2b = shpS2b + lstRndIndiv[g]
			strTempFo = 'shpFo' + lstRndIndiv[g]
			if scribus.objectExists(strTempS2b):
				if scribus.objectExists(strTempS1b):
					if strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst):
						scribus.setProperty(strTempS2b, "yPos", scribus.getProperty(shpS1b + rndfirst, "yPos") + \
						scribus.getProperty(shpS1b + rndfirst, "height") + strVerticalSpacing)
					else:
						if strSetStack2 == 'Group':
							scribus.setProperty(strTempS2b, "yPos", strTempY1 + strVerticalSpacing)
						else:
							scribus.setProperty(strTempS2b, "yPos", scribus.getProperty(strTempS1b, "yPos") + \
							scribus.getProperty(strTempS1b, "height") + strVerticalSpacing)
					if (scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height") > strTempY2):
						strTempY2 = scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height")
						strTempY3 = strTempY2
						strTempY4 = strTempY2
						strTempY5 = strTempY2
				else:
					if strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst):
						scribus.setProperty(strTempS2b, "yPos", strTempY1 + strVerticalSpacing)
					else:
						if strSetStack2 == 'Group':
							scribus.setProperty(strTempS2b, "yPos", strFoBottom + strMarginBottom)
						else:
							scribus.setProperty(strTempS2b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
							scribus.getProperty(strTempFo, "height") + strMarginBottom)
					if scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height") > strTempY2:
						strTempY2 = scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height")
						strTempY3 = strTempY2
						strTempY4 = strTempY2
						strTempY5 = strTempY2
			g += 1

		h = 0
		while h < (strSetCount):
			strTempFo = 'shpFo' + lstRndIndiv[h]
			strTempS1b = shpS1b + lstRndIndiv[h]
			strTempS2b = shpS2b + lstRndIndiv[h]
			strTempS3b = shpS3b + lstRndIndiv[h]
			if scribus.objectExists(strTempS3b):
				if scribus.objectExists(strTempS2b):
					if strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst) :
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					else:
						if strSetStack3 == 'Group':
							scribus.setProperty(strTempS3b, "yPos", strTempY2 + strVerticalSpacing)
						else:
							scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempS2b, "yPos") + \
							scribus.getProperty(strTempS2b, "height") + strVerticalSpacing)
					if (scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height") > strTempY3):
						strTempY3 = scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height")
				elif scribus.objectExists(strTempS1b):
					if strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst):
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst):
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(shpS1b + rndfirst, "yPos") + \
						scribus.getProperty(shpS1b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack3 == 'Group':
						scribus.setProperty(strTempS3b, "yPos", strTempY1 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempS1b, "yPos") + \
						scribus.getProperty(strTempS1b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height") > strTempY3:
						strTempY3 = scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height")
				elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst):
					scribus.setProperty(strTempS3b, "yPos", strTempY2 + strVerticalSpacing)
				elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst):
					scribus.setProperty(strTempS3b, "yPos", strTempY1 + strVerticalSpacing)
				elif strSetStack3 == 'Group':
					scribus.setProperty(strTempS3b, "yPos", strFoBottom + strMarginBottom)
				else:
					scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					scribus.getProperty(strTempFo, "height") + strMarginBottom)
				if scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height") > strTempY3:
					strTempY3 = scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height")
					strTempY4 = strTempY3
					strTempY5 = strTempY3
			h += 1

		q = 0
		while q < (strSetCount):
			strTempFo = 'shpFo' + lstRndIndiv[q]
			strTempS1b = shpS1b + lstRndIndiv[q]
			strTempS2b = shpS2b + lstRndIndiv[q]
			strTempS3b = shpS3b + lstRndIndiv[q]
			strTempS4b = shpS4b + lstRndIndiv[q]
			if scribus.objectExists(strTempS4b):
				if scribus.objectExists(strTempS3b):
					if strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst) :
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					else:
						if strSetStack4 == 'Group':
							scribus.setProperty(strTempS4b, "yPos", strTempY3 + strVerticalSpacing)
						else:
							scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempS3b, "yPos") + \
							scribus.getProperty(strTempS3b, "height") + strVerticalSpacing)
					if (scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height") > strTempY4):
						strTempY4 = scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")
				elif scribus.objectExists(strTempS2b):
					if strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst):
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst):
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst):
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS1b + rndfirst, "yPos") + \
						scribus.getProperty(shpS1b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack4 == 'Group':
						scribus.setProperty(strTempS4b, "yPos", strTempY2 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempS2b, "yPos") + \
						scribus.getProperty(strTempS2b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height") > strTempY4:
						strTempY4 = scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")
				elif scribus.objectExists(strTempS1b):
					if strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst):
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					if strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst):
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst):
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS1b + rndfirst, "yPos") + \
						scribus.getProperty(shpS1b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack4 == 'Group':
						scribus.setProperty(strTempS4b, "yPos", strTempY1 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempS1b, "yPos") + \
						scribus.getProperty(strTempS1b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height") > strTempY4:
						strTempY4 = scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")
				elif strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst):
					scribus.setProperty(strTempS4b, "yPos", strTempY3 + strVerticalSpacing)
				elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst):
					scribus.setProperty(strTempS4b, "yPos", strTempY2 + strVerticalSpacing)
				elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst):
					scribus.setProperty(strTempS4b, "yPos", strTempY1 + strVerticalSpacing)
				elif strSetStack4 == 'Group':
					scribus.setProperty(strTempS4b, "yPos", strFoBottom + strMarginBottom)
				else:
					scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					scribus.getProperty(strTempFo, "height") + strMarginBottom)
				if scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height") > strTempY4:
					strTempY4 = scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")
					strTempY5 = strTempY4
			q += 1

		j = 0
		while j < (strSetCount):
			strTempFo = 'shpFo' + lstRndIndiv[j]
			strTempS1b = shpS1b + lstRndIndiv[j]
			strTempS2b = shpS2b + lstRndIndiv[j]
			strTempS3b = shpS3b + lstRndIndiv[j]
			strTempS4b = shpS4b + lstRndIndiv[j]
			strTempS5b = shpS5b + lstRndIndiv[j]
			if scribus.objectExists(strTempS5b):
				if scribus.objectExists(strTempS4b):
					if strSetStack4 == 'Group' and scribus.objectExists(shpS4b + rndfirst) :
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS4b + rndfirst, "yPos") + \
						scribus.getProperty(shpS4b + rndfirst, "height") + strVerticalSpacing)
					else:
						if strSetStack5 == 'Group':
							scribus.setProperty(strTempS5b, "yPos", strTempY4 + strVerticalSpacing)
						else:
							scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(strTempS4b, "yPos") + \
							scribus.getProperty(strTempS4b, "height") + strVerticalSpacing)
					if (scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5):
						strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
				elif scribus.objectExists(strTempS3b):
					if strSetStack4 == 'Group' and scribus.objectExists(shpS4b + rndfirst):
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS4b + rndfirst, "yPos") + \
						scribus.getProperty(shpS4b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst):
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack5 == 'Group':
						scribus.setProperty(strTempS5b, "yPos", strTempY2 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(strTempS3b, "yPos") + \
						scribus.getProperty(strTempS3b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5:
						strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
				elif scribus.objectExists(strTempS2b):
					if strSetStack4 == 'Group' and scribus.objectExists(shpS4b + rndfirst):
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS4b + rndfirst, "yPos") + \
						scribus.getProperty(shpS4b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst):
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst):
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack5 == 'Group':
						scribus.setProperty(strTempS5b, "yPos", strTempY2 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(strTempS2b, "yPos") + \
						scribus.getProperty(strTempS2b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5:
						strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
				elif scribus.objectExists(strTempS1b):
					if strSetStack4 == 'Group' and scribus.objectExists(shpS4b + rndfirst):
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS4b + rndfirst, "yPos") + \
						scribus.getProperty(shpS4b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst):
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst):
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst):
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS1b + rndfirst, "yPos") + \
						scribus.getProperty(shpS1b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack5 == 'Group':
						scribus.setProperty(strTempS5b, "yPos", strTempY1 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(strTempS1b, "yPos") + \
						scribus.getProperty(strTempS1b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5:
						strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
				elif strSetStack4 == 'Group' and scribus.objectExists(shpS4b + rndfirst):
					scribus.setProperty(strTempS5b, "yPos", strTempY4 + strVerticalSpacing)
				elif strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst):
					scribus.setProperty(strTempS5b, "yPos", strTempY3 + strVerticalSpacing)
				elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst):
					scribus.setProperty(strTempS5b, "yPos", strTempY2 + strVerticalSpacing)
				elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst):
					scribus.setProperty(strTempS5b, "yPos", strTempY1 + strVerticalSpacing)
				elif strSetStack5 == 'Group':
					scribus.setProperty(strTempS5b, "yPos", strFoBottom + strMarginBottom)
				else:
					scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					 scribus.getProperty(strTempFo, "height") + strMarginBottom)
				if scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5:
					strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
			j += 1
	elif strStyle == 'Inside - Catalog':
		v = 0
		while v < (strSetCount):
			strTempFo = 'shpFo' + lstRndIndiv[v]
			strTempKb = 'shpKb' + lstRndIndiv[v]
			scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
			scribus.getProperty(strTempFo, "height") / 2 - scribus.getProperty(strTempKb, "height") / 2)
			v += 1
	elif strStyle == 'Inside - Face Value':
		v = 0
		while v < (strSetCount):
			strTempFo = 'shpFo' + lstRndIndiv[v]
			strTempFb = 'shpFb' + lstRndIndiv[v]
			scribus.setProperty(strTempFb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
			scribus.getProperty(strTempFo, "height") / 2 - scribus.getProperty(strTempFb, "height") / 2)
			v += 1
	elif strStyle == 'Outside/Inside':
		f = 0
		while f < (strSetCount):
			strTempS1b = shpS1b + lstRndIndiv[f]
			strTempFo = 'shpFo' + lstRndIndiv[f]
			if scribus.objectExists(strTempS1b) and shpS1b != 'shpKb':
				if strSetStack1 == 'Group':
					scribus.setProperty(strTempS1b, "yPos", strFoBottom + strMarginBottom)
				else:
					scribus.setProperty(strTempS1b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					 scribus.getProperty(strTempFo, "height") + strMarginBottom)
				if scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height") > strTempY1:
					strTempY1 = scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height")
					strTempY2 = strTempY1
					strTempY3 = strTempY1
					strTempY4 = strTempY1
					strTempY5 = strTempY1
			else:
				strTempY2 = strTempY1
			f += 1
	
		g = 0
		while g < (strSetCount):
			strTempS1b = shpS1b + lstRndIndiv[g]
			strTempS2b = shpS2b + lstRndIndiv[g]
			strTempFo = 'shpFo' + lstRndIndiv[g]
			if scribus.objectExists(strTempS2b) and shpS2b != 'shpKb':
				if scribus.objectExists(strTempS1b) and shpS1b != 'shpKb':
					if strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst) and shpS1b != 'shpKb':
						scribus.setProperty(strTempS2b, "yPos", scribus.getProperty(shpS1b + rndfirst, "yPos") + \
						scribus.getProperty(shpS1b + rndfirst, "height") + strVerticalSpacing)
					else:
						if strSetStack2 == 'Group':
							scribus.setProperty(strTempS2b, "yPos", strTempY1 + strVerticalSpacing)
						else:
							scribus.setProperty(strTempS2b, "yPos", scribus.getProperty(strTempS1b, "yPos") + \
							scribus.getProperty(strTempS1b, "height") + strVerticalSpacing)
					if (scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height") > strTempY2):
						strTempY2 = scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height")
						strTempY3 = strTempY2
						strTempY4 = strTempY2
						strTempY5 = strTempY2
				else:
					if strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst) and shpS1b != 'shpKb':
						scribus.setProperty(strTempS2b, "yPos", strTempY1 + strVerticalSpacing)
					else:
						if strSetStack2 == 'Group':
							scribus.setProperty(strTempS2b, "yPos", strFoBottom + strMarginBottom)
						else:
							scribus.setProperty(strTempS2b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
							scribus.getProperty(strTempFo, "height") + strMarginBottom)
					if scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height") > strTempY2:
						strTempY2 = scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height")
						strTempY3 = strTempY2
						strTempY4 = strTempY2
						strTempY5 = strTempY2
			else:
				strTempY3 = strTempY2
			g += 1

		h = 0
		while h < (strSetCount):
			strTempFo = 'shpFo' + lstRndIndiv[h]
			strTempS1b = shpS1b + lstRndIndiv[h]
			strTempS2b = shpS2b + lstRndIndiv[h]
			strTempS3b = shpS3b + lstRndIndiv[h]
			if scribus.objectExists(strTempS3b) and shpS3b != 'shpKb':
				if scribus.objectExists(strTempS2b) and shpS2b != 'shpKb':
					if strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst) and shpS2b != 'shpKb' :
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					else:
						if strSetStack3 == 'Group':
							scribus.setProperty(strTempS3b, "yPos", strTempY2 + strVerticalSpacing)
						else:
							scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempS2b, "yPos") + \
							scribus.getProperty(strTempS2b, "height") + strVerticalSpacing)
					if (scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height") > strTempY3):
						strTempY3 = scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height")
				elif scribus.objectExists(strTempS1b) and shpS1b != 'shpKb':
					if strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst) and shpS2b != 'shpKb':
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst) and shpS1b != 'shpKb':
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(shpS1b + rndfirst, "yPos") + \
						scribus.getProperty(shpS1b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack3 == 'Group':
						scribus.setProperty(strTempS3b, "yPos", strTempY1 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempS1b, "yPos") + \
						scribus.getProperty(strTempS1b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height") > strTempY3:
						strTempY3 = scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height")
				elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst) and shpS2b != 'shpKb':
					scribus.setProperty(strTempS3b, "yPos", strTempY2 + strVerticalSpacing)
				elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst) and shpS1b != 'shpKb':
					scribus.setProperty(strTempS3b, "yPos", strTempY1 + strVerticalSpacing)
				elif strSetStack3 == 'Group':
					scribus.setProperty(strTempS3b, "yPos", strFoBottom + strMarginBottom)
				else:
					scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					scribus.getProperty(strTempFo, "height") + strMarginBottom)
				if scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height") > strTempY3:
					strTempY3 = scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height")
					strTempY4 = strTempY3
					strTempY5 = strTempY3
			h += 1

		q = 0
		while q < (strSetCount):
			strTempFo = 'shpFo' + lstRndIndiv[q]
			strTempS1b = shpS1b + lstRndIndiv[q]
			strTempS2b = shpS2b + lstRndIndiv[q]
			strTempS3b = shpS3b + lstRndIndiv[q]
			strTempS4b = shpS4b + lstRndIndiv[q]
			if scribus.objectExists(strTempS4b) and shpS4b != 'shpKb':
				if scribus.objectExists(strTempS3b) and shpS3b != 'shpKb':
					if strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst) and shpS3b != 'shpKb':
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					else:
						if strSetStack4 == 'Group':
							scribus.setProperty(strTempS4b, "yPos", strTempY3 + strVerticalSpacing)
						else:
							scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempS3b, "yPos") + \
							scribus.getProperty(strTempS3b, "height") + strVerticalSpacing)
					if (scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height") > strTempY4):
						strTempY4 = scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")
				elif scribus.objectExists(strTempS2b) and shpS2b != 'shpKb':
					if strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst) and shpS3b != 'shpKb':
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst) and shpS2b != 'shpKb':
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst) and shpS1b != 'shpKb':
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS1b + rndfirst, "yPos") + \
						scribus.getProperty(shpS1b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack4 == 'Group':
						scribus.setProperty(strTempS4b, "yPos", strTempY2 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempS2b, "yPos") + \
						scribus.getProperty(strTempS2b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height") > strTempY4:
						strTempY4 = scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")
				elif scribus.objectExists(strTempS1b) and shpS1b != 'shpKb':
					if strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst) and shpS3b != 'shpKb':
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					if strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst) and shpS2b != 'shpKb':
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst) and shpS1b != 'shpKb':
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(shpS1b + rndfirst, "yPos") + \
						scribus.getProperty(shpS1b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack4 == 'Group':
						scribus.setProperty(strTempS4b, "yPos", strTempY1 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempS1b, "yPos") + \
						scribus.getProperty(strTempS1b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height") > strTempY4:
						strTempY4 = scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")
				elif strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst) and shpS3b != 'shpKb':
					scribus.setProperty(strTempS4b, "yPos", strTempY3 + strVerticalSpacing)
				elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst) and shpS2b != 'shpKb':
					scribus.setProperty(strTempS4b, "yPos", strTempY2 + strVerticalSpacing)
				elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst) and shpS1b != 'shpKb':
					scribus.setProperty(strTempS4b, "yPos", strTempY1 + strVerticalSpacing)
				elif strSetStack4 == 'Group':
					scribus.setProperty(strTempS4b, "yPos", strFoBottom + strMarginBottom)
				else:
					scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					scribus.getProperty(strTempFo, "height") + strMarginBottom)
				if scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height") > strTempY4:
					strTempY4 = scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")
					strTempY5 = strTempY4
			q += 1

		j = 0
		while j < (strSetCount):
			strTempFo = 'shpFo' + lstRndIndiv[j]
			strTempS1b = shpS1b + lstRndIndiv[j]
			strTempS2b = shpS2b + lstRndIndiv[j]
			strTempS3b = shpS3b + lstRndIndiv[j]
			strTempS4b = shpS4b + lstRndIndiv[j]
			strTempS5b = shpS5b + lstRndIndiv[j]
			if scribus.objectExists(strTempS5b):
				if scribus.objectExists(strTempS4b):
					if strSetStack4 == 'Group' and scribus.objectExists(shpS4b + rndfirst) and shpS4b != 'shpKb':
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS4b + rndfirst, "yPos") + \
						scribus.getProperty(shpS4b + rndfirst, "height") + strVerticalSpacing)
					else:
						if strSetStack5 == 'Group':
							scribus.setProperty(strTempS5b, "yPos", strTempY4 + strVerticalSpacing)
						else:
							scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(strTempS4b, "yPos") + \
							scribus.getProperty(strTempS4b, "height") + strVerticalSpacing)
					if (scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5):
						strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
				elif scribus.objectExists(strTempS3b) and shpS3b != 'shpKb':
					if strSetStack4 == 'Group' and scribus.objectExists(shpS4b + rndfirst) and shpS4b != 'shpKb':
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS4b + rndfirst, "yPos") + \
						scribus.getProperty(shpS4b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst) and shpS3b != 'shpKb':
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack5 == 'Group':
						scribus.setProperty(strTempS5b, "yPos", strTempY2 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(strTempS2b, "yPos") + \
						scribus.getProperty(strTempS2b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5:
						strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
				elif scribus.objectExists(strTempS2b) and shpS2b != 'shpKb':
					if strSetStack4 == 'Group' and scribus.objectExists(shpS4b + rndfirst) and shpS4b != 'shpKb':
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS4b + rndfirst, "yPos") + \
						scribus.getProperty(shpS4b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst) and shpS3b != 'shpKb':
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst) and shpS2b != 'shpKb':
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack5 == 'Group':
						scribus.setProperty(strTempS5b, "yPos", strTempY2 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(strTempS2b, "yPos") + \
						scribus.getProperty(strTempS2b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5:
						strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
				elif scribus.objectExists(strTempS1b) and shpS1b != 'shpKb':
					if strSetStack4 == 'Group' and scribus.objectExists(shpS4b + rndfirst) and shpS4b != 'shpKb':
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS4b + rndfirst, "yPos") + \
						scribus.getProperty(shpS4b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst) and shpS3b != 'shpKb':
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS3b + rndfirst, "yPos") + \
						scribus.getProperty(shpS3b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst) and shpS2b != 'shpKb':
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS2b + rndfirst, "yPos") + \
						scribus.getProperty(shpS2b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst) and shpS1b != 'shpKb':
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(shpS1b + rndfirst, "yPos") + \
						scribus.getProperty(shpS1b + rndfirst, "height") + strVerticalSpacing)
					elif strSetStack5 == 'Group':
						scribus.setProperty(strTempS5b, "yPos", strTempY1 + strVerticalSpacing)
					else:
						scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(strTempS1b, "yPos") + \
						scribus.getProperty(strTempS1b, "height") + strVerticalSpacing)
					if scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5:
						strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
				elif strSetStack4 == 'Group' and scribus.objectExists(shpS4b + rndfirst) and shpS4b != 'shpKb':
					scribus.setProperty(strTempS5b, "yPos", strTempY4 + strVerticalSpacing)
				elif strSetStack3 == 'Group' and scribus.objectExists(shpS3b + rndfirst) and shpS3b != 'shpKb':
					scribus.setProperty(strTempS5b, "yPos", strTempY3 + strVerticalSpacing)
				elif strSetStack2 == 'Group' and scribus.objectExists(shpS2b + rndfirst) and shpS2b != 'shpKb':
					scribus.setProperty(strTempS5b, "yPos", strTempY2 + strVerticalSpacing)
				elif strSetStack1 == 'Group' and scribus.objectExists(shpS1b + rndfirst) and shpS1b != 'shpKb':
					scribus.setProperty(strTempS5b, "yPos", strTempY1 + strVerticalSpacing)
				elif strSetStack5 == 'Group':
					scribus.setProperty(strTempS5b, "yPos", strFoBottom + strMarginBottom)
				else:
					scribus.setProperty(strTempS5b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					 scribus.getProperty(strTempFo, "height") + strMarginBottom)
				if scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5:
					strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
			j += 1
		z = 0
		while z < (strSetCount):
			strTempFo = 'shpFo' + lstRndIndiv[z]
			strTempKb = 'shpKb' + lstRndIndiv[z]
			if scribus.objectExists(strTempKb):
				scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
				strFrameOffset + strPaddingTop + lstPhotoH[z] + strOISpacing)
				z += 1
			
def funcTopPlacementYFrameIndivTextGrpAlign():
	global strTempY1
	global strTempY2
	global strTempY3
	global strTempY4
	global strTempY5
	
	strFoTop = printAreaHeight
	e = 0
	while e < strSetCount:
		if scribus.objectExists('shpFo' + lstRndIndiv[e]):
			if (scribus.getProperty('shpFo' + lstRndIndiv[e], "yPos") < strFoTop):
				strFoTop = scribus.getProperty('shpFo' + lstRndIndiv[e], "yPos")
		e += 1

	strTempY5 = strFoTop
	strTempY4 = strFoTop
	strTempY3 = strFoTop
	strTempY2 = strFoTop
	strTempY1 = strFoTop
	
	f = 0
	while f < (strSetCount):
		strTempS5t = shpS5t + lstRndIndiv[f]
		if scribus.objectExists(strTempS5t):
			scribus.setProperty(strTempS5t, "yPos", strTempY5 - strMarginTop - scribus.getProperty(strTempS5t, "height"))
			if (scribus.getProperty(strTempS5t, "yPos") < strTempY5):
				strTempY5 = scribus.getProperty(strTempS5t, "yPos")
		f += 1

	q = 0
	while q < (strSetCount):
		strTempS4t = shpS4t + lstRndIndiv[q]
		if scribus.objectExists(strTempS4t):
			scribus.setProperty(strTempS4t, "yPos", strTempY5 - strVerticalSpacing - scribus.getProperty(strTempS4t, "height"))
			if (scribus.getProperty(strTempS4t, "yPos") < strTempY4):
				strTempY4 = scribus.getProperty(strTempS4t, "yPos")
		q += 1
	
	g = 0
	while g < (strSetCount):
		strTempS3t = shpS3t + lstRndIndiv[g]
		if scribus.objectExists(strTempS3t):
			scribus.setProperty(strTempS3t, "yPos", strTempY4 - strVerticalSpacing - scribus.getProperty(strTempS3t, "height"))
			if (scribus.getProperty(strTempS3t, "yPos") < strTempY3):
				strTempY3 = scribus.getProperty(strTempS3t, "yPos")
		g += 1

	h = 0
	while h < (strSetCount):
		strTempS2t = shpS2t + lstRndIndiv[h]
		if scribus.objectExists(strTempS2t):
			scribus.setProperty(strTempS2t, "yPos", strTempY3 - strVerticalSpacing - scribus.getProperty(strTempS2t, "height"))
			if (scribus.getProperty(strTempS2t, "yPos") < strTempY2):
				strTempY2 = scribus.getProperty(strTempS2t, "yPos")
		h += 1

	j = 0
	while j < (strSetCount):
		strTempS1t = shpS1t + lstRndIndiv[j]
		if scribus.objectExists(strTempS1t):
			scribus.setProperty(strTempS1t, "yPos", strTempY2 - strVerticalSpacing - scribus.getProperty(strTempS1t, "height"))
			if (scribus.getProperty(strTempS1t, "yPos") < strTempY1):
				strTempY1 = scribus.getProperty(strTempS1t, "yPos")
		j += 1

def funcBottomPlacementYFrameIndivTextGrpAlign():
	global strTempY5
	global strTempY4
	global strTempY3
	global strTempY2
	global strTempY1
	
	strFoBottom = 0
	e = 0
	while e < strSetCount:
		if scribus.objectExists('shpFo' + lstRndIndiv[e]):
			if scribus.getProperty('shpFo' + lstRndIndiv[e], "yPos") + scribus.getProperty('shpFo' + lstRndIndiv[e], "height") > strFoBottom:
				strFoBottom = scribus.getProperty('shpFo' + lstRndIndiv[e], "yPos") + scribus.getProperty('shpFo' + lstRndIndiv[e], "height")
		e += 1

	strTempY1 = strFoBottom
	strTempY2 = strFoBottom
	strTempY3 = strFoBottom
	strTempY4 = strFoBottom
	strTempY5 = strFoBottom
	

	if strStyle == 'Outside':
		f = 0
		while f < (strSetCount):
			strTempS1b = shpS1b + lstRndIndiv[f]
			if scribus.objectExists(strTempS1b):
				scribus.setProperty(strTempS1b, "yPos", strFoBottom + strMarginBottom)
				if scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height") > strTempY1:
					strTempY1 = scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height")
			f += 1

		g = 0
		while g < (strSetCount):
			strTempS2b = shpS2b + lstRndIndiv[g]
			if scribus.objectExists(strTempS2b):
				scribus.setProperty(strTempS2b, "yPos", strTempY1 + strVerticalSpacing)
				if (scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height") > strTempY2):
					strTempY2 = scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height")
			g += 1

		h = 0
		while h < (strSetCount):
			strTempS3b = shpS3b + lstRndIndiv[h]
			strTempFo = 'shpFo' + lstRndIndiv[h]
			if scribus.objectExists(strTempS3b):
				if strStyle == 'Inside - Catalog':
					if strSetOrientation == 'Horizontal':
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
						scribus.getProperty(strTempFo, "height") / 2 - scribus.getProperty(strTempS3b, "height") / 2)
					elif strSetOrientation == 'Vertical':
						if strSetStack3 == 'Individual':
							scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempFo, "yPos") + (lstStampH[h] / 2) - \
							(scribus.getProperty(strTempS3b, "height") / 2))
						else:
							scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
							(strFrameOuterHeight / 2) - (scribus.getProperty(strTempS3b, "height") / 2))
					elif strFrameStyle == 'Internal':
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempFo, "yPos") - \
						(((scribus.getProperty(strTempFo, "height") * 100/90) - scribus.getProperty(strTempFo, "height")) / 2) + \
						(lstStampH[h] / 2) - (scribus.getProperty(strTempS3b, "height") / 2))
				elif strStyle == 'Outside/Inside':
					if strSetOrientation == 'Horizontal':
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
						strFrameOffset + strPaddingTop + lstPhotoH[h] + strOISpacing)
					elif strSetOrientation == 'Vertical' and strSetStack3 == 'Individual':
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
						strFrameOffset + strPaddingTop + lstPhotoH[h] + strOISpacing)
					elif strSetOrientation == 'Vertical' and strSetStack3 == 'Group':
						scribus.setProperty(strTempS3b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
						strFrameOffset + strPaddingTop + strSetTotH + (strVerticalSpacing * (strSetCount - 1)) + strOISpacing)
					strTempY3 = strTempY2
				else:
					scribus.setProperty(strTempS3b, "yPos", strTempY2 + strVerticalSpacing)
					if ((scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height")) > strTempY3):
						strTempY3 = (scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height"))
			h += 1

		q = 0
		while q < (strSetCount):
			strTempS4b = shpS4b + lstRndIndiv[q]
			strTempFo = 'shpFo' + lstRndIndiv[q]
			if scribus.objectExists(strTempS4b):
				if strStyle == 'Inside - Face Value':
					if strSetOrientation == 'Horizontal':
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
						scribus.getProperty(strTempFo, "height") / 2 - scribus.getProperty(strTempS4b, "height") / 2)
					elif strSetOrientation == 'Vertical':
						if strSetStack4 == 'Individual':
							scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempFo, "yPos") + (lstStampH[h] / 2) - \
							(scribus.getProperty(strTempS4b, "height") / 2))
						else:
							scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempFo, "yPos") + \
							(strFrameOuterHeight / 2) - (scribus.getProperty(strTempS4b, "height") / 2))
					elif strFrameStyle == 'Internal':
						scribus.setProperty(strTempS4b, "yPos", scribus.getProperty(strTempFo, "yPos") - \
						(((scribus.getProperty(strTempFo, "height") * 100/90) - scribus.getProperty(strTempFo, "height")) / 2) + \
						(lstStampH[h] / 2) - (scribus.getProperty(strTempS4b, "height") / 2))
				else:
					scribus.setProperty(strTempS4b, "yPos", strTempY3 + strVerticalSpacing)
					if ((scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")) > strTempY4):
						strTempY4 = (scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height"))
			q += 1

		j = 0
		while j < (strSetCount):
			strTempS5b = shpS5b + lstRndIndiv[j]
			if scribus.objectExists(strTempS5b):
				scribus.setProperty(strTempS5b, "yPos", strTempY4 + strVerticalSpacing)
				if (scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5):
					strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
			j += 1
	elif strStyle == 'Inside - Catalog':
		v = 0
		while v < strSetCount:
			strTempFo = 'shpFo' + lstRndIndiv[v]
			strTempKb = 'shpKb' + lstRndIndiv[v]
			if strSetOrientation == 'Horizontal':
				scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
				scribus.getProperty(strTempFo, "height") / 2 - scribus.getProperty(strTempKb, "height") / 2)
			elif strSetOrientation == 'Vertical':
				if strSetKatalog == 'Individual':
					scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") + (lstStampH[v] / 2) - \
					(scribus.getProperty(strTempKb, "height") / 2))
				else:
					scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					(strFrameOuterHeight / 2) - (scribus.getProperty(strTempKb, "height") / 2))
			elif strFrameStyle == 'Internal':
				scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") - \
				(((scribus.getProperty(strTempFo, "height") * 100/90) - scribus.getProperty(strTempFo, "height")) / 2) + \
				(lstStampH[v] / 2) - (scribus.getProperty(strTempKb, "height") / 2))
			v += 1
	elif strStyle == 'Inside - Face Value':
		v = 0
		while v < strSetCount:
			strTempFo = 'shpFo' + lstRndIndiv[v]
			strTempFb = 'shpFb' + lstRndIndiv[v]
			if strSetOrientation == 'Horizontal':
				scribus.setProperty(strTempFb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
				scribus.getProperty(strTempFo, "height") / 2 - scribus.getProperty(strTempFb, "height") / 2)
			elif strSetOrientation == 'Vertical':
				if strSetFace == 'Individual':
					scribus.setProperty(strTempFb, "yPos", scribus.getProperty(strTempFo, "yPos") + (lstStampH[v] / 2) - \
					(scribus.getProperty(strTempFb, "height") / 2))
				else:
					scribus.setProperty(strTempFb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					(strFrameOuterHeight / 2) - (scribus.getProperty(strTempFb, "height") / 2))
			elif strFrameStyle == 'Internal':
				scribus.setProperty(strTempFb, "yPos", scribus.getProperty(strTempFo, "yPos") - \
				(((scribus.getProperty(strTempFo, "height") * 100/90) - scribus.getProperty(strTempFo, "height")) / 2) + \
				(lstStampH[v] / 2) - (scribus.getProperty(strTempFb, "height") / 2))
			v += 1
	elif strStyle == 'Outside/Inside':
		f = 0
		while f < (strSetCount):
			strTempS1b = shpS1b + lstRndIndiv[f]
			if scribus.objectExists(strTempS1b) and shpS1b != 'shpKb':
				scribus.setProperty(strTempS1b, "yPos", strFoBottom + strMarginBottom)
				if scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height") > strTempY1:
					strTempY1 = scribus.getProperty(strTempS1b, "yPos") + scribus.getProperty(strTempS1b, "height")
			f += 1

		g = 0
		while g < (strSetCount):
			strTempS2b = shpS2b + lstRndIndiv[g]
			if scribus.objectExists(strTempS2b) and shpS2b != 'shpKb':
				scribus.setProperty(strTempS2b, "yPos", strTempY1 + strVerticalSpacing)
				if (scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height") > strTempY2):
					strTempY2 = scribus.getProperty(strTempS2b, "yPos") + scribus.getProperty(strTempS2b, "height")
			else:
				strTempY2 = strTempY1
			g += 1

		h = 0
		while h < (strSetCount):
			strTempS3b = shpS3b + lstRndIndiv[h]
			if scribus.objectExists(strTempS3b) and shpS3b != 'shpKb':
				scribus.setProperty(strTempS3b, "yPos", strTempY2 + strVerticalSpacing)
				if ((scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height")) > strTempY3):
					strTempY3 = (scribus.getProperty(strTempS3b, "yPos") + scribus.getProperty(strTempS3b, "height"))
			else:
				strTempY3 = strTempY2
			h += 1

		q = 0
		while q < (strSetCount):
			strTempS4b = shpS4b + lstRndIndiv[q]
			if scribus.objectExists(strTempS4b) and shpS4b != 'shpKb':
				scribus.setProperty(strTempS4b, "yPos", strTempY3 + strVerticalSpacing)
				if ((scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height")) > strTempY4):
					strTempY4 = (scribus.getProperty(strTempS4b, "yPos") + scribus.getProperty(strTempS4b, "height"))
			else:
				strTempY4 = strTempY3
			q += 1

		j = 0
		while j < (strSetCount):
			strTempS5b = shpS5b + lstRndIndiv[j]
			if scribus.objectExists(strTempS5b) and shpS5b != 'shpKb':
				scribus.setProperty(strTempS5b, "yPos", strTempY4 + strVerticalSpacing)
				if (scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height") > strTempY5):
					strTempY5 = scribus.getProperty(strTempS5b, "yPos") + scribus.getProperty(strTempS5b, "height")
			j += 1
		
		z = 0
		while z < strSetCount:
			strTempFo = 'shpFo' + lstRndIndiv[z]
			strTempKb = 'shpKb' + lstRndIndiv[z]
			if scribus.objectExists(strTempKb):
				if strSetOrientation == 'Horizontal':
					scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					strFrameOffset + strPaddingTop + lstPhotoH[z] + strOISpacing)
				elif strSetOrientation == 'Vertical' and strSetKatalog == 'Individual':
					scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					strFrameOffset + strPaddingTop + lstPhotoH[z] + strOISpacing)
				elif strSetOrientation == 'Vertical' and strSetKatalog == 'Group':
					scribus.setProperty(strTempKb, "yPos", scribus.getProperty(strTempFo, "yPos") + \
					strFrameOffset + strPaddingTop + strSetTotH + (strVerticalSpacing * (strSetCount - 1)) + strOISpacing)
			z += 1

	if strSingleSet == 'Set - Multi-Row/Column' and strSetOrientation == 'Horizontal':
		global strSetMultiBottom
		if strStyle == 'Outside':
			if scribus.objectExists(strTempS5b):
				strSetMultiBottom = scribus.getProperty(strTempS5b, "yPos") + int(strSetMultiSpacing)
			elif scribus.objectExists(strTempS4b):
				strSetMultiBottom = scribus.getProperty(strTempS4b, "yPos") + int(strSetMultiSpacing)
			elif scribus.objectExists(strTempS3b):
				strSetMultiBottom = scribus.getProperty(strTempS3b, "yPos") + int(strSetMultiSpacing)
			elif scribus.objectExists(strTempS2b):
				strSetMultiBottom = scribus.getProperty(strTempS2b, "yPos") + int(strSetMultiSpacing)
			elif scribus.objectExists(strTempS1b):
				strSetMultiBottom = scribus.getProperty(strTempS1b, "yPos") + int(strSetMultiSpacing)
			else:
				strSetMultiBottom = strFoBottom + int(strSetMultiSpacing)
		elif strStyle == 'Inside - Catalog' or strStyle == 'Inside - Face Value':
			strSetMultiBottom = strFoBottom + int(strSetMultiSpacing)
		elif strStyle == 'Outside/Inside':
			if scribus.objectExists(strTempS5b) and shpS5b != 'shpKb':
				strSetMultiBottom = scribus.getProperty(strTempS5b, "yPos") + int(strSetMultiSpacing)
			elif scribus.objectExists(strTempS4b) and shpS4b != 'shpKb':
				strSetMultiBottom = scribus.getProperty(strTempS4b, "yPos") + int(strSetMultiSpacing)
			elif scribus.objectExists(strTempS3b) and shpS3b != 'shpKb':
				strSetMultiBottom = scribus.getProperty(strTempS3b, "yPos") + int(strSetMultiSpacing)
			elif scribus.objectExists(strTempS2b) and shpS2b != 'shpKb':
				strSetMultiBottom = scribus.getProperty(strTempS2b, "yPos") + int(strSetMultiSpacing)
			elif scribus.objectExists(strTempS1b) and shpS1b != 'shpKb':
				strSetMultiBottom = scribus.getProperty(strTempS1b, "yPos") + int(strSetMultiSpacing)
			else:
				strSetMultiBottom = strFoBottom + int(strSetMultiSpacing)
				
def funcRightPlacementYFrameIndivText():
	x = 0
	while x < strSetCount:
		strTempFo = 'shpFo' + lstRndIndiv[x]
		strTempS1r = shpS1r + lstRndIndiv[x]
		strTempS2r = shpS2r + lstRndIndiv[x]
		strTempS3r = shpS3r + lstRndIndiv[x]
		strTempS4r = shpS4r + lstRndIndiv[x]
		strTempS5r = shpS5r + lstRndIndiv[x]

		strFrameOuterHeight = lstStampH[x] + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
		strVertOffset = (strFrameOuterHeight - lstRightOverallHeight[x]) / 2
		strTempY = scribus.getProperty(strTempFo, "yPos") + strVertOffset
		if scribus.objectExists(strTempS1r):
			scribus.setProperty(strTempS1r, "yPos", strTempY)
			strTempY = scribus.getProperty(strTempS1r, "yPos") + scribus.getProperty(strTempS1r, "height") + strVerticalSpacing
		if scribus.objectExists(strTempS2r):
			scribus.setProperty(strTempS2r, "yPos", strTempY)
			strTempY = scribus.getProperty(strTempS2r, "yPos") + scribus.getProperty(strTempS2r, "height") + strVerticalSpacing
		if scribus.objectExists(strTempS3r):
			scribus.setProperty(strTempS3r, "yPos", strTempY)
			strTempY = scribus.getProperty(strTempS3r, "yPos") + scribus.getProperty(strTempS3r, "height") + strVerticalSpacing
		if scribus.objectExists(strTempS4r):
			scribus.setProperty(strTempS4r, "yPos", strTempY)
			strTempY = scribus.getProperty(strTempS4r, "yPos") + scribus.getProperty(strTempS4r, "height") + strVerticalSpacing
		if scribus.objectExists(strTempS5r):
			scribus.setProperty(strTempS5r, "yPos", strTempY)
		x += 1

def funcLeftPlacementYFrameIndivText():
	x = 0
	while x < strSetCount:
		strTempFo = 'shpFo' + lstRndIndiv[x]
		strTempS1l = shpS1l + lstRndIndiv[x]
		strTempS2l = shpS2l + lstRndIndiv[x]
		strTempS3l = shpS3l + lstRndIndiv[x]
		strTempS4l = shpS4l + lstRndIndiv[x]
		strTempS5l = shpS5l + lstRndIndiv[x]

		strFrameOuterHeight = lstStampH[x] + strPaddingTop + strPaddingBottom + (strFrameOffset * 2)
		strVertOffset = (strFrameOuterHeight - lstLeftOverallHeight[x]) / 2
		strTempY = scribus.getProperty(strTempFo, "yPos") + strVertOffset
		if scribus.objectExists(strTempS1l):
			scribus.setProperty(strTempS1l, "yPos", strTempY)
			strTempY = scribus.getProperty(strTempS1l, "yPos") + scribus.getProperty(strTempS1l, "height") + strVerticalSpacing
		if scribus.objectExists(strTempS2l):
			scribus.setProperty(strTempS2l, "yPos", strTempY)
			strTempY = scribus.getProperty(strTempS2l, "yPos") + scribus.getProperty(strTempS2l, "height") + strVerticalSpacing
		if scribus.objectExists(strTempS3l):
			scribus.setProperty(strTempS3l, "yPos", strTempY)
			strTempY = scribus.getProperty(strTempS3l, "yPos") + scribus.getProperty(strTempS3l, "height") + strVerticalSpacing
		if scribus.objectExists(strTempS4l):
			scribus.setProperty(strTempS4l, "yPos", strTempY)
			strTempY = scribus.getProperty(strTempS4l, "yPos") + scribus.getProperty(strTempS4l, "height") + strVerticalSpacing
		if scribus.objectExists(strTempS5l):
			scribus.setProperty(strTempS5l, "yPos", strTempY)
		x += 1

def funcCenterMiddlesFrameIndiv():
	'''For text boxes on Left and Right, center them vertically on the frame'''
	intLe = len(lstLeftShp)
	intLeG = len(lstLeftShpG)
	global strLeftOverallHeight
	global strLeftOverallHeightG
	
	global lstLeftOverallHeight
	lstLeftOverallHeight = []
	global lstLeftOverallHeightG
	lstLeftOverallHeightG = []
	
	intRe = len(lstRightShp)
	intReG = len(lstRightShpG)
	global strRightOverallHeight
	global strRightOverallHeightG
	
	global lstRightOverallHeight
	lstRightOverallHeight = []
	global lstRightOverallHeightG
	lstRightOverallHeightG = []
	
	z = 0
	while z < strSetCount:
		strTempS1r = shpS1r + lstRndIndiv[z]
		strTempS2r = shpS2r + lstRndIndiv[z]
		strTempS3r = shpS3r + lstRndIndiv[z]
		strTempS4r = shpS4r + lstRndIndiv[z]
		strTempS5r = shpS5r + lstRndIndiv[z]
		strTempS1l = shpS1l + lstRndIndiv[z]
		strTempS2l = shpS2l + lstRndIndiv[z]
		strTempS3l = shpS3l + lstRndIndiv[z]
		strTempS4l = shpS4l + lstRndIndiv[z]
		strTempS5l = shpS5l + lstRndIndiv[z]
		
		Bh = 0
		BhG = 0
		Bk = 0
		BkG = 0
		intShpCountIL = 0
		intShpCountIR = 0
		intShpCountGL = 0
		intShpCountGR = 0

		if scribus.objectExists(strTempS1l):
			if strSetStack1 == 'Group':
				intKG = scribus.getProperty(strTempS1l, "height")
				BhG = BhG + intKG
				intShpCountGL = intShpCountGL + 1
			else:
				intK = scribus.getProperty(strTempS1l, "height")
				Bh = Bh + intK
				intShpCountIL = intShpCountIL + 1
		if scribus.objectExists(strTempS2l):
			if strSetStack2 == 'Group':
				intKG = scribus.getProperty(strTempS2l, "height")
				BhG = BhG + intKG
				intShpCountGL = intShpCountGL + 1
			else:
				intK = scribus.getProperty(strTempS2l, "height")
				Bh = Bh + intK
				intShpCountIL = intShpCountIL + 1
		if scribus.objectExists(strTempS3l):
			if strSetStack3 == 'Group':
				intKG = scribus.getProperty(strTempS3l, "height")
				BhG = BhG + intKG
				intShpCountGL = intShpCountGL + 1
			else:
				intK = scribus.getProperty(strTempS3l, "height")
				Bh = Bh + intK
				intShpCountIL = intShpCountIL + 1
		if scribus.objectExists(strTempS4l):
			if strSetStack4 == 'Group':
				intKG = scribus.getProperty(strTempS4l, "height")
				BhG = BhG + intKG
				intShpCountGL = intShpCountGL + 1
			else:
				intK = scribus.getProperty(strTempS4l, "height")
				Bh = Bh + intK
				intShpCountIL = intShpCountIL + 1
		if scribus.objectExists(strTempS5l):
			if strSetStack5 == 'Group':
				intKG = scribus.getProperty(strTempS5l, "height")
				BhG = BhG + intKG
				intShpCountGL = intShpCountGL + 1
			else:
				intK = scribus.getProperty(strTempS5l, "height")
				Bh = Bh + intK
				intShpCountIL = intShpCountIL + 1

		strLeftOverallHeight = Bh + ((intShpCountIL - 1) * strVerticalSpacing)
		lstLeftOverallHeight.append(strLeftOverallHeight)
		strLeftOverallHeightG = BhG + ((intShpCountGL - 1) * strVerticalSpacing)
		lstLeftOverallHeightG.append(strLeftOverallHeightG)

		if scribus.objectExists(strTempS1r):
			if strSetStack1 == 'Group':
				intKG = scribus.getProperty(strTempS1r, "height")
				BkG = BkG + intKG
				intShpCountGR = intShpCountGR + 1
			else:
				intK = scribus.getProperty(strTempS1r, "height")
				Bk = Bk + intK
				intShpCountIR = intShpCountIR + 1
		if scribus.objectExists(strTempS2r):
			if strSetStack2 == 'Group':
				intKG = scribus.getProperty(strTempS2r, "height")
				BkG = BkG + intKG
				intShpCountGR = intShpCountGR + 1
			else:
				intK = scribus.getProperty(strTempS2r, "height")
				Bk = Bk + intK
				intShpCountIR = intShpCountIR + 1
		if scribus.objectExists(strTempS3r):
			if strSetStack3 == 'Group':
				intKG = scribus.getProperty(strTempS3r, "height")
				BkG = BkG + intKG
				intShpCountGR = intShpCountGR + 1
			else:
				intK = scribus.getProperty(strTempS3r, "height")
				Bk = Bk + intK
				intShpCountIR = intShpCountIR + 1
		if scribus.objectExists(strTempS4r):
			if strSetStack4 == 'Group':
				intKG = scribus.getProperty(strTempS4r, "height")
				BkG = BkG + intKG
				intShpCountGR = intShpCountGR + 1
			else:
				intK = scribus.getProperty(strTempS4r, "height")
				Bk = Bk + intK
				intShpCountIR = intShpCountIR + 1
		if scribus.objectExists(strTempS5r):
			if strSetStack5 == 'Group':
				intKG = scribus.getProperty(strTempS5r, "height")
				BkG = BkG + intKG
				intShpCountGR = intShpCountGR + 1
			else:
				intK = scribus.getProperty(strTempS5r, "height")
				Bk = Bk + intK
				intShpCountIR = intShpCountIR + 1

		strRightOverallHeight = Bk + ((intShpCountIR - 1) * strVerticalSpacing)
		lstRightOverallHeight.append(strRightOverallHeight)
		strRightOverallHeightG = BkG + ((intShpCountGR - 1) * strVerticalSpacing)
		lstRightOverallHeightG.append(strRightOverallHeightG)

		z += 1

def funcGroupAndAlign():
	'''Group all generated objects'''
	lstObjects = []
	lstObjects.extend(lstFo)
	lstObjects.extend(lstFi)
	lstObjects.extend(lstP)
	lstObjects.extend(lstTopShp)
	lstObjects.extend(lstBottomShp)
	lstObjects.extend(lstRightShp)
	lstObjects.extend(lstLeftShp)

	if strSingleSet != 'Single':
		lstObjects.extend(lstPS)
		lstObjects.extend(lstTS)
		lstObjects.extend(lstDS)
		lstObjects.extend(lstKS)
		lstObjects.extend(lstFS)
		lstObjects.extend(lstCS)
		lstObjects.extend(lstFoS)
		lstObjects.extend(lstFiS)

	if len(lstObjects) > 1:
		global rndg
		rndg = str(randint(10000,999999999))
		global strGroupName
		strGroupName = scribus.groupObjects(lstObjects)
		'''strGroupName = strGroupName + rndg'''
		lstObjects[:] = []
		lstGroupName.append(strGroupName)

	lstTopShp[:] = []
	lstBottomShp[:] = []
	lstRightShp[:] = []
	lstLeftShp[:] = []

	lstPS[:] = []
	lstTS[:] = []
	lstDS[:] = []
	lstKS[:] = []
	lstFS[:] = []
	lstCS[:] = []
	lstFoS[:] = []
	lstFiS[:] = []

def funcSetMultiYPosition():
	lstMultiGroup = []
	c = 0
	while c <= i3:
		if strSetOrientation == 'Horizontal':
			strSetGroupTop = scribus.getProperty(lstGroupName[c], "yPos")
			strSetGroupBottom = scribus.getProperty(lstGroupName[c], "yPos") + scribus.getProperty(lstGroupName[c], "height")
			strSetMultiTop = strSetGroupBottom + int(strSetMultiSpacing)
			lstMultiGroup.append(lstGroupName[c])
			if c < i3:
				scribus.setProperty(lstGroupName[c+1], "yPos", strSetMultiTop)
			
			'''if strStyle == 'Outside':
				if scribus.objectExists(strTempS5b):
					strSetMultiBottom = scribus.getProperty(strTempS5b, "yPos") + int(strSetMultiSpacing)
				elif scribus.objectExists(strTempS4b):
					strSetMultiBottom = scribus.getProperty(strTempS4b, "yPos") + int(strSetMultiSpacing)
				elif scribus.objectExists(strTempS3b):
					strSetMultiBottom = scribus.getProperty(strTempS3b, "yPos") + int(strSetMultiSpacing)
				elif scribus.objectExists(strTempS2b):
					strSetMultiBottom = scribus.getProperty(strTempS2b, "yPos") + int(strSetMultiSpacing)
				elif scribus.objectExists(strTempS1b):
					strSetMultiBottom = scribus.getProperty(strTempS1b, "yPos") + int(strSetMultiSpacing)
				else:
					strSetMultiBottom = strFoBottom + int(strSetMultiSpacing)
			elif strStyle == 'Inside - Catalog' or strStyle == 'Inside - Face Value':
				strSetMultiTop = strSetGroupBottom + int(strSetMultiSpacing)
				if c < i3:
					scribus.setProperty(lstGroupName[c+1], "yPos", strSetMultiTop)
			elif strStyle == 'Outside/Inside':
				if scribus.objectExists(strTempS5b) and shpS5b != 'shpKb':
					strSetMultiBottom = scribus.getProperty(strTempS5b, "yPos") + int(strSetMultiSpacing)
				elif scribus.objectExists(strTempS4b) and shpS4b != 'shpKb':
					strSetMultiBottom = scribus.getProperty(strTempS4b, "yPos") + int(strSetMultiSpacing)
				elif scribus.objectExists(strTempS3b) and shpS3b != 'shpKb':
					strSetMultiBottom = scribus.getProperty(strTempS3b, "yPos") + int(strSetMultiSpacing)
				elif scribus.objectExists(strTempS2b) and shpS2b != 'shpKb':
					strSetMultiBottom = scribus.getProperty(strTempS2b, "yPos") + int(strSetMultiSpacing)
				elif scribus.objectExists(strTempS1b) and shpS1b != 'shpKb':
					strSetMultiBottom = scribus.getProperty(strTempS1b, "yPos") + int(strSetMultiSpacing)
				else:
					strSetMultiBottom = strFoBottom + int(strSetMultiSpacing)'''
		c += 1
	if len(lstMultiGroup) > 1:
		grpMultiGroup = scribus.groupObjects(lstMultiGroup)
		x1, y1 = scribus.getPosition(grpMultiGroup)
		pageWidth, pageHeight = scribus.getPageSize()
		p1 = pageHeight / 2
		h1 = scribus.getProperty(grpMultiGroup, "height")
		d1 = p1-y1
		a1 = d1-(h1/2)
		o1 = pageHeight * (scribus.currentPage() - 1)
		scribus.moveObject(0, a1, grpMultiGroup)
		'''shpTest2b = scribus.createText(100, 100, 50, 15, 'shpTest2b')
		scribus.setText(str(y1), shpTest2b)'''
	lstMultiGroup[:] = []
	
funcImportSettings()